/**
 * Copyright (C) All rights reserved.
 *
 * @Module     ExecuteClient.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    1.0 2012/05/15
 *
 */

import java.lang.*;
import java.lang.reflect.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.util.zip.*;
import java.util.jar.*;

import exec.*;
import server.*;

public class ExecuteClient extends DebugObject {
    private static String EMPTY = "";
    private static String PARENT = "..";
    private static String FILE_NAME_ERROR  = "File not found";
    private static String CLASS_NAME_ERROR = "Class not found";
    private static String JAR_NAME_ERROR = "Jar not found";
    public final static String SUFFIX_SEPARATOR = ".";
    public final static String JAR_SUFFIX = "jar";

    public final static String JAR_URL_HEAD = "jar:file:";
    public final static String JAR_URL_END  = "!/";

    private static String EXECUTE_METHOD_NAME = "exec";

    private static String PARAMETER_ERROR = "Parameter error";

    public String getMessage(String format_key, String message_key, 
        String... arg) {
        return super.getMessage(format_key, message_key, arg);
    }

    public static void main(String[] args) {
        String                target;
        String                message;
        String                method_name;
        String                file_input;
        String                output_file;
        String                parent_file_input;
        ExecuteServer         execute_server;
        byte[]                byte_parameter;
        ByteArrayOutputStream byte_array_output_stream;
        PrintStream           print_stream;
        FileInputStream       file_input_stream;
        FileOutputStream      file_output_stream;
        ExecuteClient         execute_client;
        EncodePrintStream     encode_print_stream;

        if (args.length <= 3) {
            execute_client = new ExecuteClient();
            message = execute_client.getMessage( 
                ARGUMENT_PARAMETER_EXCEPTION,
                ARGUMENT_PARAMETER_EXCEPTION);

            System.err.println( message );
            return;
        }
        execute_server = new ExecuteServer();
        byte_array_output_stream = new ByteArrayOutputStream();
/**
        print_stream = new PrintStream(byte_array_output_stream);
**/
        encode_print_stream = new EncodePrintStream(byte_array_output_stream);

        method_name = args[0];
        target = args[1];
        output_file = args[3];
/**
        file_input = args[2];
        parent_file_input = PARENT + File.separator + file_input;
**/
        parent_file_input = args[2];
        file_input = args[2];
        if (parent_file_input.lastIndexOf(File.separator) >= 0) {
            file_input = parent_file_input.substring(
                parent_file_input.lastIndexOf(File.separator)+1);
        }

        try {
            file_output_stream = new FileOutputStream(output_file);
            file_input_stream = new FileInputStream( parent_file_input ); 
        } catch (Exception exception_object) {
            execute_client = new ExecuteClient();
            message = execute_client.getMessage(
                IO_ERROR_EXCEPTION,
                IO_ERROR_EXCEPTION);
            System.err.println( message );
            exception_object.printStackTrace();
            return;
        }

        for (int i = 4; i < args.length; i++) {
            encode_print_stream.println(args[i]);
/**
            print_stream.println(args[i]);
**/
        }
        byte_parameter = byte_array_output_stream.toByteArray();
        print_stream = new PrintStream(file_output_stream);

        message_resource = new MessageResource();
        try {
            message_resource.setLanguage(Locale.JAPAN.getISO3Language());
        } catch (Exception exception_object) {
            System.err.println( exception_object.getMessage() );
            return ;
        }
        try {
            execute_server.execute(method_name, 
                target, file_input_stream, byte_parameter, print_stream,
                message_resource);
        } catch (Exception exception_object) {
            execute_client = new ExecuteClient();
            message = execute_client.getMessage(
                IO_ERROR_EXCEPTION,
                IO_ERROR_EXCEPTION);
            System.err.println( message );
            exception_object.printStackTrace();
            return;
        }
/**
        try {
            execute_server.removeFile(file_input);
        } catch (Exception exception_object) {
            execute_client = new ExecuteClient();
            message = execute_client.getMessage(
                IO_ERROR_EXCEPTION,
                IO_ERROR_EXCEPTION);
            System.err.println( message );
            exception_object.printStackTrace();
            return;
        }
**/
    }
}

