/**
 * Copyright (C) All rights reserved.
 *
 * @Module     ExecuteFile.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    1.0 2012/05/15
 *
 */

import java.lang.*;
import java.lang.reflect.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.util.zip.*;
import java.util.jar.*;

import exec.*;
import server.*;

public class ExecuteFile extends DebugObject {

    public static void main(String[] args) {
        String          message;
        String          file_input;
        ExecuteFile     execute_file;
        ExecuteServer   execute_server;
        FileInputStream file_input_stream;

        if (args.length != 1) {
            execute_file = new ExecuteFile();
            message = execute_file.getMessage( ARGUMENT_PARAMETER_EXCEPTION,
                ARGUMENT_PARAMETER_EXCEPTION);

            System.err.println( message );
            return;
        }

        execute_server = new ExecuteServer();
        file_input = args[0];

        try {
            file_input_stream = new FileInputStream( file_input ); 
            execute_server.writeFile(file_input_stream, file_input);
        } catch (Exception exception_object) {
            execute_file = new ExecuteFile();
            message = execute_file.getMessage(
                IO_ERROR_EXCEPTION,
                IO_ERROR_EXCEPTION);
            System.err.println( message );
            exception_object.printStackTrace();
            return;
        }
    }
}

