/**
 * Copyright (C)     CounterClient.java
 *
 * @author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @version    2.0 2010/11/04
 *
 * CounterClient Program
 */

import java.lang.*;
import java.io.*;

import sample.*;

public class CounterClient {
    public static String RESET_FUNCTION = "reset";
    public static String CLEAR_FUNCTION = "clear";
    public static String SET_FUNCTION = "set";
    public static String INCREMENT_FUNCTION = "increment";
    public static String DECREMENT_FUNCTION = "decrement";

    public static String VALUE_STRING = "Value ";
    public static String ILLEGAL_COMMAND = "Illegal command";
    public static String EXECUTE_COMMAND 
        = "Please execute the command as like follows, ";
    public static String USAGE_MESSAGE 
        = "CounterClient [clear | reset | increment | decrement | [set count]]";

    public static void main(String[] ag) {
        CounterServer cs;
        int  value;

        cs = new CounterServer();

        if (ag != null && ag.length == 2 &&
                ag[0].compareTo(SET_FUNCTION) == 0) {
            int   count;

            try {
                count = Integer.valueOf(ag[1]).intValue();
            } catch (Exception ep) {
                ep.printStackTrace(System.out);
                return;
            }
            value = cs.setCounter(count);
            System.out.println(VALUE_STRING + String.valueOf(value));
            value = cs.getCounter();
            System.out.println(VALUE_STRING + String.valueOf(value));
            return;
        }
        if ((ag != null && ag.length == 1 &&
                ag[0].compareTo(RESET_FUNCTION) == 0) ||
         (ag != null && ag.length == 1 &&
                ag[0].compareTo(CLEAR_FUNCTION) == 0)) {
            cs.resetCounter();
            value = cs.getCounter();
            System.out.println(VALUE_STRING + String.valueOf(value));
            return;
        }
        if (ag != null && ag.length == 1 &&
                ag[0].compareTo(INCREMENT_FUNCTION) == 0) {
            value = cs.incrementCounter();
/*
            value = cs.getCounter();
*/
            System.out.println(VALUE_STRING + String.valueOf(value));
            return;
        }
        if (ag != null && ag.length == 1 &&
                ag[0].compareTo(DECREMENT_FUNCTION) == 0) {
            value = cs.decrementCounter();
/*
            value = cs.getCounter();
*/
            System.out.println(VALUE_STRING + String.valueOf(value));
            return;
        }
        System.out.println( ILLEGAL_COMMAND );
        System.out.println( EXECUTE_COMMAND );
        System.out.println( USAGE_MESSAGE );

    }
}
