/**
 * Copyright (C) All rights reserved.
 *
 * @Module     ArticlePostTest.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    1.0 2013/04/02
 */

package exec;

import java.lang.*;
import java.io.*;
import java.util.*;

public class ArticlePostTest extends ArticlePost {
    public static String TEST1 = "Test1";

    public void Test1(String[] args) {
        int              no;
        int              board_number;
        String           message;
        String[]         tags;
        BookCenter       book_center;
        IndexCard        book_card;
        StoreHouse       store_house;
        ArticleEntry     article_entry;
        ArticleEntry[]   article_array;

        ArticleEntry     operate_article;
/**
        ArticlePostTest  article_post_test;
**/
        ArticlePost      article_post;
        article_post = new ArticlePost();
/**
        article_post_test = new ArticlePostTest();
**/
        if (getDebug() > 0 && getLogPrintStream() != null) {
            message = getMessage( ENTER_METHOD, ENTER_METHOD,
                SPACE, TEST1);
            getLogPrintStream().printLogln(message);
        }
        try {
            book_center = new BookCenter();
            book_center.setDebug( getDebug() );
            book_center.setMessageResource( getMessageResource() );
            book_center.setLogPrintStream( getLogPrintStream() );
        } catch (Exception  exception_object) {
            exception_object.printStackTrace();
            return;
        }
        for (int i = 1; i < args.length; i++) {
            try {
                book_center.addBook(args[i]);
            } catch (Exception exception_object) {
                exception_object.printStackTrace();
                return;
            }
        }
        operate_article = new ArticleEntry();
        operate_article.setMessageResource( getMessageResource() );
        operate_article.setDebug( getDebug() );
        operate_article.setLogPrintStream( getLogPrintStream() );
     
        for (int i = 0; i < args.length-1; i++) {
            try {
                book_card = book_center.getIndexCard(i);
            } catch (Exception exception_object) {
                exception_object.printStackTrace();
                return;
            }
            try {
                tags = operate_article.getKeys(args[0], book_card);
            } catch (Exception  exception_object) {
                exception_object.printStackTrace();
                return;
            }
            if (tags == null) {
                break;
            }

            for (int j = 0; j < tags.length; j++) {
                try {
                    article_post = valueOf(tags[j], book_card, 
                        (ArticlePost)article_post,
                        getMessageResource(),
                        getDebug(),
                        getLogPrintStream());
                } catch (Exception exception_object) {
                    continue;
                }
                if (getDebug() > 0 && getLogPrintStream() != null) {
                    message = getMessage( DEBUG_VALUE_KEY, DEBUG_VALUE_KEY,
                        SPACE, String.valueOf(article_post.size()) );
                    getLogPrintStream().printLogln(message);
                }
            }
        }

        for (int i = 0; i < article_post.size(); i++) {
            try {
                article_entry = (ArticleEntry)article_post.get(i);
            } catch (Exception exception_object) {
                continue;
            }
            if (getDebug() > 0 && getLogPrintStream() != null) {
                message = getMessage( DEBUG_VALUE_KEY, DEBUG_VALUE_KEY,
                    SPACE, String.valueOf(article_entry.toString()) );
                getLogPrintStream().printLogln(message);
            }

            if (article_entry.getChild() != true) {
                continue;
            }

            try {
                article_array = getArticleArray(article_entry) ;
            } catch (Exception exception_object) {
                continue;
            }

            board_number = article_entry.getBoardNumber();
            try {
                book_card = book_center.getIndexCard(board_number);
                store_house = book_center.getStoreHouse(board_number);
            } catch (Exception exception_object) {
                continue;
            }
            article_entry.printArticle(article_array, book_card, store_house);
        }
    }
}

