/**
 * Copyright (C) All rights reserved.
 *
 * @Module     BookEntry.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    1.0 2012/06/22
 *
 */

package exec;

import java.lang.*;
import java.io.*;
import java.net.*;
import java.util.*;

public class BookEntry extends BaseEntry {

    private ArrayList entries = new ArrayList(0);

    private int parent = -1;
    private int depth = 0;

    private String tag = null;

    public static String type_name = "Book";

    public  String getName() {
        return type_name;
    }

    public void setParent(int number) {
        parent = number;
    }

    public int getParent() {
        return parent;
    }

    public void setTag(String param_tag) {
        tag = param_tag;
    }

    public String getTag() {
        return tag;
    }

    public void setDepth(int number) {
        depth = number;
    }

    public int getDepth() {
        return depth;
    }

    public int addEntry(int number) {
        int  size;
        Integer integer_number;

        integer_number = Integer.valueOf(number);
        entries.add((Object)integer_number);
        size = entries.size();
        return size;
    }

    public int getEntrySize() {
        return entries.size();
    }

    public int getEntryNumber(int index) {
        Integer number;

        number = (Integer)entries.get(index);
        return number.intValue();
    }

    public boolean deleteEntry(int number) {
        Integer  integer_number;

        for (int i = 0; i < entries.size(); i++) {
            integer_number = (Integer)entries.get(i);
            if (integer_number.intValue() == number) {
                entries.remove(i);
                return true;
            }
        }
        return false;
    }

    private AreaRange start_tag = new AreaRange();
    private AreaRange end_tag = new AreaRange();

    public void setStartTag(AreaRange  tag) throws Exception {
        if (tag == null) {
            String       message;
            Exception    exception_object;
            message = getMessage(
                ARGUMENT_PARAMETER_EXCEPTION,
                ARGUMENT_PARAMETER_EXCEPTION);
            exception_object = new Exception( message );
            throw exception_object;
        }
        start_tag = tag.clone();
    }

    public void setEndTag(AreaRange  tag) throws Exception {
        if (tag == null) {
            String       message;
            Exception    exception_object;
            message = getMessage(
                ARGUMENT_PARAMETER_EXCEPTION,
                ARGUMENT_PARAMETER_EXCEPTION);
            
            exception_object = new Exception( message );
            throw exception_object;
        }
        end_tag = tag.clone();
    }

    public AreaRange getStartTag() {
        return start_tag;
    }

    public AreaRange getEndTag() {
        return end_tag;
    }
  
    public static BookEntry  valueOf( MessageResource message_resource,
        int             debug,
        LogPrintStream  log_print_stream) {
        BookEntry   book_entry;

        book_entry = new BookEntry();

        book_entry.setMessageResource( message_resource );
        book_entry.setDebug( debug );
        book_entry.setLogPrintStream( log_print_stream );

        return book_entry;
    }

    public static BookEntry  valueOf() {
        BookEntry   book_entry;

        book_entry = new BookEntry();
        return book_entry;
    }

    private static int  DEBUG_DEBUG = 1;

    public static void main(String[] args) {
        BookEntry        book_entry;
        MessageResource  message_resource;
        LogPrintStream   log_print_stream;
        int              debug;
        String           debug_string;

        debug = 0;
        debug_string = System.getProperty(EXEC_REGION_DEBUG);
        if (debug_string == null || debug_string.length() == 0) {
            debug_string = System.getProperty(DEBUG_LEVEL_KEY);
        }
        if (debug_string != null && debug_string.length() > 0) {
            try {
                debug = Integer.valueOf(debug_string).intValue();
            } catch (Exception exception_object) {
                debug = 0;
            }
        }

        message_resource = new MessageResource();
        log_print_stream = new LogPrintStream( System.err );
        book_entry = BookEntry.valueOf( message_resource,
            debug,
            log_print_stream );

        System.out.println(  book_entry.toString() );
    }
}
