/**
 * Copyright (C) All rights reserved.
 *
 * @Module:    DeleteRegion.java
 * @Author:    Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version:   1.0 2011/09/21
 *
 */

package exec;

import java.lang.*;
import java.io.*;
import java.util.*;

public class DeleteRegion extends RegionObject implements MakeReport {

    private static String DELETE_REGION = "DeleteRegion";
    private static String MAKEREPORT_METHOD = "makeReport";
    private static String EXECUTE = "execute";

    public static String DELETE_ERROR = "Couldn't delete";
    public static String PARAMETER_ERROR = "Parameter error.";
    public static String END_OF_FILE_EXCEPTION   = "EOF Exception";
    public static String END_OF_REGION_EXCEPTION = "EOR Exception";

    public static String TAG_ONLY_OPTION = "-T";

    private static int debug = 0;

    private static boolean  option_flag = false;


    public void setOption(boolean flag) {
        option_flag = flag;
    }

    public boolean checkOption() {
        return option_flag;
    }
    /**
     * deleteReport  tags files
     */
    public void  makeReport(Object[] obj_args, 
        PrintStream print_stream) throws Exception {

        byte[][][]       head_area = new byte[1][][];
        byte[][][]       sub_head_area = new byte[1][][];

        String           tags;
        String      tag_arg;
        String      request_tags;
        InputStream input_stream;
        InputStream save_in;
        KeyList     key_list;
        KeyList     sub_key_list;
        String      option_string;
        int         base;
        int         start;
        int         end;
        int         index;
        int         sub_start;
        int         sub_end;
        int         j_index;
        String      lang;
        String      key;
        String      tag;
        String      name;
        String      keys;
        String      sub_key;
        String      top_key;
        String      entry;
        String      remain_keys;
        String      message;
        String      message_log;
        String      submessage;
        String      return_string;
        String      tag_key;
        byte[]      message_byte;
        Region      region_object;
        Region      sub_region_object;
        Region[]      sub_region_object_array;
        Region      bk_sub_region_object;
        ReportRegion     report_region;
        ReportRegion     sub_report_region;
        int              print_region_end;
        boolean          check;
        File             filed;
        String           line;
        String           report_name;
        Region           operate_region;

        if (getDebug() > 0) {
            message_log = getMessage(ENTER_METHOD, ENTER_METHOD,
                SPACE, MAKEREPORT_METHOD);
            if (getLogPrintStream() == null) {
                setLogPrintStream( new LogPrintStream(System.err) );
            }
            getLogPrintStream().printLogln(message_log);
        }
        if (obj_args == null || obj_args.length <=1) {
            Exception exception_object;

            message = getMessage( ARGUMENT_PARAMETER_EXCEPTION, 
                ARGUMENT_PARAMETER_EXCEPTION,
                getMessageResource().getMessage(
                BLANK_IN_BLANK), DELETE_REGION);
            exception_object = new Exception(message);
            throw exception_object;
        }
        if (print_stream == null) {
            Exception exception_object;

            message = getMessage( STREAM_PARAMETER_EXCEPTION, 
                STREAM_PARAMETER_EXCEPTION,
                getMessageResource().getMessage(
                BLANK_IN_BLANK), DELETE_REGION);
            exception_object = new Exception(message);
            throw exception_object;
        }

        lang = System.getenv(LANG_KEY);
        tags = (String)obj_args[0];

        try {
            key_list = KeyListFactory.createKeyList(tags, COMMA,
                getMessageResource(),
                getDebug(),
                getLogPrintStream() );
            top_key = key_list.getKeyEntry(0);
        } catch (Exception exception_object) {
            throw exception_object;
        }
        remain_keys = new String();
        for (int i = 1; i < key_list.length(); i++) {
            if (i != 1 ) {
                remain_keys = remain_keys.concat(COMMA);
            }
            entry = key_list.getKeyEntry(i);
            remain_keys = remain_keys.concat(entry);
        }
        operate_region = new Region();
/**
        operate_region.setMessageResource( getMessageResource() );
        operate_region.setDebug( getDebug() );
        operate_region.setLogPrintStream( getLogPrintStream() );
*/

        save_in = System.in;
        for (int i = 1; i < obj_args.length; i++) {
            input_stream = (InputStream)obj_args[i];

            if (input_stream == null) {
                System.setIn(save_in);
                Exception exception_object;
                message = getMessage( ARGUMENT_PARAMETER_EXCEPTION, 
                    ARGUMENT_PARAMETER_EXCEPTION);
                exception_object = new Exception(message);
                throw exception_object;
            }
            System.setIn(input_stream);            
            head_area = new byte[1][][];
            while (true) {
                if (getDebug() > 0 && getLogPrintStream() != null) {
                    message_log = getMessage(DEBUG_CALL_KEY, DEBUG_CALL_KEY,
                        SPACE, 
                        Region.FINDREGION_METHOD,
                        getMessageResource().getMessage(DEBUG_CODE_001)); 
                    getLogPrintStream().printLogln(message_log);
                }

                head_area[0] = null;
                start = 0;
                end = 0;
                try {
                    region_object=operate_region.findRegion( head_area, start, end, 
                            WILDCARD_TAG, NAME_KEY);
                    keys = ReportRegion.getTagStringWithOption(region_object);
                } catch (Exception real_exception_object) {
                    break;
                }

                if (ReportRegion.compareTags(top_key, keys, NAME_KEY) == true) {
                    if (key_list.length() == 1) {
                        if (checkOption() == true) {
                            if (getDebug() > 0 && getLogPrintStream() != null) {
                                message_log = getMessage(DEBUG_CALL_KEY, DEBUG_CALL_KEY,
                                    SPACE, 
                                    Region.EXTRACTREGION_METHOD,
                                    getMessageResource().getMessage(DEBUG_CODE_001)); 
                                getLogPrintStream().printLogln(message_log);
                            }

                            message_byte = region_object.extractRegion(
                                head_area[0], 
                                region_object.getStartPosition(),
                                region_object.getEndPosition());

                            if (File.separatorChar 
                                == DOS_DIRECTORY_SEPARATOR_CHAR ||
                                (lang != null && 
                                    lang.indexOf(JAPANESE_PREFIX) >= 0)) {
                                System.out.print(new String(
                                        message_byte, JAPANESE_CHARSET));
                            } else {
                                System.out.print(new String(message_byte));
                            }
                        }
                        continue;              
                    }
                    tag_arg = remain_keys;
                } else {
                    tag_arg = tags;
                }
                try {
                    sub_key_list = KeyListFactory.createKeyList(tag_arg, COMMA,
                        getMessageResource(),
                        getDebug(),
                        getLogPrintStream() );
                } catch (Exception exception_object) {
                    throw exception_object;
                }

                base = 0;
                sub_head_area = new byte[1][][];
                sub_head_area[0] = head_area[0];
                sub_start = region_object.getKeyEndPosition()+1;
                sub_end = region_object.getEndPosition();
                bk_sub_region_object = region_object;

                print_region_end = region_object.getStartRegion();
                sub_region_object_array = new Region[ sub_key_list.length() ];
                while (true) {
                    for (j_index = 0; j_index < sub_key_list.length() ; ) {
                        try {
                            tag_key = sub_key_list.getKeyEntry(j_index);
                        } catch (Exception real_exception_object) {
                            break;
                        }

                        try {
                            sub_region_object_array[j_index]
                                =operate_region.findRegion(
                                 sub_head_area, sub_start, sub_end, 
                                 tag_key, NAME_KEY);
                            sub_key = ReportRegion.getTagStringWithOption(
                                    sub_region_object_array[j_index]);
                        } catch (Exception real_exception_object) {
                            if (real_exception_object.getMessage() != null 
                                && real_exception_object.getMessage().compareTo(
				    END_OF_FILE_EXCEPTION) == 0) {
                                    break;
                            }
                            if (j_index < 1) {
                                break;
                            }
                            sub_start = sub_region_object_array[
                                    j_index-1].getEndRegion();
                            j_index--;
                            continue;
                        } 
                        sub_start = sub_region_object_array[
                                    j_index].getStartPosition();
                        j_index++;
                        continue;
                    }
                    if (j_index != sub_key_list.length()) {
                        if (print_region_end < region_object.getEndRegion()) {
                            message_byte = region_object.extractRegion(
                                head_area[0], 
                                print_region_end,
                                region_object.getEndRegion());
                            if (File.separatorChar 
                                == DOS_DIRECTORY_SEPARATOR_CHAR ||
                                (lang != null && 
                                lang.indexOf(JAPANESE_PREFIX) >= 0)) {
                                print_stream.print(new String(
                                    message_byte, JAPANESE_CHARSET));
                            } else {
                                print_stream.print(new String(message_byte));
                            }
                        }
                        break;
                    }
                    if (getDebug() > 0 && getLogPrintStream() != null) {
                        message_log = getMessage(DEBUG_CALL_KEY, DEBUG_CALL_KEY,
                            SPACE, 
                            Region.EXTRACTREGION_METHOD,
                            getMessageResource().getMessage(DEBUG_CODE_001)); 
                        getLogPrintStream().printLogln(message_log);
                    }
                    message_byte = sub_region_object_array[0].extractRegion(
                        sub_head_area[0], 
                        print_region_end,
                        sub_region_object_array[j_index-1].getStartRegion()-1);

                    if (File.separatorChar == DOS_DIRECTORY_SEPARATOR_CHAR ||
                        (lang != null && lang.indexOf(JAPANESE_PREFIX) >= 0)) {
                        print_stream.print(new String(
                            message_byte, JAPANESE_CHARSET));
                    } else {
                        print_stream.print(new String(message_byte));
                    }
                    if (checkOption() == true) {
                        if (getDebug() > 0 && getLogPrintStream() != null) {
                            message_log = getMessage(DEBUG_CALL_KEY, DEBUG_CALL_KEY,
                            SPACE, 
                            Region.EXTRACTREGION_METHOD,
                            getMessageResource().getMessage(DEBUG_CODE_001)); 
                            getLogPrintStream().printLogln(message_log);
                        }
                        message_byte = sub_region_object_array[0].extractRegion(
                            sub_head_area[0], 
                            sub_region_object_array[
                                j_index-1].getStartPosition(),
                            sub_region_object_array[
                                j_index-1].getEndPosition());
                        print_stream.println(EMPTY);
                        if (File.separatorChar==DOS_DIRECTORY_SEPARATOR_CHAR ||
                           (lang != null&&lang.indexOf(JAPANESE_PREFIX)>= 0)) {
                            print_stream.println(new String(
                                message_byte, JAPANESE_CHARSET));
                        } else {
                            print_stream.println(new String(message_byte));
                        }
                    }
                    print_region_end = sub_region_object_array[
                        j_index-1].getEndRegion()+1;

                    sub_start = sub_region_object_array[0].getEndRegion() + 1;
                    sub_end = region_object.getEndRegion();

                    if (j_index != 1 && sub_region_object_array[j_index-1].getEndRegion() < 
                        sub_region_object_array[0].getEndRegion()) {
                        if (getDebug() > 0 && getLogPrintStream() != null) {
                            message_log = getMessage(DEBUG_CALL_KEY, DEBUG_CALL_KEY,
                            SPACE, 
                            Region.EXTRACTREGION_METHOD,
                            getMessageResource().getMessage(DEBUG_CODE_001)); 
                            getLogPrintStream().printLogln(message_log);
                        }
                        message_byte 
                            = sub_region_object_array[0].extractRegion(
                            sub_head_area[0], 
                            sub_region_object_array[j_index-1].getEndRegion()+1,
                            sub_region_object_array[0].getEndRegion());
                        if (File.separatorChar == 
                            DOS_DIRECTORY_SEPARATOR_CHAR ||
                            (lang != null && lang.indexOf(JAPANESE_PREFIX) 
                                >= 0)) {
                            print_stream.print(new String(
                                    message_byte, JAPANESE_CHARSET));
                        } else {
                            print_stream.print(new String(message_byte));
                        }
                        print_region_end = 
                                sub_region_object_array[0].getEndRegion()+1;
                    }

                }
                print_stream.println(EMPTY);
            }
        }
        System.setIn(save_in);
        if (getDebug() > 0 && getLogPrintStream() != null) {
            message_log = getMessage(END_METHOD, END_METHOD,
                SPACE, MAKEREPORT_METHOD);
            getLogPrintStream().printLogln(message_log);
        }
        return ;
    }

    public void execute(String[] org_args) throws Exception {
        String           message;
        PrintStream      print_stream;

        if (getDebug() > 0 && getLogPrintStream() != null) {
            message = getMessage(ENTER_METHOD, ENTER_METHOD, SPACE, EXECUTE);
            getLogPrintStream().printLogln( message );
        }
        print_stream = System.out;
        try {
            super.execute(org_args, print_stream, (MakeReport)this);
        } catch (Exception real_exception_object) {
            throw real_exception_object; 
        }
        if (getDebug() > 0 && getLogPrintStream() != null) {
            message = getMessage(END_METHOD, END_METHOD, SPACE, EXECUTE);
            getLogPrintStream().printLogln( message );
        }
    }

    public static void main(String[] org_args) {
        String                  message;
        int                     start;
        String[]                args;
        DeleteRegion            delete_region;
        FileOutputStream        file_output_stream;
        PrintStream             print_stream;
        String                  debug_string;

        delete_region = new DeleteRegion();
        debug_string = System.getProperty(EXEC_REGION_DEBUG);
        if (debug_string == null || debug_string.length() == 0) {
            debug_string = System.getProperty(DEBUG_LEVEL_KEY);
        }
        if (debug_string != null && debug_string.length() > 0) {
            delete_region.setDebug(debug_string);
        }
        delete_region.setLogPrintStream( new LogPrintStream( System.err ) );

        if (org_args.length < 1) {
            message = delete_region.getMessage( ARGUMENT_PARAMETER_EXCEPTION,
                ARGUMENT_PARAMETER_EXCEPTION,
                delete_region.getMessageResource().getMessage(BLANK_IN_BLANK),
                DELETE_REGION);
            System.out.println(message);
            return;
        }

        try {
            print_stream = System.out;
        } catch (Exception exception_object) {
            message = exception_object.getMessage();
            if (message == null) {
                message = delete_region.getMessage( IO_ERROR_EXCEPTION, 
                    IO_ERROR_EXCEPTION,
                    delete_region.getMessageResource().getMessage(
                        BLANK_IN_BLANK), DELETE_REGION);
            }
            System.exit(1);
            return;
        }

        if (org_args.length >= 3 && org_args[1].compareTo(TAG_ONLY_OPTION) == 0) {
            delete_region.setOption(true);
            args = new String[org_args.length-2];
            args[0] = org_args[2];
            start = 3;
        } else if (org_args.length >= 3 && org_args[2].compareTo(TAG_ONLY_OPTION) == 0) {
            delete_region.setOption(true);
            args = new String[org_args.length-2];
            args[0] = org_args[1];
            start = 3;
        } else {
            args = new String[org_args.length-1];
            args[0] = org_args[1];
            delete_region.setOption(false);
            start = 2;
        }
        for (int i = start; i < org_args.length; i++) {
            args[i-start+1] = org_args[i];
        } 
        try {
            delete_region.execute(args);
        } catch (Exception exception_object) {
            message = exception_object.getMessage();
            if (message == null) {
                message = delete_region.getMessage( INTERNAL_ERROR_EXCEPTION, 
                    INTERNAL_ERROR_EXCEPTION,
                    delete_region.getMessageResource().getMessage(
                        BLANK_IN_BLANK), DELETE_REGION);
            } 
            if (message.compareTo(END_OF_FILE_EXCEPTION) != 0) {
                System.err.println(message);
                System.exit (1);
            }
        }
    }
}
