/**
 * Copyright (C) All rights reserved.
 *
 * @Module     DeleteRegionTest.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    1.0 2013/04/04
 *
 */

package exec;

import java.lang.*;
import java.io.*;
import java.util.*;

public class DeleteRegionTest extends DeleteRegion {
    private static String TEST1 = "Test1";
    private static String TEST2 = "Test2";

    public void Test1(String[] args) {
        boolean        check_boolean;;
        String         message;
        Object[]       objs;
        PrintStream    print_stream;

        if (getDebug() > 0 && getLogPrintStream() != null) {
            message = getMessage(ENTER_METHOD, ENTER_METHOD, SPACE, TEST1);
            getLogPrintStream().printLogln( message );

            FileInputStream    file_input_stream;

            if (args.length < 2) {
                message = getMessage(END_METHOD, END_METHOD, SPACE, TEST1);
                getLogPrintStream().printLogln( message );
                return;
            }
            try {
                file_input_stream = new FileInputStream(args[1]);
            } catch (Exception exception_object) {
                exception_object.printStackTrace();
                message = getMessage(END_METHOD, END_METHOD, SPACE, TEST1);
                getLogPrintStream().printLogln( message );
                return;
            }
            objs = new Object[2];
            objs[0] = args[0];
            try {
                check_boolean = checkTags((String)objs[0]);
            } catch (Exception exception_object) {
                exception_object.printStackTrace();
                message = getMessage(END_METHOD, END_METHOD, SPACE, TEST1);
                getLogPrintStream().printLogln( message );
                return;
            }
            if (check_boolean == false) {
                message = getMessage(END_METHOD, END_METHOD, SPACE, TEST1);
                getLogPrintStream().printLogln( message );
                return;
            }
            objs[1] = file_input_stream;

            try {
                makeReport(objs, getLogPrintStream().getPrintStream());
            } catch (Exception exception_object) {
                exception_object.printStackTrace();
                message = getMessage(END_METHOD, END_METHOD, SPACE, TEST1);
                getLogPrintStream().printLogln( message );
                return;
            }

            message = getMessage(END_METHOD, END_METHOD, SPACE, TEST1);
            getLogPrintStream().printLogln( message );
        }
    }

    public void Test2(String[] args) {
        String  message;

        if (getDebug() > 0 && getLogPrintStream() != null) {
            message = getMessage(ENTER_METHOD, ENTER_METHOD, SPACE, TEST2);
            getLogPrintStream().printLogln( message );

            try {
                execute(args);
            } catch (Exception exception_object) {
                exception_object.printStackTrace();
                message = getMessage(END_METHOD, END_METHOD, SPACE, TEST2);
                getLogPrintStream().printLogln( message );
                return;
            }

            message = getMessage(END_METHOD, END_METHOD, SPACE, TEST2);
            getLogPrintStream().printLogln( message );
        }
    }
}
  
