/**
 * Copyright (C) All rights reserved.
 *
 * @Module     InsertRegionTest.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    1.0 2013/04/05
 *
 */

package exec;

import java.lang.*;
import java.io.*;
import java.util.*;

public class InsertRegionTest extends InsertRegion {
    private static String TEST1 = "Test1";
    private static String TEST2 = "Test2";

    public void Test1(String[] args) {
        String             message;
        Object[]           obj;
        FileInputStream    file_input_stream;

        if (getDebug() > 0 && getLogPrintStream() != null) {
            message = getMessage(ENTER_METHOD, ENTER_METHOD, SPACE, TEST1);
            getLogPrintStream().printLogln( message );

            obj = new Object[args.length];
            obj[0] = args[0];
            for (int i = 1; i < args.length; i++) {
                try {
                    file_input_stream = new FileInputStream( args[i] );
                } catch (Exception exception_object) {
                    exception_object.printStackTrace();
                    message = getMessage(END_METHOD, END_METHOD, SPACE, TEST1);
                    getLogPrintStream().printLogln( message );
                    return;
                }
                obj[i] = file_input_stream;
            }

            enableInsertTag() ;
            try {
                makeReport(obj, getLogPrintStream().getPrintStream());
            } catch (Exception exception_object) {
                exception_object.printStackTrace();
                message = getMessage(END_METHOD, END_METHOD, SPACE, TEST1);
                getLogPrintStream().printLogln( message );
                return;
            }

            message = getMessage(END_METHOD, END_METHOD, SPACE, TEST1);
            getLogPrintStream().printLogln( message );
        }
    }

    public void Test2(String[] args) {
        String  message;

        if (getDebug() > 0 && getLogPrintStream() != null) {
            message = getMessage(ENTER_METHOD, ENTER_METHOD, SPACE, TEST2);
            getLogPrintStream().printLogln( message );

            try {
                execute(args);
            } catch (Exception exception_object) {
                exception_object.printStackTrace();
                message = getMessage(END_METHOD, END_METHOD, SPACE, TEST2);
                getLogPrintStream().printLogln( message );
                return;
            }

            message = getMessage(END_METHOD, END_METHOD, SPACE, TEST2);
            getLogPrintStream().printLogln( message );
        }
    }
}

