/**
 * Copyright (C) All rights reserved.
 *
 * @Module     JapaneseMatch.java
 * @Author     Takahiko Tanaka.
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    1.0 2012/12/06
 *
 */

package exec;

import java.lang.*;
import java.io.*;
import java.util.*;

import dict.*;

public class JapaneseMatch extends DebugObject {
    private String               COMMA = ",";
    private ArrayList            key_array = new ArrayList(0);
    private StringMatch          string_match = new StringMatch();
    private static String        dictionary_file = "dictionary";
    private JapaneseDictionary   japanese_dictionary = null;

    public void add(String key) throws Exception {
        KeyList              key_list;
        TagString            tag_string;
        String               key_string;
        String               converted_key;
        String               option_string;
        String               converted_option;
        String               japanese_key;
        String               key_list_string;

        if (japanese_dictionary == null) {
            try {
                japanese_dictionary = JapaneseDictionary.valueOf(dictionary_file, true);
            } catch (Exception exception_object) {
                throw exception_object;
            }
        }
        try {
            key_list = KeyListFactory.createKeyList(key, COMMA,
                getMessageResource(),
                getDebug(),
                getLogPrintStream());
        } catch (Exception exception_object) {
            throw exception_object;
        }

        japanese_key = new String();
        
        for (int i = 0; i < key_list.length(); i++) {
            try {
                key_list_string = key_list.getKeyEntry(i);
                tag_string = new TagString(key_list_string);
                key_string = tag_string.getKey();
                option_string = tag_string.getOptionValue();
                converted_option = japanese_dictionary.findEntry(option_string);
                converted_key = japanese_dictionary.findEntry(key_string);
            } catch (Exception exception_object) {
                throw exception_object;
            }
            japanese_key = japanese_key.concat(converted_key+converted_option);
        }
        key_array.add(key);
        try {
            string_match.add(japanese_key);
        } catch (Exception exception_object) {
            throw exception_object;
        }
    }

    public int getPosition(int order) throws Exception {
        int  position;
        position = string_match.getPositionInKey(order);
        return position;
    }

    public String getKey(int order) throws Exception {
        int     position;
        String  item_string;

        position = string_match.getPositionInKey(order);
        item_string = (String)key_array.get(position);
        return item_string;
    }

    public static void main(String[] args) {
        JapaneseMatch  japanese_match;
    }
}
