/**
 * Copyright (C) All rights reserved.
 *
 * @Author     Takahiko Tanaka
 * @Module     KeyListFactory.java
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    1.0 2011/09/21
 *
 */

package exec;

import java.lang.*;
import java.io.*;
import java.util.*;

public class KeyListFactory {

    public static String  PARAMETER_ERROR = "Parameter error.";

    public static KeyList createKeyList(String tags, String separator,
        MessageResource  param_message_resource,
        int              debug,
        LogPrintStream   log_print_stream) throws Exception
    {
        int               list_index;
        int               key_list_count;
        String            message;
        String            word;
        StringTokenizer   string_tokenizer;
        KeyList           key_list;
        Exception         exception_object;
        MessageResource   message_resource;

        if (tags == null) {
            message_resource = param_message_resource;
            if (message_resource == null) {
                message_resource = new MessageResource();
            }
            message = message_resource.getFormattedMessage(
                DebugObject.ARGUMENT_PARAMETER_EXCEPTION,
                message_resource.getMessage(
                    DebugObject.ARGUMENT_PARAMETER_EXCEPTION));

            exception_object = new Exception( message );
            throw exception_object;
        }
        string_tokenizer = new StringTokenizer(tags, separator);
        key_list_count = string_tokenizer.countTokens();
        if (key_list_count <= 0) {
            message_resource = param_message_resource;
            if (message_resource == null) {
                message_resource = new MessageResource();
            }
            message = message_resource.getFormattedMessage(
                DebugObject.ARGUMENT_PARAMETER_EXCEPTION,
                message_resource.getMessage(
                    DebugObject.ARGUMENT_PARAMETER_EXCEPTION));
            exception_object = new Exception( message );
            throw exception_object;
        }
        try {
            key_list = KeyList.valueOf(key_list_count,
                    param_message_resource,
                    debug,
                    log_print_stream);
        } catch (Exception real_exception_object) {
            throw real_exception_object;
        }
        list_index = 0;
        while (string_tokenizer.hasMoreTokens()) {
            word = string_tokenizer.nextToken();
            try {
                key_list.setKeyEntry(list_index, word);
            } catch (Exception real_exception_object) {
                throw real_exception_object;
            }
            list_index = list_index + 1;
        }
        return key_list;
    }
}
