/**
 * Copyright (C)  All rights reserved.
 *
 * @Module     MessageText.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    1.0 2011/09/05
 *
 */

package exec;

import java.lang.*;
import java.io.*;
import java.net.*;
import java.util.*;

public interface MessageText {

    public static String TAB_SPACE = "    ";
    public static String SPACE = " ";
    public static String COMMA = ",";
    public static String NAME_KEY = "name";
    public static String TMPDIR = "tmp";

    public static String PARENT = "..";
    public static String EMPTY = "";
    public static String DOT = ".";
    public static String EQUAL = "=";
    public static String CLOSE_TAG = ">";
    public static String WILDCARD_TAG = "<*>";
    public static char   NUMERIC_ZERO = '0';
    public static char   NUMERIC_NINE = '9';
    public static char   CODE_NEWLINE = '\n';
    public static char   CODE_RETURN = '\r';
    public static char   UPPER_A = 'A';
    public static char   UPPER_Z = 'Z';
    public static char   DATE_SEPARATOR_CHAR = '/';
    public static char   TERM_SEPARATOR_CHAR = '-';
    public static String TAG_START_STRING = "<";
    public static String TAG_END_STRING = ">";
    public static String TAG_END_MARK_STRING = "/";
    public static char   TAG_END = '>';
    public static String NEWLINE_STRING = "\n";
    public static String START_BRACKET_STRING = "[";
    public static String END_BRACKET_STRING = "]";
    public static char START_BRACKET_CHAR = '[';
    public static char END_BRACKET_CHAR = ']';
    public static char DOS_DIRECTORY_SEPARATOR_CHAR = '\\';

    public static String CHECKTAGS_METHOD = "checkTags";
    public static String EXECUTE_METHOD = "Execute";
    public static String ENTER_METHOD = "Enter into method";
    public static String END_METHOD = "End method";
    public static String ENTER_EXECUTE = "Enter into execute() method.";
    public static String END_EXECUTE = "End execute() method.";
    public static String PARAMETER_KEY = "Parameter";
    public static String METHOD_KEY = "Method";

    public static String REACH_END_OF_FILE = "Reach End Of File";
    public static String REACH_END_OF_AREA = "Reach End Of Area";

    public static String DEBUG_NULL_KEY = "Null";
    public static String DEBUG_START_KEY = "Start";
    public static String DEBUG_CALL_KEY = "Call";
    public static String DEBUG_TRACE_KEY = "Trace";
    public static String DEBUG_EXCEPTION_KEY = "Exception";
    public static String DEBUG_DEBUG_KEY = "Debug";
    public static String DEBUG_DEBUG_CONDITION_KEY = "Debug condition";
    public static String DEBUG_ENABLE_KEY = "Enable";
    public static String DEBUG_ENTER_KEY = "Enter";
    public static String DEBUG_DISABLE_KEY = "disable";
    public static String DEBUG_TAG_KEY = "Tag";
    public static String DEBUG_VALUE_KEY = "Value";
    public static String DEBUG_COUNT_KEY = "Count";

    public static String DEBUG_READ_OPERATION_KEY = "Read Operation";
    public static String DEBUG_WRITE_OPERATION_KEY = "Write Operation";

    public static String DEBUG_READ_DATA_FROM_JAR = "Read data from Jar.";

    public static String DEBUG_CODE_001 = "\001";
    public static String DEBUG_CODE_002 = "\002";
    public static String DEBUG_CODE_003 = "\003";
    public static String DEBUG_CODE_004 = "\004";
    public static String CODE_101 = "\101";

    public static String DEBUG_VALUE_EXCEPTION_KEY = "Illegal debug value";

    public static int TRACE_DEBUG_LEVEL = 3;
    public static int FULL_DEBUG_LEVEL = 5;

    public String DEBUG_MESSAGE = "Message ";
    public static String LANG_KEY = "LANG";
    public static String EXEC_REGION_LANG = "exec.region.lang";
    public static String DEBUG_LEVEL_KEY = "debug.level";
    public static String JAPANESE_PREFIX = "ja_JP";
    public final static String JAPANESE_CHARSET = "UTF-8";
    public final static String SYSTEM_IO_ERROR = "System I/O error";
    public static String SPACE_STRING = " ";

    public static String DEBUG_SETUP_MESSAGE = "Debug environment is set.";

    public static String EOF_EXCEPTION = "EOF Exception";
    public static String INVOKE_ERROR_EXCEPTION = "Invoke Error Exception";
    public static String ARGUMENT_PARAMETER_EXCEPTION = "Argument Parameter Exception";
    public static String OVERFLOW_INDEX_EXCEPTION     
        = "Overflow Index Exception";
    public static String TAGKEYS_PARAMETER_ERROR      
        = "Tagkeys parameter error";
    public static String ILLEGAL_DEBUG_VALUE
        = "Illegal debug value";
    public static String ASSERTION_EXCEPTION
        = "Assertion Exception";
    public static String FORMAT_ERROR_EXCEPTION
        = "Format Error Exception";
    public static String ILLEGAL_METHOD_EXCEPTION 
        = "Illegal Method Exception";
    public static String ILLEGAL_KEY_EXCEPTION
        = "Illegal Key Exception";
    public static String INVALID_FILE_ERROR_EXCEPTION
        = "Invalid File Error Exception";
    public static String NOT_FOUND_ENTRY_EXCEPTION 
        = "Not Found Entry Exception";
    public static String REGION_ERROR_EXCEPTION
        = "Region Error Exception";

    public static String INTERNAL_ERROR_EXCEPTION = "Internal Error Exception";
    public static String IO_ERROR_EXCEPTION = "I/O Error Exception";
    public static String STREAM_PARAMETER_EXCEPTION = "Stream Parameter Error";
    public static String TAG_PARAMETER_EXCEPTION = "TAG Parameter Error";
    public static String WORD_PARAMETER_EXCEPTION = "Word Parameter Error";
    public static String DISPLAY_HIERARCHY_TITLE_MESSAGE = "File name";
    public static String DISPLAY_HIERARCHY_PARAMETER_EXCEPTION    
        = "Parameter Exception in DisplayHierarchy.";
    public static String FILE_WARNING_MESSAGE = "File error";

    public static String FILE_NOT_FOUND_EXCEPTION = "not found";

    public static String BLANK_IN_BLANK = " in ";

    /** Search Region **/
    public static String TAG_PARAMETER_ERROR = "Tag Parameter error.";
    public static String WORD_PARAMETER_ERROR = "Word Parameter error.";

    public static String EXEC_REGION_DEBUG = "exec.region.debug";

    public static String PROMPT_INPUT_FILE = "Please input file name";


    /**
     **  Error definition
     **/
    public static String DELETEREGION_PARAMETER_EXCEPTION
        = "Parameter exception";

}
