/**
 * Copyright (C) All rights reserved.
 *
 * @Module     OperateBuffer.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    1.0 2012/11/29
 *
 */

package exec;

import java.lang.*;
import java.io.*;

public class OperateBuffer extends DebugObject {
/**
    private static String NOT_FOUND_EXCEPTION = "Not found exception.";
    private static String PARAMETER_ERROR_EXCEPTION = "Parameter error exception.";
**/

    public  int searchWord(byte[] buffer, int start, int end, byte[] word)    throws Exception {
        int   i;
        int   current;
        String  message;

        if (buffer == null || word == null ||
            buffer.length == 0 || word.length == 0 ||
            buffer.length < start || buffer.length < end ||
            start < 0 || end < start) {

            Exception  exception_object;
            message = getMessage( ARGUMENT_PARAMETER_EXCEPTION,
                ARGUMENT_PARAMETER_EXCEPTION);
            exception_object = new Exception( message );
            throw exception_object;
        }
        current = 0;
        for (i = start; i <= end; i++) {
            if (buffer[i] == word[current]) {
                current = current + 1;
                if (word.length == current) {
                    break;
                }
            } else {
                current = 0;
            }
        }
        if (end < i) {
            Exception  exception_object;
            message = getMessage( FORMAT_ERROR_EXCEPTION,
                FORMAT_ERROR_EXCEPTION);
            exception_object = new Exception( message );
            throw exception_object;
        }
        return i - current;
    }
}

