/**
 * Copyright (C) All rights reserved.
 *
 * @Module     ParameterOutput.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    1.0 2013/01/23
 *
 */

package exec;

import java.lang.*;
import java.io.*;
import java.util.*;

public class ParameterOutput extends RegionObject implements MakeReport {
    private String lang = null;

    private static String PARAMETER_OUTPUT = "ParameterOutput";
    private static String MAKEREPORT_METHOD = "makeReport";
    private static String EXECUTE = "execute";

    private static String INPUT_STREAM_EXCEPTION = "DecodeInputStream error.";

/**
    private static String PARAMETER_OUTPUT_PARAMETER_EXCEPTION    
        = "Parameter Exception in ParameterOutput.";
**/

    private static LogPrintStream  log_print_stream = null;

    public ParameterOutput() {
        super();
        if (getDebug() > 0) {
            log_print_stream = new LogPrintStream(System.err);
        }
    }

    public void makeReport(Object[] arg_string, PrintStream print_stream) throws Exception {
        String  message;
        String  parameter_key;

/**
        if (arg_string != null || arg_string.length == 0 || print_stream == null) {
            Exception    exception_object;
            message = getMessage( PARAMETER_OUTPUT_PARAMETER_EXCEPTION,
                PARAMETER_OUTPUT_PARAMETER_EXCEPTION);
            exception_object = new Exception(message);
            throw exception_object;
        }
*/
        if (arg_string.length <= 1) {
            Exception exception_object;

            message = getMessage( ARGUMENT_PARAMETER_EXCEPTION, 
                ARGUMENT_PARAMETER_EXCEPTION,
                getMessageResource().getMessage(
                BLANK_IN_BLANK), PARAMETER_OUTPUT);
            exception_object = new Exception(message);
            throw exception_object;
        }
        if (print_stream == null) {
            Exception exception_object;

            message = getMessage( STREAM_PARAMETER_EXCEPTION, 
                STREAM_PARAMETER_EXCEPTION,
                getMessageResource().getMessage(
                BLANK_IN_BLANK), PARAMETER_OUTPUT);
            exception_object = new Exception(message);
            throw exception_object;
        }
/***
        message       = getMessage(ENTER_EXECUTE, ENTER_EXECUTE);
        parameter_key = getMessage(PARAMETER_KEY, PARAMETER_KEY);

        log_print_stream.printLogln(message);
****/
/**
        print_stream.println(message);
**/
        for (int i = 0; i < arg_string.length; i++) {
/**
            log_print_stream.printLogln(
                parameter_key + SPACE + arg_string[i]);
**/
            print_stream.println(arg_string[i].toString());
/*
            print_stream.println(arg_string[i]);
*/
        }
/**
        message = getMessage(END_EXECUTE, END_EXECUTE);
        log_print_stream.printLogln(message);
**/
        return;
    }

    public void execute(String[] org_args) throws Exception {
        String           message;
        PrintStream      print_stream;

        if (getDebug() > 0 && getLogPrintStream() != null) {
            message = getMessage(ENTER_METHOD, ENTER_METHOD, SPACE, EXECUTE);
            getLogPrintStream().printLogln( message );
        }
        if (getDebug() > 0 && getLogPrintStream() != null) {
            message = getMessage(DEBUG_VALUE_KEY, DEBUG_VALUE_KEY, 
                    SPACE, String.valueOf(org_args.length));
            getLogPrintStream().printLogln( message );
        }
        for (int i = 0; i < org_args.length; i++) {
            if (getDebug() > 0 && getLogPrintStream() != null) {
                message = getMessage(DEBUG_VALUE_KEY, DEBUG_VALUE_KEY, 
                    SPACE, org_args[i]);
                getLogPrintStream().printLogln( message );
            }
        }
/**
*/
        print_stream = System.out;
        try {
            super.execute(org_args, print_stream, (MakeReport)this);
        } catch (Exception real_exception_object) {
            throw real_exception_object; 
        }
/*
**/
        if (getDebug() > 0 && getLogPrintStream() != null) {
            message = getMessage(END_METHOD, END_METHOD, SPACE, EXECUTE);
            getLogPrintStream().printLogln( message );
        }
    }


    public static void main(String[] args) {
        String           message;
        ParameterOutput  parameter_output;

        parameter_output = new ParameterOutput();
        if (args.length > 0) {
/**
            message = parameter_output.getMessage(
                PARAMETER_OUTPUT_PARAMETER_EXCEPTION,
                PARAMETER_OUTPUT_PARAMETER_EXCEPTION);

            System.err.println( message );
            System.exit(0);
            return;
**/
            message = parameter_output.getMessage( ARGUMENT_PARAMETER_EXCEPTION,
                ARGUMENT_PARAMETER_EXCEPTION,
                parameter_output.getMessageResource().getMessage(
                    BLANK_IN_BLANK),
                PARAMETER_OUTPUT);
            System.out.println(message);
            return;
        }

        try {
/*
            parameter_output.execute(args);
*/
            parameter_output.execute(args, System.out, 
                    (MakeReport)parameter_output);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }
}
