/**
 * Copyright (C) All rights reserved.
 *
 * @Module     RegionObjectTest.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    1.0 2013/04/04
 *
 */

package exec;

import java.lang.*;
import java.io.*;
import java.util.*;

public class RegionObjectTest extends RegionObject implements MakeReport {
    private static String TEST1 = "Test1";
    private static String OBJECT_HEAD = "Object";

    public void makeReport(Object[] args, PrintStream print_stream) throws Exception {
        String      message;

        if (print_stream == null) {
            message = getMessage( ARGUMENT_PARAMETER_EXCEPTION, 
                ARGUMENT_PARAMETER_EXCEPTION);
            System.err.println(message);
            return;
        }
        for (int i = 0; i < args.length; i++) {
            print_stream.println ( OBJECT_HEAD + SPACE + args[i].toString() );
        }
    }


    public void Test1(String[] args) {
        String         message;

        if (getDebug() > 0 && getLogPrintStream() != null) {
            message = getMessage(ENTER_METHOD, ENTER_METHOD, SPACE, TEST1);
            getLogPrintStream().printLogln( message );

            try {
                execute(args, 
                    getLogPrintStream().getPrintStream(), (MakeReport)this);
            } catch (Exception exception_object) {
                exception_object.printStackTrace();
                return;
            }

            message = getMessage(END_METHOD, END_METHOD, SPACE, TEST1);
            getLogPrintStream().printLogln( message );
        }
    }
}
