/**
 * Copyright (C) All rights reserved.
 *
 * @Module     ReportEntry.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    1.0 2012/08/24
 *
 */

package exec;

import java.lang.*;
import java.io.*;
import java.util.*;

public class ReportEntry extends BaseEntry {
    private String tag_string;
    private ArrayList  articles = new ArrayList();
    public static String type_name = "Report";

    private static String PARAMETER_ERROR = "Parameter error";

    public  String getName() {
        return type_name;
    }

    public void setTagString(String tag) {
        tag_string = tag;
    }

    public String getTagString() {
        return tag_string;
    }

    public void appendArticle(int article_index) throws Exception {
        Integer  index_integer;

        index_integer = new Integer(article_index);

        articles.add((Object)index_integer);
    }

    public void replaceArticle(int index, int article_index) throws Exception {
        Integer  index_integer;

        index_integer = new Integer(article_index);
        if (index < 0 || index >= articles.size()) {
            String message;
            Exception  exception_object;
            message = getMessage(
                ARGUMENT_PARAMETER_EXCEPTION,
                ARGUMENT_PARAMETER_EXCEPTION);
            exception_object = new Exception( message );
            throw exception_object;
        }
        articles.set(index, (Object)index_integer);
    }

    public void removeArticle(int index) throws Exception {
        if (index < 0 || index >= articles.size()) {
            String message;
            Exception  exception_object;
            message = getMessage(
                ARGUMENT_PARAMETER_EXCEPTION,
                ARGUMENT_PARAMETER_EXCEPTION);
            exception_object = new Exception( message );
            throw exception_object;
        }
        articles.remove(index);
    }

    public void insertArticle(int index, int article_index) throws Exception {
        Integer  index_integer;

        if (index < 0) {
            String message;
            Exception  exception_object;
            message = getMessage(
                ARGUMENT_PARAMETER_EXCEPTION,
                ARGUMENT_PARAMETER_EXCEPTION);
            exception_object = new Exception( message );
            throw exception_object;
        }
        index_integer = new Integer(article_index);

        articles.add(index, (Object)index_integer);
    }

    public int size() {
        return articles.size();
    }

    public int getArticleIndex(int index) throws Exception {
        Integer  index_integer;

        if (index < 0 || index >= articles.size()) {
            String message;
            Exception  exception_object;
            message = getMessage(
                ARGUMENT_PARAMETER_EXCEPTION,
                ARGUMENT_PARAMETER_EXCEPTION);
            exception_object = new Exception( message );
            throw exception_object;
        }
        index_integer = (Integer)articles.get(index);
        return index_integer.intValue();
    }

    public static void main(String[] args) {
        ReportEntry   report_entry;

        report_entry = new ReportEntry();
    }
}
