/**
 * Copyright (C) All rights reserved.
 *
 * @Module     ReportRegionTest.java
 * @Author     Takahiko Tanaka.
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    1.0 2013/02/19
 *
 */

package exec;

import java.lang.*;
import java.io.*;
import java.util.*;


public class ReportRegionTest extends ReportRegion {
    private static String CASE_1_TEST = "Test1";
    private static String CASE_2_TEST = "Test2";
    private static String CASE_3_TEST = "Test3";
    private static String CASE_4_TEST = "Test4";
    private static String CASE_5_TEST = "Test5";
    private static String CASE_6_TEST = "Test6";
    private static String CASE_7_TEST = "Test7";
    private static String CASE_1_FILE = "Report.20110101";
    private static String CASE_2_FILE = "Report.20110201";
    private static String REPORT_TAG_1 = "<顧客>,<仕事>";
    private static String REPORT_TAG_2 = "<仕事>,<顧客>";
    private static String REPORT_TAG_3 = "<顧客>";
    private static String REPORT_TAG_4 = "<仕事>";

    private static String PARAMETER_ERROR_MESSAGE = "Parameter error";

    public void Test1(String[] args) {
        Object[]         object_array;
        FileInputStream  file_input_stream1;
        FileInputStream  file_input_stream2;
        PrintStream      print_stream;

        if (getDebug() > 0 && getLogPrintStream() != null) {
            String   message_log;
            message_log = getMessage(ENTER_METHOD, ENTER_METHOD, 
                    SPACE, CASE_1_TEST);
            getLogPrintStream().printLogln( message_log );
        }
        print_stream = new PrintStream(System.out);
        try {
            file_input_stream1 = new FileInputStream(getCommonPath(CASE_1_FILE));
            file_input_stream2 = new FileInputStream(getCommonPath(CASE_2_FILE));
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
        object_array = new Object[3];
        object_array[0] = REPORT_TAG_1;
        object_array[1] = file_input_stream1;
        object_array[2] = file_input_stream2;
        try {
            makeReport(object_array , print_stream);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }

    public void Test2(String[] args) {
        Object[]         object_array;
        FileInputStream  file_input_stream1;
        FileInputStream  file_input_stream2;
        PrintStream      print_stream;

        if (getDebug() > 0 && getLogPrintStream() != null) {
            String   message_log;
            message_log = getMessage(ENTER_METHOD, ENTER_METHOD, 
                    SPACE, CASE_2_TEST);
            getLogPrintStream().printLogln( message_log );
        }
        print_stream = new PrintStream(System.out);
        try {
            file_input_stream1 = new FileInputStream(getCommonPath(CASE_1_FILE));
            file_input_stream2 = new FileInputStream(getCommonPath(CASE_2_FILE));
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
        object_array = new Object[3];
        object_array[0] = REPORT_TAG_1;
        object_array[1] = file_input_stream1;
        object_array[2] = file_input_stream2;
        try {
            getRegions(object_array, print_stream);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }

    public void Test3(String[] args) {
        Object[]         object_array;
        FileInputStream  file_input_stream1;
        FileInputStream  file_input_stream2;
        PrintStream      print_stream;

        if (getDebug() > 0 && getLogPrintStream() != null) {
            String   message_log;
            message_log = getMessage(ENTER_METHOD, ENTER_METHOD, 
                    SPACE, CASE_3_TEST);
            getLogPrintStream().printLogln( message_log );
        }
        print_stream = new PrintStream(System.out);
        try {
            file_input_stream1 = new FileInputStream(getCommonPath(CASE_1_FILE));
            file_input_stream2 = new FileInputStream(getCommonPath(CASE_2_FILE));
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
        object_array = new Object[3];
        object_array[0] = REPORT_TAG_2;
        object_array[1] = file_input_stream1;
        object_array[2] = file_input_stream2;
        try {
            makeReport(object_array , print_stream);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }

    public void Test4(String[] args) {
        Object[]         object_array;
        FileInputStream  file_input_stream1;
        FileInputStream  file_input_stream2;
        PrintStream      print_stream;

        if (getDebug() > 0 && getLogPrintStream() != null) {
            String   message_log;
            message_log = getMessage(ENTER_METHOD, ENTER_METHOD, 
                    SPACE, CASE_4_TEST);
            getLogPrintStream().printLogln( message_log );
        }
        print_stream = new PrintStream(System.out);
        try {
            file_input_stream1 = new FileInputStream(getCommonPath(CASE_1_FILE));
            file_input_stream2 = new FileInputStream(getCommonPath(CASE_2_FILE));
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
        object_array = new Object[3];
        object_array[0] = REPORT_TAG_2;
        object_array[1] = file_input_stream1;
        object_array[2] = file_input_stream2;
        try {
            getRegions(object_array, print_stream);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }

    public void Test5(String[] args) {
        Object[]         object_array;
        FileInputStream  file_input_stream1;
        FileInputStream  file_input_stream2;
        PrintStream      print_stream;

        if (getDebug() > 0 && getLogPrintStream() != null) {
            String   message_log;
            message_log = getMessage(ENTER_METHOD, ENTER_METHOD, 
                    SPACE, CASE_5_TEST);
            getLogPrintStream().printLogln( message_log );
        }
        print_stream = new PrintStream(System.out);
        try {
            file_input_stream1 = new FileInputStream(getCommonPath(CASE_1_FILE));
            file_input_stream2 = new FileInputStream(getCommonPath(CASE_2_FILE));
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
        object_array = new Object[3];
        object_array[0] = REPORT_TAG_3;
        object_array[1] = file_input_stream1;
        object_array[2] = file_input_stream2;
        try {
            getRegions(object_array, print_stream);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }

    public void Test6(String[] args) {
        Object[]         object_array;
        FileInputStream  file_input_stream1;
        FileInputStream  file_input_stream2;
        PrintStream      print_stream;

        if (getDebug() > 0 && getLogPrintStream() != null) {
            String   message_log;
            message_log = getMessage(ENTER_METHOD, ENTER_METHOD, 
                    SPACE, CASE_6_TEST);
  
            getLogPrintStream().printLogln( message_log );
        }

        print_stream = new PrintStream(System.out);
        try {
            file_input_stream1 = new FileInputStream(getCommonPath(CASE_1_FILE));
            file_input_stream2 = new FileInputStream(getCommonPath(CASE_2_FILE));
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
        object_array = new Object[3];
        object_array[0] = REPORT_TAG_4;
        object_array[1] = file_input_stream1;
        object_array[2] = file_input_stream2;
        try {
            getRegions(object_array, print_stream);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }

    public void Test7(String[] args) {
        String message;

        if (getDebug() > 0 && getLogPrintStream() != null) {
            message = getMessage(ENTER_METHOD, ENTER_METHOD, SPACE, CASE_7_TEST);
            getLogPrintStream().printLogln( message );

            try {
                execute(args);
            } catch (Exception exception_object) {
                exception_object.printStackTrace();
                message = getMessage(END_METHOD, END_METHOD, SPACE, CASE_7_TEST);
                getLogPrintStream().printLogln( message );
                return;
            }

            message = getMessage(END_METHOD, END_METHOD, SPACE, CASE_7_TEST);
            getLogPrintStream().printLogln( message );
        }
    }
}
