/**
 * Copyright (C) All rights reserved.
 *
 * @Module     ReportSearch.java
 * @Author     Takahiko Tanaka.
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    1.0 2012/10/04
 *
 */

package exec;

import java.lang.*;
import java.io.*;

public class ReportSearch extends ReportRegion {

    public int doSearch(String tag_string, IndexCard report_card) 
        throws Exception {
        int         tag_index;
        ReportEntry report_entry;
        String[]    param_tags;
        String[]    local_tags;
        String      local_tag_string;
        String      message;

        if (tag_string == null || report_card == null) {
            Exception   exception_object;
            message = getMessage( ARGUMENT_PARAMETER_EXCEPTION,
                ARGUMENT_PARAMETER_EXCEPTION );
            exception_object = new Exception( message );
            throw exception_object;
        }
        try {
            param_tags = (String[])OperateReport.getTags(tag_string);
        } catch (Exception exception_object) {
            throw exception_object;
        }
        for (int i = 0; i < report_card.size(); i++) {
            report_entry = (ReportEntry)report_card.get(i);

            local_tag_string = report_entry.getTagString();
            try {
                local_tags = (String[])OperateReport.getTags(local_tag_string);
            } catch (Exception exception_object) {
                throw exception_object;
            }
            for (tag_index = 0; tag_index < local_tags.length; tag_index++) {
                if (TagString.compareTag(local_tags[tag_index], 
                            param_tags[tag_index]) != true) {
                    break;
                }
            }
            if (tag_index == local_tags.length) {
                return report_entry.getNumber();
            }
        }
        Exception  exception_object;
        message = getMessage( NOT_FOUND_ENTRY_EXCEPTION,
                NOT_FOUND_ENTRY_EXCEPTION );
        exception_object = new Exception( message );
        throw exception_object;
    }
}

