/**
 * Copyright (C) All rights reserved.
 *
 * @Module:    Rule.java
 * @Author:    Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version:   1.0 2013/05/15 
 *
 */

package exec;

import java.lang.*;
import java.lang.reflect.*;
import java.io.*;
import java.net.*;
import java.util.*;

public class Rule extends DebugObject {
    private static String SPACE_SEPARATOR = " ";
    private static String DOT_SEPARATOR = ".";
    private static String PARAMETER_ERROR = "Parameter error.";

    private StringObject string_object = null;

    public Rule() {
    }

    public boolean checkRuleCommand(String command) throws Exception {
        int      idx;
        Class    class_instance;
        Class    string_class;
        Class[]  param_class;
        String   class_name;
        String   method_name;
        String   parameter;
        Method   method_instance;

        if (command == null) {
            Exception   exception_object;
            exception_object = new Exception(PARAMETER_ERROR);
            throw exception_object;
        } 
        idx = command.lastIndexOf(DOT_SEPARATOR);
        if (idx < 0) {
            Exception   exception_object;
            exception_object = new Exception(PARAMETER_ERROR);
            throw exception_object;
        }
        class_name = command.substring(0, idx);
        method_name = command.substring(idx+1);
        try {
            class_instance = Class.forName(class_name); 
        } catch (Exception exception_object) {
            return false;
        }
        param_class = new Class[1];
        parameter = new String();
        string_class = parameter.getClass();
        param_class[0] = string_class;
        try {
            method_instance = class_instance.getMethod(
                    method_name, param_class);
        } catch (Exception exception_object) {
            return false;
        }
        return true;
    }

    public String getOperand(String line) throws Exception {
        int     index;
        String  operand;

        if (line == null) {
            Exception   exception_object;
            exception_object = new Exception(PARAMETER_ERROR);
            throw exception_object;
        }
        index = line.indexOf(SPACE_SEPARATOR);
        if (index > 0) {
            operand = line.substring(index+1);
            operand = operand.trim();
            return operand;
        }
        Exception  exception_object;
        exception_object = new Exception(PARAMETER_ERROR);
        throw exception_object;
    }

    public String getCommand(String line) throws Exception {
        int     index;
        String  command;
        String  operand;

        if (line == null) {
            Exception   exception_object;
            exception_object = new Exception(PARAMETER_ERROR);
            throw exception_object;
        }
        index = line.indexOf(SPACE_SEPARATOR);
        if (index > 0) {
            command = line.substring(0, index);
            return command;
        }
        Exception  exception_object;
        exception_object = new Exception(PARAMETER_ERROR);
        throw exception_object;
    }

    public void readRules(String file_name) throws Exception {
        boolean            flag;
        String             line;
        String             command;
        String             operand;
        FileInputStream    file_input_stream;
        DataInputStream    data_input_stream;

        try {
            file_input_stream = new FileInputStream(file_name);
            data_input_stream = new DataInputStream(file_input_stream);
        } catch (Exception exception_object) {
            throw exception_object;
        }
        if (string_object == null) {
            string_object = new StringObject();
        }
        while (true) {
            try {
                line = data_input_stream.readLine();
            } catch (Exception exception_object) {
                throw exception_object;
            }
            if (line == null) {
                break;
            }
            try {
                command = getCommand(line);
                operand = getOperand(line);
            } catch (Exception exception_object) {
                throw exception_object;
            }
            try {
                flag = checkRuleCommand(command);
            } catch (Exception exception_object) {
                throw exception_object;
            }
            if (flag == false) {
                continue;
            }
            string_object.add(command, operand);
        }
    }

/**
    public String executeRules(String message) throws Exception {
        int      size;
        String   return_message;
        String   command;
        String   operand;

        size = string_object.size();
        for (int i = 0; i < size; i++) {
            command = string_object.getKey(i);
            operand = string_object.getMessage(i);

            try {
           
            } catch (Exception exception_object) {
            }
        }
    }
**/

/**
    public String executeRule(String command, String operand, String message) throws Exception {
        ByteArrayInputStream   byte_array_input_stream;
    }

    public static void main(String[] args) {
        Rule   rule_object;

        try {
        } catch (Exception exception_object) {
        }
    }
**/
}

