/**
 * Copyright (C) All rights reserved.
 *
 * @Module     SearchRegionTest.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    1.0 2013/04/04
 *
 */

package exec;

import java.lang.*;
import java.io.*;
import java.util.*;

public class SearchRegionTest extends SearchRegion {
    private static String TEST1 = "Test1";
    private static String TEST2 = "Test2";

    public void Test1(String[] args) {
        String         word;
        String         message;
        Object[]       obj;
        FileInputStream    file_input_stream;

        if (getDebug() > 0 && getLogPrintStream() != null) {
            message = getMessage(ENTER_METHOD, ENTER_METHOD, SPACE, TEST1);
            getLogPrintStream().printLogln( message );

            if (args.length < 3) {
                message = getMessage(DEBUG_VALUE_KEY, DEBUG_VALUE_KEY, 
                    SPACE, String.valueOf(args.length));
                getLogPrintStream().printLogln( message );
                message = getMessage(END_METHOD, END_METHOD, SPACE, TEST1);
                getLogPrintStream().printLogln( message );
                return;
            }
            word = args[0];
            obj = new Object[args.length-1];
            obj[0] = (String)args[1];
            for (int i = 2; i < args.length; i++) {
                try {
                    file_input_stream = new FileInputStream( args[i] );
                } catch (Exception exception_object) {
                    exception_object.printStackTrace();
                    message = getMessage(END_METHOD, END_METHOD, SPACE, TEST1);
                    getLogPrintStream().printLogln( message );
                    return;
                }
                obj[i-1] = (Object)file_input_stream;
            }

            setWord(word);
            try {
                makeReport(obj , getLogPrintStream().getPrintStream());
            } catch (Exception exception_object) {
                exception_object.printStackTrace();
                message = getMessage(END_METHOD, END_METHOD, SPACE, TEST1);
                getLogPrintStream().printLogln( message );
                return;
            }

            message = getMessage(END_METHOD, END_METHOD, SPACE, TEST1);
            getLogPrintStream().printLogln( message );
        }
    }

    public void Test2(String[] args) {
        String   word;
        String   message;
        String[] org_args;
 
        if (getDebug() > 0 && getLogPrintStream() != null) {
            message = getMessage(ENTER_METHOD, ENTER_METHOD, SPACE, TEST2);
            getLogPrintStream().printLogln( message );

            word = args[0];
            org_args = new String[args.length-1];
            for (int i = 0; i < org_args.length; i++) {
                org_args[i] = args[i+1];
            }
            setWord(word);
            try {
                execute(org_args);
            } catch (Exception exception_object) {
                exception_object.printStackTrace();
                message = getMessage(END_METHOD, END_METHOD, SPACE, TEST2);
                getLogPrintStream().printLogln( message );
                return;
            }

            message = getMessage(END_METHOD, END_METHOD, SPACE, TEST2);
            getLogPrintStream().printLogln( message );
        }
    }
}
