/**
 * Copyright (C) All rights reserved.
 *
 * @Module:    SortRegion.java
 * @Author:    Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version:   1.0 2011/05/30
 *
 */
package exec;

import java.lang.*;
import java.io.*;
import java.net.*;
import java.util.*;

public class SortRegion extends RegionObject implements MakeReport {

    private static String SORT_REGION = "SortRegion";
    private static String MAKEREPORT_METHOD = "makeReport";
    private static String MAKEMESSAGETABLE_METHOD = "makeMessageTable";
    private static String NEXTCONTENT_METHOD = "nextContent";
    private static String EXECUTE = "execute";

    public static String CURRENT_IS_TOP = "No parent.";
    public static String SORT_ERROR = "Couldn't sort";
    public static String PARAMETER_ERROR = "Parameter error";
/**
    private int                   region_index = 0;
    private ReportRegion[]        report_region = new ReportRegion[0];
**/
    private static boolean duplication_mode = false;

    private int REGION_UNIT = 10;
    private int debug_level = 0;

    private String[]              keys_table    = new String[0];
    private String[]              message_table = new String[0];
    private int                   message_index = 0;
    public int MESSAGE_TABLE_UNIT = 16;

    private  JapaneseMatch  japanese_match_object;

    public boolean checkDuplication() {
        return duplication_mode;
    }

    public boolean enableDuplication() {
        boolean previous_state;

        previous_state = duplication_mode;
        duplication_mode = true;
        return previous_state;
    }

    public boolean disableDuplication() {
        boolean previous_state;

        previous_state = duplication_mode;
        duplication_mode = false;
        return previous_state;
    }

    public void makeMessageTable(Object[] argument) throws Exception {
        byte[]                 return_byte;
        String                 buffer;
        ByteArrayOutputStream  byte_array_output_stream;
        PrintStream            print_stream;
        PrintStream            print_stream_object;
        InputStream            system_input;
        String[]               tag_list1;
        String[]               tag_list2;
        ReportRegion           bk_region;
        String                 tag_keys;
        String                 keys;
        String                 subkeys;
        String                 message;
        String                 message_log;
        Region[]               region_object;
        StringTokenizer        stk;
        int                    list_index;
        int                    object_count;
        int                    new_count;
        int                    tab_count;
        String[]               list;
        boolean                check;
        String                 tags;
        ReportRegion[]         merge_object;
        ReportRegion           report_region_object;

        int      length_index;
        int      length_int;
        int      unknown_index;
        int      unknown_int;
        String   length_string;
        String   unknown_string;
        String   unknown_tags;
        String   remain;
        String    unknown_message;
        KeyList   unknown_key_list;
        String    unknown_key_list_string;

        system_input = System.in;

        japanese_match_object = new JapaneseMatch();

        if (argument == null || argument.length <= 1) {
            Exception  exception_object;
            message = getMessage( ARGUMENT_PARAMETER_EXCEPTION, 
                ARGUMENT_PARAMETER_EXCEPTION );
            exception_object = new Exception(message);
            throw exception_object;
        }

/***
        tags = (String)argument[0];
        merge_object = new ReportRegion[argument.length-1];
        for (int i = 1; i < argument.length; i++) {
            merge_object[i-1] = new ReportRegion();
            if ((argument[i] instanceof InputStream) == false) {
                merge_object[i-1].setCurrentInputStream(null);
                continue;
            }
            merge_object[i-1].setCurrentInputStream(
                (InputStream)argument[i]);
        }
**/

        report_region_object = new ReportRegion();
        tab_count = 0;
        new_count = 0;

        while (true) {
            try {
/****
                message = report_region_object.nextRegion(tags, merge_object);
****/
                message = report_region_object.makeReportBody(argument, null);
            } catch (Exception exception_object) {
                throw exception_object;
            }
            if (message == null) {
                break;
            }
            tag_keys = null;
            unknown_tags = new String();

            length_index = message.indexOf(SPACE);
            if (length_index >= 0) {
                length_string = message.substring(0, length_index);
                length_int = Integer.valueOf(length_string).intValue();

                tag_keys = message.substring(length_index+1, 
                    length_int+length_index+1);
                remain = message.substring(length_int+1+length_index+1);
                unknown_index = remain.indexOf(SPACE);
                if (unknown_index >= 0) {
                    unknown_string = remain.substring(0, unknown_index);
                    unknown_int = Integer.valueOf(unknown_string).intValue(); 
                    unknown_tags = remain.substring(unknown_index+1,
                        unknown_int+unknown_index+1);
                    message = remain.substring(unknown_int+unknown_index+1);
                }
            }
/**
            byte_array_output_stream = new ByteArrayOutputStream();
            print_stream_object = new PrintStream(byte_array_output_stream);

            if (unknown_tags != null && unknown_tags.length() > 0) {
                try {
                    unknown_key_list = KeyListFactory.createKeyList(
                        unknown_tags, COMMA,
                    getMessageResource(),
                    getDebug(),
                    getLogPrintStream());
                } catch (Exception exception_object_key) {
                    throw exception_object_key;
                }
                for (int k = 0; k < unknown_key_list.length(); k++) {
                    try {
                        unknown_key_list_string 
                            = unknown_key_list.getKeyEntry(k);
                    } catch (Exception exception_object_key) {
                        exception_object_key;
                    }
                    new_count = ReportRegion.printStartTag(print_stream_object, 
                        tab_count, unknown_key_list_string);
                    if (new_count != -1) {
                        tab_count = new_count;
                    }
                }
            }
            message = new String(
                byte_array_output_stream.toByteArray()) + message;

            byte_array_output_stream = new ByteArrayOutputStream();
            print_stream_object = new PrintStream(byte_array_output_stream);

            if (unknown_tags != null && unknown_tags.length() > 0) {
                try {
                    unknown_key_list = KeyListFactory.createKeyList(
                        unknown_tags, COMMA,
                    getMessageResource(),
                    getDebug(),
                    getLogPrintStream());
                } catch (Exception exception_object_key) {
                    throw exception_object_key;
                }
                for (int k = unknown_key_list.length()-1; k >= 0; k--) {
                    try {
                        unknown_key_list_string 
                            = unknown_key_list.getKeyEntry(k);
                    } catch (Exception exception_object_key) {
                        continue;
                    }
                    new_count = ReportRegion.printEndTag(print_stream_object, 
                        tab_count, unknown_key_list_string);
                    if (new_count != -1) {
                        tab_count = new_count;
                    }
                }
            }
            message = message.concat(new String(
                byte_array_output_stream.toByteArray()) );
**/
            if (message_index >= message_table.length) {
                String[]    bk_message;
                String[]    bk_keys;
                bk_message = new String[message_table.length
                    + MESSAGE_TABLE_UNIT];
                bk_keys = new String[keys_table.length
                    + MESSAGE_TABLE_UNIT];
                for (int l = 0; l < message_table.length; l++) {
                    bk_message[l] = message_table[l];
                    bk_keys[l] = keys_table[l];
                }
                keys_table = bk_keys;
                message_table = bk_message;
            }
            try {
                japanese_match_object.add(
                    tag_keys+COMMA+unknown_tags);
            } catch (Exception string_base_exception_object) {
                throw string_base_exception_object;
            }
            keys_table[message_index] = tag_keys+COMMA+unknown_tags;
            message_table[message_index] = message;
            message_index = message_index + 1;
        }
    }

    public void makeReport(Object[] argument, PrintStream print_stream) throws Exception {
        byte[]                 return_byte;
        String                 buffer;
        ByteArrayOutputStream  byte_array_output_stream;
        InputStream            system_input;
        String[]               tag_list1;
        String[]               tag_list2;
        ReportRegion           bk_region;
        String                 tag_keys;
        String                 keys;
        String                 message;
        String                 message_log;
        Region[]               region_object;
        StringTokenizer        stk;
        int                    list_index;
        int                    object_count;
        String[]               list;
        String                 lang;

        if (getDebug() > 0) {
            message_log = getMessage(ENTER_METHOD, ENTER_METHOD,
                SPACE, MAKEREPORT_METHOD);
            if (getLogPrintStream() == null) {
                setLogPrintStream( new LogPrintStream(System.err) );
            }
            getLogPrintStream().printLogln(message_log);
        }
        if (argument == null || argument.length <= 1) {
            Exception exception_object;

            message = getMessage( ARGUMENT_PARAMETER_EXCEPTION, 
                ARGUMENT_PARAMETER_EXCEPTION,
                getMessageResource().getMessage(
                BLANK_IN_BLANK), SORT_REGION);
            exception_object = new Exception(message);
            throw exception_object;
        }
        if (print_stream == null) {
            Exception exception_object;

            message = getMessage( STREAM_PARAMETER_EXCEPTION, 
                STREAM_PARAMETER_EXCEPTION,
                getMessageResource().getMessage(
                BLANK_IN_BLANK), SORT_REGION);
            exception_object = new Exception(message);
            throw exception_object;
        }

        system_input = System.in;
        if (getDebug() > 0 && getLogPrintStream() != null) {
            message_log = getMessage(DEBUG_CALL_KEY, DEBUG_CALL_KEY,
                SPACE, MAKEMESSAGETABLE_METHOD,
                getMessageResource().getMessage(DEBUG_CODE_001)); 
            getLogPrintStream().printLogln(message_log);
        }

        try {
            makeMessageTable(argument);
        } catch (Exception real_exception_object) {
            String    exception_message;
            Exception exception_object;

            exception_message = real_exception_object.getMessage();
            message = getMessage( INTERNAL_ERROR_EXCEPTION, 
                INTERNAL_ERROR_EXCEPTION,
                exception_message );

            exception_object = new Exception(message);
            throw exception_object;
        }
        int  index;
        int  sub_index;

        for (int i = 0; i < message_index; i++) {
            try {
                index = japanese_match_object.getPosition(i);
            } catch (Exception exception_object) {
                break;
            }
            keys = keys_table[index];
            buffer = message_table[index];
            
            list_index = 0;
            stk = new StringTokenizer(keys, COMMA);
            list = new String[stk.countTokens()];
            while (stk.hasMoreTokens()) {
                list[list_index] = stk.nextToken();
                list_index = list_index + 1;
            }

            for (int j = 0; j < list.length; j++) {
                for (int k = 0; k < j; k++) {
                    print_stream.print(TAB_SPACE);
                }
                print_stream.println(list[j]);
            }
            print_stream.println(buffer);
            for (int j = 0; j < list.length; j++) {
                for (int k = list.length-j-1; k > 0; k--) {
                    print_stream.print(TAB_SPACE);
                }
                print_stream.println(
                    convertFromStartToEnd(list[list.length-j-1]));
            }
        }
        if (getDebug() > 0 && getLogPrintStream() != null) {
            message_log = getMessage(END_METHOD, END_METHOD,
                SPACE, MAKEREPORT_METHOD);
            getLogPrintStream().printLogln(message_log);
        }
        return;
    }

    public int getMessageNumber() {
        return message_index;
    }

    public String getMessageInOrder(int order) throws Exception {
        int     index;
        String  buffer;

        try {
            index = japanese_match_object.getPosition(order);
        } catch (Exception exception_object) {
            throw exception_object;
        }
        buffer = message_table[index];
        return buffer;
    }

    public String getTagStringInOrder(int order) throws Exception {
        int     index;
        String  keys;

        try {
            index = japanese_match_object.getPosition(order);
        } catch (Exception exception_object) {
            throw exception_object;
        }

        keys = keys_table[index];
        return keys;
    }

    public void execute(String[] org_args) throws Exception {
        String           message;
        PrintStream      print_stream;

        if (getDebug() > 0 && getLogPrintStream() != null) {
            message = getMessage(ENTER_METHOD, ENTER_METHOD, SPACE, EXECUTE);
            getLogPrintStream().printLogln( message );
        }
        print_stream = System.out;
        try {
            super.execute(org_args, print_stream, (MakeReport)this);
        } catch (Exception real_exception_object) {
            throw real_exception_object; 
        }
        if (getDebug() > 0 && getLogPrintStream() != null) {
            message = getMessage(ENTER_METHOD, ENTER_METHOD, SPACE, EXECUTE);
            getLogPrintStream().printLogln( message );
        }
    }

    public static void main(String[] args) {
        String[]        string_args;
        SortRegion      sort_region;
        byte[]          report_byte;
        String          message;
        String          lang;
        FileOutputStream  file_output_stream;
        PrintStream       print_stream;
        String            debug_string;

        sort_region = new SortRegion();
        debug_string = System.getProperty(EXEC_REGION_DEBUG);
        if (debug_string == null || debug_string.length() == 0) {
            debug_string = System.getProperty(DEBUG_LEVEL_KEY);
        }
        if (debug_string != null && debug_string.length() > 0) {
            sort_region.setDebug(debug_string);
        }
        sort_region.setLogPrintStream( new LogPrintStream( System.err ) );

        report_byte = new byte[0];

        if (args.length <= 0) {
            message = sort_region.getMessage( ARGUMENT_PARAMETER_EXCEPTION,
                ARGUMENT_PARAMETER_EXCEPTION,
                sort_region.getMessageResource().getMessage(
                    BLANK_IN_BLANK),
                SORT_REGION);
            System.out.println(message);
            return;
        }
        string_args = new String[args.length];
        for (int i = 0; i < args.length; i++) {
            string_args[i] = args[i];
        }
        try {
            print_stream = System.out;
        } catch (Exception exception_object) {
            message = exception_object.getMessage();
            if (message == null) {
                message = sort_region.getMessage( IO_ERROR_EXCEPTION, 
                    IO_ERROR_EXCEPTION,
                    sort_region.getMessageResource().getMessage(
                        BLANK_IN_BLANK), SORT_REGION);
            }
            System.exit(1);
            return;
        }

        try {
            sort_region.execute(string_args);
        } catch (Exception exception_object) {
            message = exception_object.getMessage();
            if (message == null) {
                message = sort_region.getMessage( INTERNAL_ERROR_EXCEPTION, 
                    INTERNAL_ERROR_EXCEPTION,
                    sort_region.getMessageResource().getMessage(
                        BLANK_IN_BLANK), SORT_REGION);
            }
            System.err.println(message);
            System.exit(1);
        }
    }
}
