/**
 * Copyright (C) All rights reserved.
 *
 * @Module     StringObject.java from OServ
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2011/11/25
 *
 */

package exec;

import java.lang.*;
import java.io.*;
import java.util.*;

public class StringObject extends Object implements Serializable {
    private ArrayList keys = new ArrayList();
    private ArrayList messages = new ArrayList();

    private final static String NOT_FOUND_ERROR = "Not found";
    private final static String INTERNAL_ERROR_EXCEPTION
        = "Internal Error Exception.";

    public void add (String key, String message)  {
        if (key == null || message == null) {
            return;
        }
        keys.add((Object)key);
        messages.add((Object)message);
    }

    public String remove(int index) throws Exception {
        String message_string;
        if (keys == null) {
            Exception exception_object;
            exception_object = new Exception(INTERNAL_ERROR_EXCEPTION);
            throw exception_object;
        }
        if (keys.size() <= index) {
            Exception exception_object;
            exception_object = new Exception(NOT_FOUND_ERROR);
            throw exception_object;
        }
        message_string = (String)messages.get(index);
        keys.remove(index);
        messages.remove(index);
        return message_string;
    }

    public String getKey(int index) throws Exception {
        String   key_string;

        if (keys == null) {
            Exception exception_object;
            exception_object = new Exception(INTERNAL_ERROR_EXCEPTION);
            throw exception_object;
        }
        if (keys.size() <= index) {
            Exception exception_object;
            exception_object = new Exception(NOT_FOUND_ERROR);
            throw exception_object;
        }
        key_string = (String)keys.get(index);
        return key_string;
    }

    public String getMessage(int index) throws Exception {
        String   message_string;

        if (messages == null) {
            Exception exception_object;
            exception_object = new Exception(INTERNAL_ERROR_EXCEPTION);
            throw exception_object;
        }
        if (messages.size() <= index) {
            Exception exception_object;
            exception_object = new Exception(NOT_FOUND_ERROR);
            throw exception_object;
        }
        message_string = (String)messages.get(index);
        return message_string;
    }

    public String getMessage(String key) throws Exception {
        String key_string;
        String message_string;

        if (key == null) {
            Exception exception_object;
            exception_object = new Exception(INTERNAL_ERROR_EXCEPTION);
            throw exception_object;
        }

        for (int i = 0; i < keys.size(); i++) {
            key_string = (String)keys.get(i);
            if (key_string == null || key_string.length() == 0) {
                continue;
            }
            if (key_string.compareTo(key) == 0) {
                message_string = (String)messages.get(i);
                return message_string;
            }
        }
        return key;
/**
        Exception exception_object;
        exception_object = new Exception(NOT_FOUND_ERROR);
        throw exception_object;
**/
    }

    public int size() {
        return keys.size();
    }
}
