/**
 * Copyright (C) All rights reserved.
 *
 * @Module     exec_jpn.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    1.0 2013/01/23
 */

package exec;

import  java.lang.*;

public class exec_jpn implements MessageText {
    private static String MESSAGE_LIST_SEPARATOR="=";
    private static String PRINT_ENTER_EXECUTE="メソッドexecute()が開始します。";
    private static String PARAMETER_KEY_JAPANESE = "パラメータ";
    private static String END_EXECUTE_JAPANESE="メソッドexecute()が終了します。";
    private static String ENTER_METHOD_JAPANESE="メソッドが開始します。";
    private static String END_METHOD_JAPANESE="メソッドが終了します。";

    private static String DEBUG_TAG_KEY_JAPANESE="タグ";
    private static String DEBUG_CALL_KEY_JAPANESE="呼び出します。";
    private static String DEBUG_START_KEY_JAPANESE="開始します。";
    private static String DEBUG_TRACE_KEY_JAPANESE="トレース";
    private static String DEBUG_EXCEPTION_KEY_JAPANESE="例外の発生";
    private static String DEBUG_ENABLE_KEY_JAPANESE="有効";
    private static String DEBUG_DISABLE_KEY_JAPANESE="無効";
    private static String DEBUG_DEBUG_KEY_JAPANESE = "デバッグ";
    private static String DEBUG_DEBUG_CONDITION_KEY_JAPANESE = "デバッグ状態";
    private static String DEBUG_VALUE_EXCEPTION_KEY_JAPANESE = "不正なdebugの値が指定されました。";
    private static String DEBUG_VALUE_KEY_JAPANESE = "値";
    private static String DEBUG_COUNT_KEY_JAPANESE = "カウント";

    private static String DEBUG_READ_OPERATION_KEY_JAPANESE
        = "読み込み操作";
    private static String DEBUG_WRITE_OPERATION_KEY_JAPANESE
        = "書き込み操作";


    private static String REACH_END_OF_FILE_JAPANESE = "ファイルの終わりに到達しました。";
    private static String REACH_END_OF_AREA_JAPANESE = "領域の終わりに到達しました。";

    private static String DEBUG_SETUP_MESSAGE_JAPANESE 
        = "デバッグ環境が設定されました。";

    private static String INVOKE_ERROR_EXCEPTION_JAPANESE
        = "呼び出し異常が発生しました。";
    private static String TAGKEYS_PARAMETER_ERROR_JAPANESE
        = "指定されたタグが異常です。";
    private static String OVERFLOW_INDEX_EXCEPTION_JAPANESE
        = "指定されたインデックスが範囲外です。";
    private static String ARGUMENT_PARAMETER_EXCEPTION_JAPANESE
        = "引数パラメータの異常を検出しました。";
    private static String INTERNAL_ERROR_EXCEPTION_JAPANESE
        = "内部異常を検出しました。";
    private static String IO_ERROR_EXCEPTION_JAPANESE
        = "入出力異常を検出しました。";
    private static String STREAM_PARAMETER_EXCEPTION_JAPANESE
        = "ストリームパラメータが異常です。";
    private static String TAG_PARAMETER_EXCEPTION_JAPANESE
        = "タグパラメータが異常です。";
    private static String WORD_PARAMETER_EXCEPTION_JAPANESE
        = "単語パラメータが異常です。";

    private static String INVALID_FILE_ERROR_EXCEPTION_JAPANESE
        = "無効なファイルが指定されました。";
    private static String FORMAT_ERROR_EXCEPTION_JAPANESE
        = "誤ったフォーマットです。";
    private static String DEBUG_READ_DATA_FROM_JAR_JAPANESE
        = "jarファイルからデータを読み込みました。";
    private static String ILLEGAL_DEBUG_VALUE_JAPANESE
        = "不正なデバッグレベルが設定されています。";
    private static String ASSERTION_EXCEPTION_JAPANESE
        = "論理的不整合を検出しました。";
    private static String ILLEGAL_KEY_EXCEPTION_JAPANESE
        = "不正なタグ文字列が指定されました。";
    private static String ILLEGAL_METHOD_EXCEPTION_JAPANESE
        = "不正なメソッドが呼び出されました。";
    private static String PROMPT_INPUT_FILE_JAPANESE
        = "入力ファイルを指定して下さい。";
    private static String NOT_FOUND_ENTRY_EXCEPTION_JAPANESE
        = "エントリが見つかりませんでした。";
    private static String REGION_ERROR_EXCEPTION_JAPANESE
        = "領域が見つかりませんでした。";
    private static String FILE_NOT_FOUND_EXCEPTION_JAPANESE
        = "が見つかりませんでした。";

    private static String BLANK_IN_BLANK_JAPANESE
        = "の中で";

    private static String DISPLAY_HIERARCHY_TITLE_MESSAGE_JAPANESE
        = "ファイル名";
    private static String FILE_WARNING_MESSAGE_JAPANESE = "ファイル名";

    private static String JAPANESE_WO="を";
    private static String JAPANESE_NO="の";
    private static String JAPANESE_HA="は";
    private static String JAPANESE_GAIZYOUDESU="が異常です。";
    private static String JAPANESE_DESU="です。";

    public String[] jpn = {
        DEBUG_READ_DATA_FROM_JAR+
            MESSAGE_LIST_SEPARATOR+
                DEBUG_READ_DATA_FROM_JAR_JAPANESE, 
        REACH_END_OF_FILE+
            MESSAGE_LIST_SEPARATOR+
                REACH_END_OF_FILE_JAPANESE, 
        REACH_END_OF_AREA+
            MESSAGE_LIST_SEPARATOR+
                REACH_END_OF_AREA_JAPANESE, 
        BLANK_IN_BLANK+
            MESSAGE_LIST_SEPARATOR+
                BLANK_IN_BLANK_JAPANESE, 
        REGION_ERROR_EXCEPTION+
            MESSAGE_LIST_SEPARATOR+
                REGION_ERROR_EXCEPTION_JAPANESE,
        PROMPT_INPUT_FILE+
            MESSAGE_LIST_SEPARATOR+
                PROMPT_INPUT_FILE_JAPANESE,
        INVALID_FILE_ERROR_EXCEPTION+
            MESSAGE_LIST_SEPARATOR+
                INVALID_FILE_ERROR_EXCEPTION_JAPANESE,
        ILLEGAL_KEY_EXCEPTION+
            MESSAGE_LIST_SEPARATOR+
                ILLEGAL_KEY_EXCEPTION_JAPANESE,
        ILLEGAL_METHOD_EXCEPTION+
            MESSAGE_LIST_SEPARATOR+
                ILLEGAL_METHOD_EXCEPTION_JAPANESE,
        FILE_NOT_FOUND_EXCEPTION+
            MESSAGE_LIST_SEPARATOR+
                FILE_NOT_FOUND_EXCEPTION_JAPANESE,
        FORMAT_ERROR_EXCEPTION+
            MESSAGE_LIST_SEPARATOR+
                FORMAT_ERROR_EXCEPTION_JAPANESE,
        ASSERTION_EXCEPTION+
            MESSAGE_LIST_SEPARATOR+
                ASSERTION_EXCEPTION_JAPANESE,
        ARGUMENT_PARAMETER_EXCEPTION+
            MESSAGE_LIST_SEPARATOR+
                ARGUMENT_PARAMETER_EXCEPTION_JAPANESE,
        INTERNAL_ERROR_EXCEPTION+
            MESSAGE_LIST_SEPARATOR+
                INTERNAL_ERROR_EXCEPTION_JAPANESE,
        STREAM_PARAMETER_EXCEPTION+
            MESSAGE_LIST_SEPARATOR+
                STREAM_PARAMETER_EXCEPTION_JAPANESE,
        TAG_PARAMETER_EXCEPTION+
            MESSAGE_LIST_SEPARATOR+
                TAG_PARAMETER_EXCEPTION_JAPANESE,
        WORD_PARAMETER_EXCEPTION+
            MESSAGE_LIST_SEPARATOR+
                WORD_PARAMETER_EXCEPTION_JAPANESE,
        IO_ERROR_EXCEPTION+
            MESSAGE_LIST_SEPARATOR+
                IO_ERROR_EXCEPTION_JAPANESE,
        ILLEGAL_DEBUG_VALUE+
            MESSAGE_LIST_SEPARATOR+
                ILLEGAL_DEBUG_VALUE_JAPANESE,

        ENTER_EXECUTE+
            MESSAGE_LIST_SEPARATOR+
                PRINT_ENTER_EXECUTE, 
        PARAMETER_KEY+
            MESSAGE_LIST_SEPARATOR+
                PARAMETER_KEY_JAPANESE,
        END_EXECUTE+
            MESSAGE_LIST_SEPARATOR+
                END_EXECUTE_JAPANESE,
        ENTER_METHOD+
            MESSAGE_LIST_SEPARATOR+
                ENTER_METHOD_JAPANESE, 
        END_METHOD+
            MESSAGE_LIST_SEPARATOR+
                END_METHOD_JAPANESE,

        DISPLAY_HIERARCHY_TITLE_MESSAGE+
            MESSAGE_LIST_SEPARATOR+
                DISPLAY_HIERARCHY_TITLE_MESSAGE_JAPANESE,
        FILE_WARNING_MESSAGE+
            MESSAGE_LIST_SEPARATOR+
                FILE_WARNING_MESSAGE_JAPANESE,
        INVOKE_ERROR_EXCEPTION+
            MESSAGE_LIST_SEPARATOR+
                INVOKE_ERROR_EXCEPTION_JAPANESE,
        OVERFLOW_INDEX_EXCEPTION+
            MESSAGE_LIST_SEPARATOR+
                OVERFLOW_INDEX_EXCEPTION_JAPANESE,
        TAGKEYS_PARAMETER_ERROR+
            MESSAGE_LIST_SEPARATOR+
                TAGKEYS_PARAMETER_ERROR_JAPANESE,

        DEBUG_READ_OPERATION_KEY+
            MESSAGE_LIST_SEPARATOR+
                DEBUG_READ_OPERATION_KEY_JAPANESE,
        DEBUG_WRITE_OPERATION_KEY+
            MESSAGE_LIST_SEPARATOR+
                DEBUG_WRITE_OPERATION_KEY_JAPANESE,
        DEBUG_TAG_KEY+
            MESSAGE_LIST_SEPARATOR+
                DEBUG_TAG_KEY_JAPANESE,
        DEBUG_START_KEY+
            MESSAGE_LIST_SEPARATOR+
                DEBUG_START_KEY_JAPANESE,
        DEBUG_TRACE_KEY+
            MESSAGE_LIST_SEPARATOR+
                DEBUG_TRACE_KEY_JAPANESE,
        DEBUG_CALL_KEY+
            MESSAGE_LIST_SEPARATOR+
                DEBUG_CALL_KEY_JAPANESE,
        DEBUG_VALUE_KEY+
            MESSAGE_LIST_SEPARATOR+
                DEBUG_VALUE_KEY_JAPANESE,
        DEBUG_COUNT_KEY+
            MESSAGE_LIST_SEPARATOR+
                DEBUG_COUNT_KEY_JAPANESE,
        DEBUG_EXCEPTION_KEY+
            MESSAGE_LIST_SEPARATOR+
                DEBUG_EXCEPTION_KEY_JAPANESE,
        DEBUG_DEBUG_CONDITION_KEY+
            MESSAGE_LIST_SEPARATOR+
                DEBUG_DEBUG_CONDITION_KEY_JAPANESE,
        DEBUG_DEBUG_KEY+
            MESSAGE_LIST_SEPARATOR+
                DEBUG_DEBUG_KEY_JAPANESE,
        DEBUG_ENABLE_KEY+
            MESSAGE_LIST_SEPARATOR+
                DEBUG_ENABLE_KEY_JAPANESE,
        DEBUG_DISABLE_KEY+
            MESSAGE_LIST_SEPARATOR+
                DEBUG_DISABLE_KEY_JAPANESE,
        DEBUG_VALUE_EXCEPTION_KEY+
            MESSAGE_LIST_SEPARATOR+
                DEBUG_VALUE_EXCEPTION_KEY_JAPANESE,
        DEBUG_SETUP_MESSAGE+
            MESSAGE_LIST_SEPARATOR+
                DEBUG_SETUP_MESSAGE_JAPANESE,
        DEBUG_CODE_001+
            MESSAGE_LIST_SEPARATOR+
                JAPANESE_WO,
        DEBUG_CODE_002+
            MESSAGE_LIST_SEPARATOR+
                JAPANESE_NO,
        DEBUG_CODE_003+
            MESSAGE_LIST_SEPARATOR+
                JAPANESE_HA,
        DEBUG_CODE_004+
            MESSAGE_LIST_SEPARATOR+
                JAPANESE_DESU,
        CODE_101+
            MESSAGE_LIST_SEPARATOR+
                JAPANESE_GAIZYOUDESU,
    };
    public String[] format = {
        FILE_NOT_FOUND_EXCEPTION+
            MESSAGE_LIST_SEPARATOR+
                "2,0",
        ENTER_METHOD+
            MESSAGE_LIST_SEPARATOR+
                "2,1,0",
        END_METHOD+
            MESSAGE_LIST_SEPARATOR+
                "2,1,0",
        DEBUG_CALL_KEY+
            MESSAGE_LIST_SEPARATOR+
                "2,3,0",
        DEBUG_DEBUG_CONDITION_KEY+
            MESSAGE_LIST_SEPARATOR+
                "0,3,2,4",
        FILE_WARNING_MESSAGE+
            MESSAGE_LIST_SEPARATOR+
                "0,2,3",
        ARGUMENT_PARAMETER_EXCEPTION+
            MESSAGE_LIST_SEPARATOR+
                "2,1,0",
        STREAM_PARAMETER_EXCEPTION+
            MESSAGE_LIST_SEPARATOR+
                "2,1,0",
        INTERNAL_ERROR_EXCEPTION+
            MESSAGE_LIST_SEPARATOR+
                "2,1,0",
        IO_ERROR_EXCEPTION+
            MESSAGE_LIST_SEPARATOR+
                "2,1,0",
        DEBUG_TAG_KEY+
            MESSAGE_LIST_SEPARATOR+
                "0,1,2",
        DEBUG_VALUE_KEY+
            MESSAGE_LIST_SEPARATOR+
                "0,1,2",
        DEBUG_START_KEY+
            MESSAGE_LIST_SEPARATOR+
                "0,1,2",
        DEBUG_TRACE_KEY+
            MESSAGE_LIST_SEPARATOR+
                "0,1,2",
        REACH_END_OF_FILE+
            MESSAGE_LIST_SEPARATOR+
                "0",
        REACH_END_OF_AREA+
            MESSAGE_LIST_SEPARATOR+
                "0",
        DEBUG_SETUP_MESSAGE+
            MESSAGE_LIST_SEPARATOR+
                "0,1,2",
        DEBUG_READ_OPERATION_KEY+
            MESSAGE_LIST_SEPARATOR+
                "0,1,2",
        DEBUG_WRITE_OPERATION_KEY+
            MESSAGE_LIST_SEPARATOR+
                "0,1,2",
    };

}
