/**
 * Copyright (C) All rights reserved.
 *
 * @Module     Command.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2012/07/18
 *
 */

package odir;

import java.lang.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.security.*;

import javax.crypto.*;
import javax.crypto.spec.*;

public class Command extends Object {
    private static String des_key = "DES";
    private static String password_key = "?u:->X#!";

    private static MessageResource  message_resource = null;

    public Command() {
        Locale   locale_object;

        locale_object = Locale.getDefault();
        message_resource = new MessageResource();
        message_resource.setLanguage(locale_object.getISO3Language()); 
    }

    public static MessageResource  getMessageResource() {
        Locale   locale_object;

        if (message_resource == null) {
            message_resource = new MessageResource();
            locale_object = Locale.getDefault();
            message_resource.setLanguage(locale_object.getISO3Language()); 
        }
        return message_resource;
    }

    public static SealedObject getSealedPassword(String password) throws Exception {
        Cipher                     ci;
        SecretKeySpec              secret_key_spec;
        DESKeySpec                 des_key_spec;
        KeyFactory                 key_factory;
        PublicKey                  public_key;
        PrivateKey                 private_key;
        SealedObject               sealed_object;
        FileOutputStream           file_output_stream;
        ObjectOutputStream         object_output_stream;
        DirectoryServerException   directory_server_exception;

         try {
             ci = Cipher.getInstance(des_key);
         } catch (Exception exception_object) {
             directory_server_exception = new DirectoryServerException(
                getMessageResource().getFormattedMessage(
                    DirectoryServerException.JAVA_CIPHER_GET_INSTANCE_EXCEPTION,
                    getMessageResource().getMessage(
                        DirectoryServerException.JAVA_CIPHER_GET_INSTANCE_EXCEPTION)));
             throw directory_server_exception;
         }

         secret_key_spec = new SecretKeySpec(password_key.getBytes(), des_key);

         try {
             ci.init(Cipher.ENCRYPT_MODE, secret_key_spec);
         } catch (Exception exception_object) {
             directory_server_exception = new DirectoryServerException(
                getMessageResource().getFormattedMessage(
                    DirectoryServerException.JAVA_CIPHER_INIT_EXCEPTION,
                    getMessageResource().getMessage(
                        DirectoryServerException.JAVA_CIPHER_INIT_EXCEPTION)));
             throw directory_server_exception;
         }
         try {
             sealed_object = new SealedObject(password, ci);
         } catch (Exception exception_object) {
             directory_server_exception = new DirectoryServerException(
                getMessageResource().getFormattedMessage(
                    DirectoryServerException.JAVA_SEALED_OBJECT,
                    getMessageResource().getMessage(
                        DirectoryServerException.JAVA_SEALED_OBJECT)));
             throw directory_server_exception;
         }
         return sealed_object;
    }

    public static void main(String[]  args) {
    }
}
