/**
 * Copyright (C) All rights reserved.   
 *
 * @Module     DirectoryServerException.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    1.0 2012/07/19
 */

package odir;

import java.lang.*;
import java.net.*;

public class DirectoryServerException extends Exception {
    public static String BUSY_WAIT = "System is busy.";
    public static String OWNER_PARAMETER_EXCEPTION 
        = "Owner Parameter Incorrect.";
    public static String PASSWORD_PARAMETER_EXCEPTION 
        = "Password Parameter Incorrect.";
    public static String DATABASE_NOT_FOUND_EXCEPTION 
        = "Database not found exception.";
    public static String USER_ENTRY_NOT_FOUND_EXCEPTION 
        = "USer Entry not found exception.";
    public static String URI_PARAMETER_EXCEPTION 
        = "URI Parameter Exception.";
    public static String METHOD_PARAMETER_EXCEPTION 
        = "Method Unmatch Exception.";
    public static String INPUT_PARAMETER_EXCEPTION 
        = "Input Parameter Exception.";
    public static String CLASS_ERROR_EXCEPTION
        = "Class not found.";
    public static String PASSWORD_INVALIDATE_EXCEPTION 
        = "Parameter invalid Exception.";
    public static String ENTRY_ALREADY_EXIST
        = "Entry already exist";
    public static String FILE_IS_DIRECTORY
        = "File was a directory.";
    public static String HOME_DIRECTORY_NOT_FOUND
        = "Directory not found";
    public static final String DIRECTORY_PARAMETER_ERROR 
        = "You must specify a directory path except root.";
    public static String MERGE_ALREADY_EXIST_EXCEPTION
        = "The Target File has already existed.";
    public static String MERGE_IO_ERROR_EXCEPTION
        = "Merge method causes IO Error.";
    public static String DELETE_SPLIT_IO_ERROR_EXCEPTION
        = "Delete split IO Error.";
    public static String SPLIT_ALREADY_EXIST_EXCEPTION
        = "Split File has already existed.";
    public static String SPLIT_NUMBER_PARAMETER_EXCEPTION
        = "illegal split number parameter.";
    public static String NOT_SUPPORT_RETURN_TYPE_EXCEPTION
        = "Not support return type.";
    public static String NOT_SUPPORT_PARAMETER_TYPE_EXCEPTION
        = "Not support parameter type.";
    public static String NETWORK_ADDRESS_ERROR_EXCEPTION
        = "Network address error.";
    public static String ENCRYPT_EXCEPTION
        = "Encrypt exception";

    public static String INTERNAL_ERROR_EXCEPTION
        = "Internal error exception.";

    public static String INPUT_RETRY_LIMIT 
        = "Retry is cancelled over limitation.";
    public static String ILLEGAL_FORMAT_OF_FILE_LIST
        = "Illegal format of file list.";

    public final static String SESSION_FORMAT_ERROR_EXCEPTION
        = "Session Key Format error exception";

    public static String TARGET_ERROR_EXCEPTION
        = "Target error exception.";

    public static String SESSION_TIMEOUT
        = "Session timeout.";

    public static String JAVA_CLASS_LOADER_DEFINE_CLASS_EXCEPTION
        = "Java exception happens in defineClass() in ClassLoader.";
    public static String JAVA_CLASS_FOR_NAME
        = "Java exception happens in forName() in Class.";
    public static String JAVA_URL_EXCEPTION 
        = "URL Construction Exception.";
    public static String JAVA_FILE_MKDIR
        = "Java exception happens in mkdir() in File.";
    public static String JAVA_RUNTIME_EXEC
        = "Java exception happens in exec() in Runtime.";
    public static String JAVA_RUNTIME_GET_RUNTIME
        = "Java exception happens in getRuntime() in Runtime.";
    public static String JAVA_DATA_INPUT_STREAM_READ_LINE
        = "Java exception happens in readLine() in DataInputStream.";
    public static String JAVA_DATA_INPUT_STREAM
        = "Java exception happens in DataInputStream.";
    public static String JAVA_FILE_OUTPUT_STREAM_WRITE
        = "Java exception happens in write() in FileOutputStream.";
    public static String JAVA_FILE_OUTPUT_STREAM_CLOSE
        = "Java exception happens in close() in FileOutputStream.";
    public static String JAVA_FILE_OUTPUT_STREAM
        = "Java exception happens in FileOutputStream.";
    public static String JAVA_FILE_INPUT_STREAM_READ
        = "Java exception happens in read() in FileInputStream.";
    public static String JAVA_FILE_INPUT_STREAM
        = "Java exception happens in FileInputStream.";
    public static String JAVA_OBJECT_OUTPUT_STREAM_CLOSE
        = "Java exception happens in close() in ObjectOutputStream.";
    public static String JAVA_OBJECT_OUTPUT_STREAM
        = "Java exception happens in ObjectOutputStream.";
    public static String JAVA_OBJECT_OUTPUT_STREAM_WRITE_OBJECT
        = "Java exception happens in writeObject() in ObjectOutputStream.";
    public static String JAVA_OBJECT_INPUT_STREAM_CLOSE
        = "Java exception happens in close() in ObjectInputStream.";
    public static String JAVA_OBJECT_INPUT_STREAM
        = "Java exception happens in ObjectInputStream.";
    public static String JAVA_OBJECT_INPUT_STREAM_READ_OBJECT
        = "Java exception happens in readObject() in ObjectInputStream.";

    public static String SESSION_KEY_PARAMETER_NOT_FOUND
        = "Session key parameter not found.";
    public static String INPUT_PARAMETER_NOT_FOUND
        = "User's Parameters not found.";
    public static String OWNER_PARAMETER_NOT_FOUND
        = "Owner parameter not found.";
    public static String PASSWORD_PARAMETER_NOT_FOUND
        = "Password parameter not found.";
    public static String URI_PARAMETER_NOT_FOUND
        = "URI parameter is not found.";
    public static String SOURCE_PARAMETER_NOT_FOUND
        = "Source parameter is not found.";
    public static String DESTINATION_PARAMETER_NOT_FOUND
        = "Destination parameter is not found.";
    public static String ILLEGAL_VALUE
        = "illegal value.";
    public static String ILLEGAL_COMMAND_NAME
        = "illegal command name.";
    public static String ERROR_FILE_NOT_FOUND
        = "Error File not found";
    public static String CANCEL_EXCEPTION
        = "Cancel Exception";

    public static String JAVA_CIPHER_GET_INSTANCE_EXCEPTION
        = "Exception happends in getInstance() in Cipher.";

    public static String JAVA_CIPHER_INIT_EXCEPTION
        = "Exception happends init() in Cipher";
    public static String JAVA_SEALED_OBJECT
        = "Exception happends <init> in SealedObject";

    public static String TERMINAL_NAME_NOT_FOUND 
        = "Terminal name not found.";

    public DirectoryServerException (String ag) {
        super(ag);
    }
}
