/**
 * Copyright (C) All rights reserved.
 *
 * @Module     Argument.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2012/05/30
 *
 * This is a class for TEST of ArgumentInputStream and ArgumentOutputStream
 *
 */

package oserv;

import java.lang.*;
import java.lang.reflect.*;
import java.io.*;
import java.net.*;

public class Argument extends Object {

    public static int     ip1 = 0;
    public static long    lp1 = 0;
    public static float   fp1 = (float)0.0;
    public static double  dp1 = 0.0;
    public static short   sp1 = 0;
    public static char    cp1 = 0;
    public static byte    tp1 = 0;
    public static boolean bp1 = false;

    public static String p1 = null;
    public static String p2 = null;
    public static String r1 = null;

    public static InputStream            input_stream_object = null;
    public static PipedInputStream       piped_input_stream = null;
    public static FileInputStream        file_input_stream = null;
    public static ObjectInputStream      object_input_stream = null;
    public static ByteArrayInputStream   byte_array_input_stream = null;
    public static DataInputStream        data_input_stream = null;
    public static BufferedInputStream    buffered_input_stream = null;
    /*
    public static FilterInputStream      filter_input_stream = null;
    */
    public static PushbackInputStream    pushback_input_stream = null;
    public static LineNumberInputStream  line_number_input_stream = null;
    public static SequenceInputStream    sequence_input_stream = null;

    public static OutputStream           output_stream_object = null;
    public static PipedOutputStream      piped_output_stream = null;
    public static FileOutputStream       file_output_stream = null;
    public static ObjectOutputStream     object_output_stream = null;
    public static BufferedOutputStream   buffered_output_stream = null;
    public static ByteArrayOutputStream  byte_array_output_stream = null;
    public static DataOutputStream       data_output_stream = null;
    public static FilterOutputStream     filter_output_stream = null;
    public static PrintStream            print_stream = null;

    public static String filename = "check_file";
    public static String inputstream_filename = "inputstream";
    public static String pipedinputstream_filename = "pipedinputstream";
    public static String fileinputstream_filename = "fileinputstream";
    public static String filterinputstream_filename = "filterinputstream";
    public static String objectinputstream_filename = "objectinputstream";
    public static String datainputstream_filename = "datainputstream";
    public static String bufferedinputstream_filename = "bufferedinputstream";
    public static String bytearrayinputstream_filename = "bytearrayinputstream";
    public static String linenumberinputstream_filename = "linenumberinputstream";
    public static String pushbackinputstream_filename = "pushbackinputstream";
    public static String sequenceinputstream_filename = "sequenceinputstream";

    public static String outputstream_filename = "outputstream";
    public static String pipedoutputstream_filename = "pipedoutputstream";
    public static String fileoutputstream_filename = "fileoutputstream";
    public static String filteroutputstream_filename = "filteroutputstream";
    public static String objectoutputstream_filename = "objectoutputstream";
    public static String dataoutputstream_filename = "dataoutputstream";
    public static String bufferedoutputstream_filename = "bufferedoutputstream";
    public static String bytearrayoutputstream_filename = "bytearrayoutputstream";
    public static String printstream_filename = "printstream";

    public static String EMPTY = " ";
    public static String PARENT = "..";
    public static String NEWLINE = "\n";
    public final static String FILE_URL_PROTOCOL = "file://";

    public final static String METHOD_NAME = "method";
    public final static String VARIABLE1  = "p1";
    public final static String VARIABLE2  = "p2";
    public final static String PARAMETER1 = "Variable1";
    public final static String PARAMETER2 = "Variable2";
    public final static String RETURN1 = "r1";

    public final static String VARIABLE1_TYPE  = "String";
    public final static String VARIABLE2_TYPE  = "String";
    public final static String VARIABLE_INT_TYPE      = "int";
    public final static String VARIABLE_LONG_TYPE     = "long";
    public final static String VARIABLE_FLOAT_TYPE    = "float";
    public final static String VARIABLE_DOUBLE_TYPE   = "double";
    public final static String VARIABLE_BOOLEAN_TYPE  = "boolean";
    public final static String VARIABLE_CHAR_TYPE     = "char";
    public final static String VARIABLE_SHORT_TYPE    = "short";
    public final static String VARIABLE_BYTE_TYPE     = "byte";
/*
    public final static String VARIABLE_PIPED_INPUT_STREAM_TYPE = "java.io.PipedInputStream";
    public final static String VARIABLE_PIPED_OUTPUT_STREAM_TYPE = "java.io.PipedOutputStream";
*/
    public final static String VARIABLE_SEQUENCE_INPUT_STREAM_TYPE = "java.io.SequenceInputStream";
    public final static String VARIABLE_LINE_NUMBER_INPUT_STREAM_TYPE = "java.io.LineNumberInputStream";
    public final static String VARIABLE_PUSHBACK_INPUT_STREAM_TYPE = "java.io.PushbackInputStream";
    public final static String VARIABLE_PRINT_STREAM_TYPE = "java.io.PrintStream";

    public final static String VARIABLE_INPUT_STREAM_OBJECT_TYPE 
        = ObjectServerHeader.JAVA_INPUTSTREAM_TYPE_KEY;
    public final static String VARIABLE_OUTPUT_STREAM_OBJECT_TYPE 
        = ObjectServerHeader.JAVA_OUTPUTSTREAM_TYPE_KEY;
    public final static String VARIABLE_OBJECT_INPUT_STREAM_TYPE 
        = ObjectServerHeader.JAVA_OBJECTINPUTSTREAM_TYPE_KEY;
    public final static String VARIABLE_OBJECT_OUTPUT_STREAM_TYPE 
        = ObjectServerHeader.JAVA_OBJECTOUTPUTSTREAM_TYPE_KEY;
    public final static String VARIABLE_FILE_INPUT_STREAM_TYPE 
        = ObjectServerHeader.JAVA_FILEINPUTSTREAM_TYPE_KEY;
    public final static String VARIABLE_FILE_OUTPUT_STREAM_TYPE 
        = ObjectServerHeader.JAVA_FILEOUTPUTSTREAM_TYPE_KEY;
    public final static String VARIABLE_FILTER_INPUT_STREAM_TYPE 
        = ObjectServerHeader.JAVA_FILTERINPUTSTREAM_TYPE_KEY;
    public final static String VARIABLE_FILTER_OUTPUT_STREAM_TYPE 
        = ObjectServerHeader.JAVA_FILTEROUTPUTSTREAM_TYPE_KEY;

    public final static String VARIABLE_DATA_INPUT_STREAM_TYPE 
        = ObjectServerHeader.JAVA_DATAINPUTSTREAM_TYPE_KEY;
    public final static String VARIABLE_DATA_OUTPUT_STREAM_TYPE 
        = ObjectServerHeader.JAVA_DATAOUTPUTSTREAM_TYPE_KEY;

    public final static String VARIABLE_BUFFERED_INPUT_STREAM_TYPE 
        = ObjectServerHeader.JAVA_BUFFEREDINPUTSTREAM_TYPE_KEY;
    public final static String VARIABLE_BUFFERED_OUTPUT_STREAM_TYPE 
        = ObjectServerHeader.JAVA_BUFFEREDOUTPUTSTREAM_TYPE_KEY;

    public final static String VARIABLE_PIPED_INPUT_STREAM_TYPE 
        = ObjectServerHeader.JAVA_PIPEDINPUTSTREAM_TYPE_KEY;
    public final static String VARIABLE_PIPED_OUTPUT_STREAM_TYPE 
        = ObjectServerHeader.JAVA_PIPEDOUTPUTSTREAM_TYPE_KEY;

    public final static String VARIABLE_BYTE_ARRAY_INPUT_STREAM_TYPE 
        = ObjectServerHeader.JAVA_BYTEARRAYINPUTSTREAM_TYPE_KEY;
    public final static String VARIABLE_BYTE_ARRAY_OUTPUT_STREAM_TYPE 
        = ObjectServerHeader.JAVA_BYTEARRAYOUTPUTSTREAM_TYPE_KEY;


    public final static String VARIABLE_INT      = "ip1";
    public final static String VARIABLE_LONG     = "lp1";
    public final static String VARIABLE_FLOAT    = "fp1";
    public final static String VARIABLE_DOUBLE   = "dp1";
    public final static String VARIABLE_BOOLEAN  = "bp1";
    public final static String VARIABLE_CHAR     = "cp1";
    public final static String VARIABLE_SHORT    = "sp1";
    public final static String VARIABLE_BYTE     = "tp1";

    public final static String VARIABLE_PIPED_INPUT_STREAM = "piped_input_stream";
    public final static String VARIABLE_PIPED_OUTPUT_STREAM = "piped_output_stream";
    public final static String VARIABLE_SEQUENCE_INPUT_STREAM = "sequence_input_stream";
    public final static String VARIABLE_LINE_NUMBER_INPUT_STREAM = "line_number_input_stream";
    public final static String VARIABLE_PUSHBACK_INPUT_STREAM = "pushback_input_stream";
    public final static String VARIABLE_PRINT_STREAM = "print_stream";

    public final static String VARIABLE_INPUT_STREAM_OBJECT = "input_stream_object";
    public final static String VARIABLE_OUTPUT_STREAM_OBJECT = "output_stream_object";

    public final static String VARIABLE_OBJECT_INPUT_STREAM = "object_input_stream";
    public final static String VARIABLE_OBJECT_OUTPUT_STREAM = "object_output_stream";
    public final static String VARIABLE_FILE_INPUT_STREAM = "file_input_stream";
    public final static String VARIABLE_FILE_OUTPUT_STREAM = "file_output_stream";
    public final static String VARIABLE_FILTER_INPUT_STREAM = "filter_input_stream";
    public final static String VARIABLE_FILTER_OUTPUT_STREAM = "filter_output_stream";
    public final static String VARIABLE_DATA_INPUT_STREAM = "data_input_stream";
    public final static String VARIABLE_DATA_OUTPUT_STREAM = "data_output_stream";
    public final static String VARIABLE_BUFFERED_INPUT_STREAM = "buffered_input_stream";
    public final static String VARIABLE_BUFFERED_OUTPUT_STREAM = "buffered_output_stream";
    public final static String VARIABLE_BYTE_ARRAY_INPUT_STREAM = "byte_array_input_stream";
    public final static String VARIABLE_BYTE_ARRAY_OUTPUT_STREAM = "byte_array_output_stream";

    public final static int     PARAMETER_INT       = 234;
    public final static long    PARAMETER_LONG      = 543;
    public final static float   PARAMETER_FLOAT     = (float)0.345;
    public final static double  PARAMETER_DOUBLE    = 4.56;
    public final static boolean PARAMETER_BOOLEAN   = true;
    public final static char    PARAMETER_CHAR      = 'A';
    public final static short   PARAMETER_SHORT     = 5;
    public final static byte    PARAMETER_BYTE      = 6;

    public static InputStream            PARAMETER_INPUT_STREAM = null;
    public static FileInputStream        PARAMETER_FILE_INPUT_STREAM = null;
    public static ByteArrayInputStream   PARAMETER_BYTE_ARRAY_INPUT_STREAM = null;
    public static FilterInputStream      PARAMETER_FILTER_INPUT_STREAM = null;
    public static PipedInputStream       PARAMETER_PIPED_INPUT_STREAM = null;
    public static SequenceInputStream    PARAMETER_SEQUENCE_INPUT_STREAM = null;
    public static ObjectInputStream      PARAMETER_OBJECT_INPUT_STREAM = null;
    public static DataInputStream        PARAMETER_DATA_INPUT_STREAM = null;
    public static LineNumberInputStream  PARAMETER_LINE_NUMBER_INPUT_STREAM = null;
    public static BufferedInputStream    PARAMETER_BUFFERED_INPUT_STREAM = null;
    public static PushbackInputStream    PARAMETER_PUSHBACK_INPUT_STREAM = null;


    public static OutputStream           PARAMETER_OUTPUT_STREAM = null;
    public static FileOutputStream       PARAMETER_FILE_OUTPUT_STREAM = null;
    public static PipedOutputStream      PARAMETER_PIPED_OUTPUT_STREAM = null;
    public static ByteArrayOutputStream  PARAMETER_BYTE_ARRAY_OUTPUT_STREAM = null;
    public static ObjectOutputStream     PARAMETER_OBJECT_OUTPUT_STREAM = null;
    public static BufferedOutputStream   PARAMETER_BUFFERED_OUTPUT_STREAM = null;
    public static FilterOutputStream     PARAMETER_FILTER_OUTPUT_STREAM = null;
    public static DataOutputStream       PARAMETER_DATA_OUTPUT_STREAM = null;
    public static PrintStream            PARAMETER_PRINT_STREAM = null;


    public final static String LINE1 = "Test message 1\n";
    public final static String LINE2 = "Test message 2\n";
    public final static String LINE3 = "Test message 3\n";
    public final static String LINE4 = "Test message 4\n";
    public final static String PRINT_LINE1 = "Test message print 1\n";
    public final static String PRINT_LINE2 = "Test message print 2\n";
    public final static String FILE_LINE1 = "Test message file 1\n";
    public final static String FILE_LINE2 = "Test message file 2\n";
    public final static String BYTEARRAY_LINE1 = "Test message byte array 1\n";
    public final static String BYTEARRAY_LINE2 = "Test message byte array 2\n";
    public final static String FILTER_LINE1 = "Test message filter 1\n";
    public final static String FILTER_LINE2 = "Test message filter 2\n";
    public final static String PIPED_LINE1 = "Test message piped 1\n";
    public final static String PIPED_LINE2 = "Test message piped 2\n";
    public final static String BUFFERED_LINE1 = "Test message buffered 1\n";
    public final static String BUFFERED_LINE2 = "Test message buffered 2\n";
    public final static String SEQUENCE_LINE1 = "Test message sequence 1\n";
    public final static String SEQUENCE_LINE2 = "Test message sequence 2\n";
    public final static String DATA_LINE1 = "Test message data 1\n";
    public final static String DATA_LINE2 = "Test message data 2\n";
    public final static String OBJECT_LINE1 = "Test message object 1\n";
    public final static String OBJECT_LINE2 = "Test message object 2\n";
    public final static String PUSHBACK_LINE1 = "Test message pushback 1\n";
    public final static String PUSHBACK_LINE2 = "Test message pushback 2\n";
    public final static String LINENUMBER_LINE1 = "Test message line number 1\n";
    public final static String LINENUMBER_LINE2 = "Test message line number 2\n";

    public static String[]  static_types = {
            VARIABLE1_TYPE,
            VARIABLE2_TYPE,
            VARIABLE_INT_TYPE,
            VARIABLE_LONG_TYPE,
            VARIABLE_FLOAT_TYPE,
            VARIABLE_DOUBLE_TYPE,
            VARIABLE_SHORT_TYPE,
            VARIABLE_BOOLEAN_TYPE,
            VARIABLE_CHAR_TYPE,
            VARIABLE_BYTE_TYPE,
            VARIABLE_INPUT_STREAM_OBJECT_TYPE,
            VARIABLE_FILE_INPUT_STREAM_TYPE,
            VARIABLE_DATA_INPUT_STREAM_TYPE,

            VARIABLE_BUFFERED_INPUT_STREAM_TYPE,
            VARIABLE_BYTE_ARRAY_INPUT_STREAM_TYPE,
            VARIABLE_OBJECT_INPUT_STREAM_TYPE,

            VARIABLE_LINE_NUMBER_INPUT_STREAM_TYPE,
            VARIABLE_PUSHBACK_INPUT_STREAM_TYPE,
            VARIABLE_SEQUENCE_INPUT_STREAM_TYPE,

            VARIABLE_OUTPUT_STREAM_OBJECT_TYPE,
            VARIABLE_FILE_OUTPUT_STREAM_TYPE,
            VARIABLE_DATA_OUTPUT_STREAM_TYPE,
            VARIABLE_BUFFERED_OUTPUT_STREAM_TYPE,
            VARIABLE_BYTE_ARRAY_OUTPUT_STREAM_TYPE,
            VARIABLE_OBJECT_OUTPUT_STREAM_TYPE,
            VARIABLE_PRINT_STREAM_TYPE,
            VARIABLE_FILTER_OUTPUT_STREAM_TYPE,
            VARIABLE_PIPED_OUTPUT_STREAM_TYPE,
    };

    public static String[]  static_fields = {
            Argument.VARIABLE1,
            Argument.VARIABLE2,
            Argument.VARIABLE_INT,
            Argument.VARIABLE_LONG,
            Argument.VARIABLE_FLOAT,
            Argument.VARIABLE_DOUBLE,
            Argument.VARIABLE_SHORT,
            Argument.VARIABLE_BOOLEAN,
            Argument.VARIABLE_CHAR,
            Argument.VARIABLE_BYTE,
            Argument.VARIABLE_INPUT_STREAM_OBJECT,
            Argument.VARIABLE_FILE_INPUT_STREAM,
            Argument.VARIABLE_DATA_INPUT_STREAM,

            Argument.VARIABLE_BUFFERED_INPUT_STREAM,
            Argument.VARIABLE_BYTE_ARRAY_INPUT_STREAM,
            Argument.VARIABLE_OBJECT_INPUT_STREAM,

            Argument.VARIABLE_LINE_NUMBER_INPUT_STREAM,
            Argument.VARIABLE_PUSHBACK_INPUT_STREAM,
            Argument.VARIABLE_SEQUENCE_INPUT_STREAM,

            Argument.VARIABLE_OUTPUT_STREAM_OBJECT,
            Argument.VARIABLE_FILE_OUTPUT_STREAM,
            Argument.VARIABLE_DATA_OUTPUT_STREAM,
            Argument.VARIABLE_BUFFERED_OUTPUT_STREAM,
            Argument.VARIABLE_BYTE_ARRAY_OUTPUT_STREAM,
            Argument.VARIABLE_OBJECT_OUTPUT_STREAM,

            Argument.VARIABLE_PRINT_STREAM,
            Argument.VARIABLE_FILTER_OUTPUT_STREAM,
            Argument.VARIABLE_PIPED_OUTPUT_STREAM,
    };

    public Argument() {
        makeInputStreams();
        makeOutputStreams();
    }

    public void method() {
        int        rt;
        byte[]     buffer;
        Object     obj_buffer;
        if (p1 != null && p2 != null) {
            r1 = p1 + EMPTY + p2 + EMPTY +
                 String.valueOf(ip1) + EMPTY +
                 String.valueOf(lp1) + EMPTY +
                 String.valueOf(fp1) + EMPTY +
                 String.valueOf(dp1) + EMPTY +
                 String.valueOf(sp1) + EMPTY +
                 String.valueOf(bp1) + EMPTY +
                 String.valueOf(tp1) + EMPTY +
                 String.valueOf(cp1) + NEWLINE;
        }
        if (input_stream_object != null) {
            try {
                buffer = new byte[LINE1.length()];
                rt = input_stream_object.read(buffer, 0, buffer.length);
                r1 = r1.concat(new String(buffer));
                buffer = new byte[LINE2.length()];
                rt = input_stream_object.read(buffer, 0, buffer.length);
                r1 = r1.concat(new String(buffer));
            } catch (Exception exception_object) {
                exception_object.printStackTrace();  
                return;
            }
        }
        if (output_stream_object != null) {
            try {
                buffer = LINE1.getBytes();
                output_stream_object.write(buffer, 0, buffer.length);
                buffer = LINE2.getBytes();
                output_stream_object.write(buffer, 0, buffer.length);
            } catch (Exception exception_object) {
                exception_object.printStackTrace();
                return;
            }
        }

        if (file_input_stream != null) {
            try {
                buffer = new byte[FILE_LINE1.length()];
                rt = file_input_stream.read(buffer, 0, buffer.length);
                r1 = r1.concat(new String(buffer));
                buffer = new byte[FILE_LINE2.length()];
                rt = file_input_stream.read(buffer, 0, buffer.length);
                r1 = r1.concat(new String(buffer));
            } catch (Exception exception_object) {
                exception_object.printStackTrace();  
                return;
            }
        }
        if (file_output_stream != null) {
            try {
                buffer = FILE_LINE1.getBytes();
                file_output_stream.write(buffer, 0, buffer.length);
                buffer = FILE_LINE2.getBytes();
                file_output_stream.write(buffer, 0, buffer.length);
            } catch (Exception exception_object) {
                exception_object.printStackTrace();
                return;
            }
        }
        if (data_input_stream != null) {
            try {
                buffer = new byte[DATA_LINE1.length()];
                rt = data_input_stream.read(buffer, 0, buffer.length);
                r1 = r1.concat(new String(buffer));
                buffer = new byte[DATA_LINE2.length()];
                rt = data_input_stream.read(buffer, 0, buffer.length);
                r1 = r1.concat(new String(buffer));
            } catch (Exception exception_object) {
                exception_object.printStackTrace();  
                return;
            }
        }
        if (data_output_stream != null) {
            try {
                buffer = DATA_LINE1.getBytes();
                data_output_stream.write(buffer, 0, buffer.length);
                buffer = DATA_LINE2.getBytes();
                data_output_stream.write(buffer, 0, buffer.length);
            } catch (Exception exception_object) {
                exception_object.printStackTrace();
                return;
            }
        }

        if (filter_output_stream != null) {
            try {
                buffer = FILTER_LINE1.getBytes();
                filter_output_stream.write(buffer, 0, buffer.length);
                buffer = FILTER_LINE2.getBytes();
                filter_output_stream.write(buffer, 0, buffer.length);
            } catch (Exception exception_object) {
                exception_object.printStackTrace();
                return;
            }
        }
        if (buffered_input_stream != null) {
            try {
                buffer = new byte[BUFFERED_LINE1.length()];
                rt = buffered_input_stream.read(buffer, 0, buffer.length);
                r1 = r1.concat(new String(buffer));
                buffer = new byte[BUFFERED_LINE2.length()];
                rt = buffered_input_stream.read(buffer, 0, buffer.length);
                r1 = r1.concat(new String(buffer));
            } catch (Exception exception_object) {
                exception_object.printStackTrace();  
                return;
            }
        }
        if (buffered_output_stream != null) {
            try {
                buffer = BUFFERED_LINE1.getBytes();
                buffered_output_stream.write(buffer, 0, buffer.length);
                buffer = BUFFERED_LINE2.getBytes();
                buffered_output_stream.write(buffer, 0, buffer.length);
            } catch (Exception exception_object) {
                exception_object.printStackTrace();
                return;
            }
        }
        if (object_input_stream != null) {
            try {
                obj_buffer = object_input_stream.readObject();
                r1 = r1.concat((String)obj_buffer);
                obj_buffer = object_input_stream.readObject();
                r1 = r1.concat((String)obj_buffer);
            } catch (Exception exception_object) {
                exception_object.printStackTrace();  
                return;
            }
        }
        if (object_output_stream != null) {
            try {
                object_output_stream.writeObject((Object)OBJECT_LINE1);
                object_output_stream.writeObject((Object)OBJECT_LINE2);
/*
                buffer = OBJECT_LINE1.getBytes();
                object_output_stream.write(buffer, 0, buffer.length);
                buffer = OBJECT_LINE2.getBytes();
                object_output_stream.write(buffer, 0, buffer.length);
*/
            } catch (Exception exception_object) {
                exception_object.printStackTrace();
                return;
            }
        }
        if (byte_array_input_stream != null) {
            try {
                buffer = new byte[BYTEARRAY_LINE1.length()];
                rt = byte_array_input_stream.read(buffer, 0, buffer.length);
                r1 = r1.concat(new String(buffer));
                buffer = new byte[BYTEARRAY_LINE2.length()];
                rt = byte_array_input_stream.read(buffer, 0, buffer.length);
                r1 = r1.concat(new String(buffer));
            } catch (Exception exception_object) {
                exception_object.printStackTrace();  
                return;
            }
        }
        if (byte_array_output_stream != null) {
            try {
                buffer = BYTEARRAY_LINE1.getBytes();
                byte_array_output_stream.write(buffer, 0, buffer.length);
                buffer = BYTEARRAY_LINE2.getBytes();
                byte_array_output_stream.write(buffer, 0, buffer.length);
            } catch (Exception exception_object) {
                exception_object.printStackTrace();
                return;
            }
        }
        if (print_stream != null) {
            try {
                print_stream.print(PRINT_LINE1);
                print_stream.print(PRINT_LINE2);
            } catch (Exception exception_object) {
                exception_object.printStackTrace();
                return;
            }
        }
        if (piped_output_stream != null) {
            try {
                buffer = PIPED_LINE1.getBytes();
                piped_output_stream.write(buffer, 0, buffer.length);
                buffer = PIPED_LINE2.getBytes();
                piped_output_stream.write(buffer, 0, buffer.length);
            } catch (Exception exception_object) {
                exception_object.printStackTrace();
                return;
            }
        }
        if (line_number_input_stream != null) {
            try {
                buffer = new byte[LINENUMBER_LINE1.length()];
                rt = line_number_input_stream.read(buffer, 0, buffer.length);
                r1 = r1.concat(new String(buffer));
                buffer = new byte[LINENUMBER_LINE2.length()];
                rt = line_number_input_stream.read(buffer, 0, buffer.length);
                r1 = r1.concat(new String(buffer));
            } catch (Exception exception_object) {
                exception_object.printStackTrace();  
                return;
            }
        }
        if (pushback_input_stream != null) {
            try {
                buffer = new byte[PUSHBACK_LINE1.length()];
                rt = pushback_input_stream.read(buffer, 0, buffer.length);
                r1 = r1.concat(new String(buffer));
                buffer = new byte[PUSHBACK_LINE2.length()];
                rt = pushback_input_stream.read(buffer, 0, buffer.length);
                r1 = r1.concat(new String(buffer));
            } catch (Exception exception_object) {
                exception_object.printStackTrace();  
                return;
            }
        }
        if (sequence_input_stream != null) {
            try {
                buffer = new byte[SEQUENCE_LINE1.length()];
                rt = sequence_input_stream.read(buffer, 0, buffer.length);
                r1 = r1.concat(new String(buffer));
                buffer = new byte[SEQUENCE_LINE2.length()];
                rt = sequence_input_stream.read(buffer, 0, buffer.length);
                r1 = r1.concat(new String(buffer));
            } catch (Exception exception_object) {
                exception_object.printStackTrace();  
                return;
            }
        }
    }

    public static void makePushbackInputStream() {
        byte[]                 buffer;
        PushbackInputStream    local_pushback_input_stream;
        FileOutputStream       local_file_output_stream;
        FileInputStream        local_file_input_stream;

        try {
            local_file_output_stream = new FileOutputStream(
                pushbackinputstream_filename );

            buffer = PUSHBACK_LINE1.getBytes();
            local_file_output_stream.write(buffer, 0, buffer.length);
            buffer = PUSHBACK_LINE2.getBytes();
            local_file_output_stream.write(buffer, 0, buffer.length);
            local_file_output_stream.close();

            local_file_input_stream = new FileInputStream(
                pushbackinputstream_filename );
            pushback_input_stream = new PushbackInputStream(
                (InputStream)local_file_input_stream);
            PARAMETER_PUSHBACK_INPUT_STREAM = pushback_input_stream;
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }

    public static void makeLineNumberInputStream() {
        byte[]                   buffer;
        LineNumberInputStream    local_line_number_input_stream;
        FileOutputStream         local_file_output_stream;
        FileInputStream          local_file_input_stream;

        try {
            local_file_output_stream = new FileOutputStream(
                linenumberinputstream_filename );

            buffer = LINENUMBER_LINE1.getBytes();
            local_file_output_stream.write(buffer, 0, buffer.length);
            buffer = LINENUMBER_LINE2.getBytes();
            local_file_output_stream.write(buffer, 0, buffer.length);
            local_file_output_stream.close();

            local_file_input_stream = new FileInputStream(
                linenumberinputstream_filename );
            line_number_input_stream = new LineNumberInputStream(
                (InputStream)local_file_input_stream);
            PARAMETER_LINE_NUMBER_INPUT_STREAM = line_number_input_stream;

        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }

    public static void makeByteArrayInputStream() {
        byte[]             buffer;
        FileInputStream    local_file_input_stream;
        FileOutputStream   local_file_output_stream;
        try {
            byte_array_input_stream = new ByteArrayInputStream(
                (BYTEARRAY_LINE1 + BYTEARRAY_LINE2).getBytes());
            PARAMETER_BYTE_ARRAY_INPUT_STREAM = byte_array_input_stream;
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }

    public static void makePipedOutputStream() {
        try {
            piped_input_stream = new PipedInputStream();
            piped_output_stream = new PipedOutputStream(piped_input_stream);
            PARAMETER_PIPED_OUTPUT_STREAM = piped_output_stream;
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }

    public static void makeByteArrayOutputStream() {
        try {
            byte_array_output_stream = new ByteArrayOutputStream();
            PARAMETER_BYTE_ARRAY_OUTPUT_STREAM = byte_array_output_stream;
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }

    public static void makePrintStream() {
        byte[]             buffer;
        FileOutputStream    local_file_output_stream;
        try {
            local_file_output_stream = new FileOutputStream(
                printstream_filename );
            print_stream = new PrintStream(
                (OutputStream)local_file_output_stream);
            PARAMETER_PRINT_STREAM = print_stream;
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }

    public static void makeBufferedInputStream() {
        byte[]             buffer;
        FileInputStream    local_file_input_stream;
        FileOutputStream   local_file_output_stream;

        try {
            local_file_output_stream = new FileOutputStream(
                bufferedinputstream_filename );
            buffer = BUFFERED_LINE1.getBytes();
            local_file_output_stream.write(buffer, 0, buffer.length);
            buffer = BUFFERED_LINE2.getBytes();
            local_file_output_stream.write(buffer, 0, buffer.length);
            local_file_output_stream.close();

            local_file_input_stream = new FileInputStream(
                bufferedinputstream_filename );
            buffered_input_stream = new BufferedInputStream(
                (InputStream)local_file_input_stream);
            PARAMETER_BUFFERED_INPUT_STREAM = buffered_input_stream;
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }

    public static void makeBufferedOutputStream() {
        byte[]             buffer;
        FileOutputStream    local_file_output_stream;
        try {
            local_file_output_stream = new FileOutputStream(
                bufferedoutputstream_filename );
            buffered_output_stream = new BufferedOutputStream(
                (OutputStream)local_file_output_stream);
            PARAMETER_BUFFERED_OUTPUT_STREAM = buffered_output_stream;
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }

    public static void makeObjectInputStream() {
        FileInputStream    local_file_input_stream;
        FileOutputStream   local_file_output_stream;
        ObjectOutputStream local_object_output_stream;
        try {
            local_file_output_stream = new FileOutputStream(
                objectinputstream_filename );
            local_object_output_stream = new ObjectOutputStream(
                local_file_output_stream );
            local_object_output_stream.writeObject(OBJECT_LINE1);
            local_object_output_stream.writeObject(OBJECT_LINE2);
            local_object_output_stream.close();

            local_file_input_stream = new FileInputStream(
                objectinputstream_filename );
            object_input_stream = new ObjectInputStream(
                (InputStream)local_file_input_stream );
            PARAMETER_OBJECT_INPUT_STREAM = object_input_stream;
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }

    public static void makeObjectOutputStream() {
        byte[]             buffer;
        FileOutputStream    local_file_output_stream;
        try {
            local_file_output_stream = new FileOutputStream(
                objectoutputstream_filename );
            object_output_stream = new ObjectOutputStream(
                (OutputStream)local_file_output_stream );
            PARAMETER_OBJECT_OUTPUT_STREAM = object_output_stream;
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }

    public static void makeDataInputStream() {
        byte[]             buffer;
        FileInputStream    local_file_input_stream;
        FileOutputStream   local_file_output_stream;
        try {
            local_file_output_stream = new FileOutputStream(
                datainputstream_filename );
            buffer = DATA_LINE1.getBytes();
            local_file_output_stream.write(buffer, 0, buffer.length);
            buffer = DATA_LINE2.getBytes();
            local_file_output_stream.write(buffer, 0, buffer.length);
            local_file_output_stream.close();

            local_file_input_stream = new FileInputStream(
                datainputstream_filename );
            data_input_stream = new DataInputStream(
                (InputStream)local_file_input_stream );
            PARAMETER_DATA_INPUT_STREAM = data_input_stream;
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }

    public static void makeDataOutputStream() {
        byte[]             buffer;
        FileOutputStream    local_file_output_stream;
        try {
            local_file_output_stream = new FileOutputStream(
                dataoutputstream_filename );
            data_output_stream = new DataOutputStream(
                (OutputStream)local_file_output_stream );
            PARAMETER_DATA_OUTPUT_STREAM = data_output_stream;
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }

    public static void makeFilterOutputStream() {
        byte[]             buffer;
        FileOutputStream    local_file_output_stream;
        try {
            local_file_output_stream = new FileOutputStream( 
                filteroutputstream_filename );
            
            filter_output_stream = new FilterOutputStream(
                (OutputStream)local_file_output_stream ); 
            PARAMETER_FILTER_OUTPUT_STREAM = filter_output_stream;
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }

    public static void makeOutputStream() {
        byte[]   buffer;
        try {
            output_stream_object = (OutputStream)new FileOutputStream(
                outputstream_filename
            );
            buffer = LINE1.getBytes();
            output_stream_object.write(buffer, 0, buffer.length);
            buffer = LINE2.getBytes();
            output_stream_object.write(buffer, 0, buffer.length);
            PARAMETER_OUTPUT_STREAM = output_stream_object;
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }

    public static void makeFileOutputStream() {
        byte[]   buffer;
        try {
            file_output_stream = new FileOutputStream(
                fileoutputstream_filename
            );
            buffer = FILE_LINE1.getBytes();
            file_output_stream.write(buffer, 0, buffer.length);
            buffer = FILE_LINE2.getBytes();
            file_output_stream.write(buffer, 0, buffer.length);
            PARAMETER_FILE_OUTPUT_STREAM = file_output_stream;
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }

    public static void makeInputStream() {
        byte[]              buffer;
        FileOutputStream    internal_file_output_stream;

        try {
            internal_file_output_stream = new FileOutputStream(filename);
            buffer = LINE1.getBytes();
            internal_file_output_stream.write(buffer, 0, buffer.length);
            buffer = LINE2.getBytes();
            internal_file_output_stream.write(buffer, 0, buffer.length);
            internal_file_output_stream.close();
            PARAMETER_INPUT_STREAM = (InputStream)new FileInputStream(filename);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }

    public static void makeSequenceInputStream() {
        byte[]              buffer;
        FileOutputStream    internal_file_output_stream;
        FileInputStream     internal_file_input_stream;
        ByteArrayInputStream byte_array_input_stream;

        try {
            internal_file_output_stream = new FileOutputStream(sequenceinputstream_filename);
            buffer = SEQUENCE_LINE1.getBytes();
            internal_file_output_stream.write(buffer, 0, buffer.length);
            buffer = SEQUENCE_LINE2.getBytes();
            internal_file_output_stream.write(buffer, 0, buffer.length);
            internal_file_output_stream.close();
            internal_file_input_stream = new FileInputStream(sequenceinputstream_filename);
            byte_array_input_stream = new ByteArrayInputStream(
                                ObjectServerHeader.EMPTY_MESSAGE.getBytes() );
            PARAMETER_SEQUENCE_INPUT_STREAM = new SequenceInputStream(
                internal_file_input_stream, byte_array_input_stream);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }
    public static void makeFileInputStream() {
        byte[]              buffer;
        FileOutputStream    internal_file_output_stream;

        try {
            internal_file_output_stream = new FileOutputStream(fileinputstream_filename);
            buffer = FILE_LINE1.getBytes();
            internal_file_output_stream.write(buffer, 0, buffer.length);
            buffer = FILE_LINE2.getBytes();
            internal_file_output_stream.write(buffer, 0, buffer.length);
            internal_file_output_stream.close();
            PARAMETER_FILE_INPUT_STREAM = new FileInputStream(fileinputstream_filename);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }

    public static void makeOutputStreams() {
        makeOutputStream();
        makeFileOutputStream();
        makePipedOutputStream();
        makeDataOutputStream();
        makeFilterOutputStream();
        makeObjectOutputStream();
        makeBufferedOutputStream();
        makeByteArrayOutputStream();
        makePrintStream();
    }

    public static void makeInputStreams() {
        makeInputStream();
        makeFileInputStream();
        makeDataInputStream();
        makeObjectInputStream();
        makePushbackInputStream();
        makeLineNumberInputStream();
        makeBufferedInputStream();
        makeByteArrayInputStream();
        makeSequenceInputStream();
    }

    public static void setInputStreams() {
        input_stream_object = PARAMETER_INPUT_STREAM;
        file_input_stream = PARAMETER_FILE_INPUT_STREAM;
        piped_input_stream = PARAMETER_PIPED_INPUT_STREAM;
        object_input_stream = PARAMETER_OBJECT_INPUT_STREAM;
        byte_array_input_stream = PARAMETER_BYTE_ARRAY_INPUT_STREAM;
        data_input_stream = PARAMETER_DATA_INPUT_STREAM;
        buffered_input_stream = PARAMETER_BUFFERED_INPUT_STREAM;
        pushback_input_stream = PARAMETER_PUSHBACK_INPUT_STREAM;

        line_number_input_stream = PARAMETER_LINE_NUMBER_INPUT_STREAM;
        sequence_input_stream = PARAMETER_SEQUENCE_INPUT_STREAM;
    }

    public static void setOutputStreams() {
        output_stream_object = PARAMETER_OUTPUT_STREAM;
        file_output_stream = PARAMETER_FILE_OUTPUT_STREAM;
        piped_output_stream = PARAMETER_PIPED_OUTPUT_STREAM;
        object_output_stream = PARAMETER_OBJECT_OUTPUT_STREAM;
        byte_array_output_stream = PARAMETER_BYTE_ARRAY_OUTPUT_STREAM;
        data_output_stream = PARAMETER_DATA_OUTPUT_STREAM;
        buffered_output_stream = PARAMETER_BUFFERED_OUTPUT_STREAM;

        filter_output_stream = PARAMETER_FILTER_OUTPUT_STREAM;
        print_stream = PARAMETER_PRINT_STREAM;
    }

    public String method1(String pa1, String pa2) {
        p1 = pa1;
        p2 = pa2;

        ip1 = PARAMETER_INT;
        lp1 = PARAMETER_LONG;
        fp1 = PARAMETER_FLOAT;
        dp1 = PARAMETER_DOUBLE;
        sp1 = PARAMETER_SHORT;
        bp1 = PARAMETER_BOOLEAN;
        cp1 = PARAMETER_CHAR;
        tp1 = PARAMETER_BYTE;

        setInputStreams();
        setOutputStreams();
        try {
            file_input_stream = new FileInputStream(filename);
        } catch (Exception exception_object) {
            return r1;
        }

        return r1;
    }

    public static void main(String[] args) {
        String     class_name;
        Object     class_instance;
        Class      class_object;
        URL        url;
        URL[]      urls;
        File       fd;
        Object[]   empty;
        URLClassLoader  uloader;
        String          urlpath;
        Method[]        methods;
        Field[]         fields;
        String          method_string;
        String          field_string;
        String          return_value;

        if (args.length != 1 && args.length != 2) {
            return;
        }
        class_name = args[0];

        setInputStreams();
        setOutputStreams();

        fd = new File(EMPTY);

        if (args.length == 1) {
            urlpath = FILE_URL_PROTOCOL + fd.getAbsolutePath().substring(
                0, fd.getAbsolutePath().length()-1)
                + PARENT + File.separator;
        } else {
            urlpath = FILE_URL_PROTOCOL + args[1];
        }

        empty = new Object[0];
        try {
            url = new URL(urlpath);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
        urls = new URL[1];
        urls[0] = url;
        uloader = new URLClassLoader(urls);

        try {
            class_object = Class.forName(class_name, true, uloader);
            class_instance = class_object.newInstance();
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }

        methods = class_object.getMethods();
        fields = class_object.getFields();

        for (int i = 0; i < fields.length; i++) {
            field_string = fields[i].getName();
            try {
                if (field_string.compareTo(VARIABLE1) == 0) {
                    fields[i].set(class_instance, PARAMETER1);
                    continue;
                }
                if (field_string.compareTo(VARIABLE2) == 0) {
                    fields[i].set(class_instance, PARAMETER2);
                    continue;
                }
                if (field_string.compareTo(VARIABLE_INT) == 0) {
                    fields[i].setInt(class_instance, PARAMETER_INT);
                    continue;
                }
                if (field_string.compareTo(VARIABLE_LONG) == 0) {
                    fields[i].setLong(class_instance, PARAMETER_LONG);
                    continue;
                }
                if (field_string.compareTo(VARIABLE_FLOAT) == 0) {
                    fields[i].setFloat(class_instance, PARAMETER_FLOAT);
                    continue;
                }
                if (field_string.compareTo(VARIABLE_DOUBLE) == 0) {
                    fields[i].setDouble(class_instance, PARAMETER_DOUBLE);
                    continue;
                }
                if (field_string.compareTo(VARIABLE_SHORT) == 0) {
                    fields[i].setShort(class_instance, PARAMETER_SHORT);
                    continue;
                }
                if (field_string.compareTo(VARIABLE_BYTE) == 0) {
                    fields[i].setByte(class_instance, PARAMETER_BYTE);
                    continue;
                }
                if (field_string.compareTo(VARIABLE_CHAR) == 0) {
                    fields[i].setChar(class_instance, PARAMETER_CHAR);
                    continue;
                }
                if (field_string.compareTo(VARIABLE_BOOLEAN) == 0) {
                    fields[i].setBoolean(class_instance, PARAMETER_BOOLEAN);
                    continue;
                }
                if (field_string.compareTo(VARIABLE_INPUT_STREAM_OBJECT) == 0) {
                    fields[i].set(class_instance, PARAMETER_INPUT_STREAM);
                    continue;
                }
                if (field_string.compareTo(VARIABLE_OUTPUT_STREAM_OBJECT) == 0) {
                    fields[i].set(class_instance, PARAMETER_OUTPUT_STREAM);
                    continue;
                }
                if (field_string.compareTo(VARIABLE_FILE_INPUT_STREAM) == 0) {
                    fields[i].set(class_instance, PARAMETER_FILE_INPUT_STREAM);
                    continue;
                }
                if (field_string.compareTo(VARIABLE_FILE_OUTPUT_STREAM) == 0) {
                    fields[i].set(class_instance, PARAMETER_FILE_OUTPUT_STREAM);
                    continue;
                }
                if (field_string.compareTo(VARIABLE_FILTER_INPUT_STREAM) == 0) {
                    fields[i].set(class_instance, PARAMETER_FILTER_INPUT_STREAM);
                    continue;
                }
                if (field_string.compareTo(VARIABLE_FILTER_OUTPUT_STREAM) == 0) {
                    fields[i].set(class_instance, PARAMETER_FILTER_OUTPUT_STREAM);
                    continue;
                }
                if (field_string.compareTo(VARIABLE_BUFFERED_INPUT_STREAM) == 0) {
                    fields[i].set(class_instance, PARAMETER_BUFFERED_INPUT_STREAM);
                    continue;
                }
                if (field_string.compareTo(VARIABLE_BUFFERED_OUTPUT_STREAM) == 0) {
                    fields[i].set(class_instance, PARAMETER_BUFFERED_OUTPUT_STREAM);
                    continue;
                }
                if (field_string.compareTo(VARIABLE_DATA_INPUT_STREAM) == 0) {
                    fields[i].set(class_instance, PARAMETER_DATA_INPUT_STREAM);
                    continue;
                }
                if (field_string.compareTo(VARIABLE_DATA_OUTPUT_STREAM) == 0) {
                    fields[i].set(class_instance, PARAMETER_DATA_OUTPUT_STREAM);
                    continue;
                }
                if (field_string.compareTo(VARIABLE_BYTE_ARRAY_INPUT_STREAM) == 0) {
                    fields[i].set(class_instance, PARAMETER_BYTE_ARRAY_INPUT_STREAM);
                    continue;
                }
                if (field_string.compareTo(VARIABLE_BYTE_ARRAY_OUTPUT_STREAM) == 0) {
                    fields[i].set(class_instance, PARAMETER_BYTE_ARRAY_OUTPUT_STREAM);
                    continue;
                }
                if (field_string.compareTo(VARIABLE_OBJECT_INPUT_STREAM) == 0) {
                    fields[i].set(class_instance, PARAMETER_OBJECT_INPUT_STREAM);
                    continue;
                }
                if (field_string.compareTo(VARIABLE_OBJECT_OUTPUT_STREAM) == 0) {
                    fields[i].set(class_instance, PARAMETER_OBJECT_OUTPUT_STREAM);
                    continue;
                }
                if (field_string.compareTo(VARIABLE_PIPED_OUTPUT_STREAM) == 0) {
                    fields[i].set(class_instance, PARAMETER_PIPED_OUTPUT_STREAM);
                    continue;
                }
                if (field_string.compareTo(VARIABLE_PRINT_STREAM) == 0) {
                    fields[i].set(class_instance, PARAMETER_PRINT_STREAM);
                    continue;
                }
                if (field_string.compareTo(VARIABLE_SEQUENCE_INPUT_STREAM) == 0) {
                    fields[i].set(class_instance, PARAMETER_SEQUENCE_INPUT_STREAM);
                    continue;
                }
                if (field_string.compareTo(VARIABLE_LINE_NUMBER_INPUT_STREAM) == 0) {
                    fields[i].set(class_instance, PARAMETER_LINE_NUMBER_INPUT_STREAM);
                    continue;
                }
                if (field_string.compareTo(VARIABLE_PUSHBACK_INPUT_STREAM) == 0) {
                    fields[i].set(class_instance, PARAMETER_PUSHBACK_INPUT_STREAM);
                    continue;
                }
            } catch (Exception exception_object) {
                break;
            }
        }

        for (int i = 0; i < methods.length; i++) {
            method_string = methods[i].getName();
            if (method_string.compareTo(METHOD_NAME) == 0) {
                try {
                    methods[i].invoke(class_instance, empty);
                } catch (Exception exception_object) {
                    break;
                }
            }
        }

        for (int i = 0; i < fields.length; i++) {
            field_string = fields[i].getName();
            try {
                if (field_string.compareTo(RETURN1) == 0) {
                    return_value = (String)fields[i].get(class_instance);
                    System.out.println(return_value);
                    break;
                }
            } catch (Exception exception_object) {
                break;
            }
        }
    }
}
