/**
 * Copyright (C) All rights reserved.
 *
 * @Module     ClassInputStream.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2013/03/08
 *
 */

package oserv;

import java.lang.*;
import java.io.*;

public class ClassInputStreamTest extends ClassInputStream {
    private static String OBJECT_HEADER = "Object Header";
    private static String SPACE = " ";
    private static String PARAMETER_ERROR = "Parameter error.";
    private static String DOT_STRING = ".";

    private static String FILE_NAME = "File name";
    private static String CLASS_NAME = "Class name";
    private static String TYPE_NAME = "Type name";
    private static String LENGTH = "Length";

    private static String TEST1 = "Test1";
    private static String TEST2 = "Test2";

    public ClassInputStreamTest(String file_name, String class_name, String type,
        long file_length) throws FileNotFoundException {
        super(file_name, class_name, type, file_length);
    }

    public static void main(String[]  args) {
        ClassInputStreamTest   class_input_stream_test;
        long                   length;
        int                    index;
        String                 file_name;
        String                 class_name;
        String                 type;
        File                   file_object;
        String                 file_path_name;
        String                 class_path_name;
        String                 type_name;
        String                 length_string;

        if (args.length != 1) {
            System.err.println(PARAMETER_ERROR);
            return;
        }

        file_name = args[0];
        index = file_name.lastIndexOf(File.separator);
        if (index < 0) {
            System.err.println(PARAMETER_ERROR);
            return;
        }
        class_name = file_name.substring(index+1);
        type = new String();
        index = class_name.lastIndexOf(DOT_STRING);
        if (index < 0) {
            System.err.println(PARAMETER_ERROR);
            return;
        }
        type = class_name.substring(index+1);
        class_name = class_name.substring(0, index);

        try {
            file_object = new File(file_name);
            length = file_object.length();
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }

        try {
            class_input_stream_test = new ClassInputStreamTest(
                file_name,
                class_name,
                type,
                length);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
        System.out.println(OBJECT_HEADER + SPACE + class_input_stream_test.toString());

        file_path_name = class_input_stream_test.getFilePath();
        System.out.println(FILE_NAME + SPACE + file_path_name);
        class_path_name = class_input_stream_test.getClassPath();
        System.out.println(CLASS_NAME + SPACE + class_path_name);
        type_name = class_input_stream_test.getType();
        System.out.println(TYPE_NAME + SPACE + type_name);
        length_string = String.valueOf(class_input_stream_test.length());
        System.out.println(LENGTH + SPACE + length_string);

    }
}
