/**
 * Copyright (C) All rights reserved.
 *
 * @Module     ForwardServer.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2012/03/08
 *
 */

package oserv;

import java.lang.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.util.zip.*;
import java.util.jar.*;


public class ForwardServer extends SystemServer {

    private String myType = FORWARD_THREAD_TYPE;
    private static String FORWARD_SERVER_CLASS_NAME = "oserv.ForwardServer";

    public void setMyType(String type) {
        if (type != null) {
            myType = type;
        }
    }

    public static String getClassName() {
        return FORWARD_SERVER_CLASS_NAME;
    }

    protected String getMyType() {
        Thread  thread_object;

        thread_object = Thread.currentThread();
        if (thread_object instanceof ForwardServer) {
            return ObjectServerHeader.FORWARD_THREAD_TYPE;
        }
        return super.getMyType();
    }

    public ForwardServer() {
        super();
    }

    public ForwardServer(Thread runnable, String type) {
        super(runnable, type);
    }
}
