/**
 * Copyright (C) All rights reserved.
 *
 * @Module     NamedDataInputStream.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2012/05/16
 *
 */

package oserv;

import java.lang.*;
import java.io.*;
import java.net.*;

public class NamedDataInputStream extends DataInputStream implements NamedInputStream {

    private static NamedFileInputStream named_file_input_stream;

    public final static String PARAMETER_ERROR = "Parameter error";

    public NamedDataInputStream(NamedFileInputStream param_file_input_stream) throws IOException {
        super(param_file_input_stream);
        named_file_input_stream = param_file_input_stream;
    }

    public String getFileName() {
        String filename = null;
        if (named_file_input_stream != null) {
            filename = named_file_input_stream.getFileName();
        }
        return filename;
    }

    public void close() throws IOException {
        try {
            super.close();
        } catch (IOException io_exception) {
            throw io_exception;
        }
    }

    public static void main(String[] args) {
        String   line;

        if (args.length != 1) {
            System.err.println(PARAMETER_ERROR);
            return;
        }
        NamedFileInputStream  named_file_input_stream;
        NamedDataInputStream  named_data_input_stream;
        File                  file_descriptor;
        DataInputStream       data_input_stream;

        try {
            named_file_input_stream = new NamedFileInputStream(args[0]); 
            named_data_input_stream = new NamedDataInputStream(
                named_file_input_stream );
            data_input_stream = (DataInputStream)named_data_input_stream;
/**
            data_input_stream = new DataInputStream(((InputStream)named_file_input_stream));
**/
        } catch (Exception exception_object) {
            return;
        }

        while (true) {
            try {
                line = data_input_stream.readLine();
            } catch (Exception exception_object) {
                break;
            }
            if (line == null) { break; }
        }
        try {
            data_input_stream.close();
        } catch (Exception exception_object) {
        }
        file_descriptor = new File(named_file_input_stream.getFileName());
        if (file_descriptor.exists() == true) {
/*
            file_descriptor.delete();
*/
        }
    }
}
