/**
 * Copyright (C) All rights reserved.
 *
 * @Module     NamedFileInputStream.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2012/04/04
 *
 */

package oserv;

import java.lang.*;
import java.io.*;
import java.net.*;

public class NamedFileInputStream extends FileInputStream implements NamedInputStream {

    private static String filename;

    public final static String PARAMETER_ERROR = "Parameter error";

    public NamedFileInputStream(String param_file_name) throws IOException {
        super(param_file_name);
        filename = param_file_name;
    }

    public String getFileName() {
        return filename;
    }

    public void close() throws IOException {
        try {
            super.close();
        } catch (IOException io_exception) {
            throw io_exception;
        }
        /*
        if (getFileName() != null) {
            File file_descriptor;
            file_descriptor = new File(getFileName());
            file_descriptor.delete();
        }
        */
    }

    public static void main(String[] args) {
        String   line;

        if (args.length != 1) {
            System.err.println(PARAMETER_ERROR);
            return;
        }
        NamedFileInputStream  named_file_input_stream;
        File                  file_descriptor;
        DataInputStream       data_input_stream;

        try {
            named_file_input_stream = new NamedFileInputStream(args[0]); 
            data_input_stream = new DataInputStream(((InputStream)named_file_input_stream));
        } catch (Exception exception_object) {
            return;
        }

        while (true) {
            try {
                line = data_input_stream.readLine();
            } catch (Exception exception_object) {
                break;
            }
            if (line == null) { break; }
        }
        try {
            data_input_stream.close();
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
        file_descriptor = new File(named_file_input_stream.getFileName());
        if (file_descriptor.exists() == true) {
            file_descriptor.delete();
        }
    }
}
