/**
 * Copyright (C) All rights reserved.
 *
 * @Module     NamedFileOutputStream.java
 * @Author     Takahiko Tanaka.
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2012/05/25
 *
 */

package oserv;

import java.lang.*;
import java.io.*;
import java.net.*;

public class NamedFileOutputStream extends FileOutputStream implements NamedOutputStream {

    private static String filename;
    private static boolean close_flag = false;

    public NamedFileOutputStream(String param_file_name) throws IOException {
        super(param_file_name);
        filename = param_file_name;
    }

    public String getFileName() {
        return filename;
    }

    public void closeStream() throws Exception {
        try {
            super.close();
        } catch (Exception exception_object) {
            throw exception_object;
        }
    }

    public void close() throws IOException {
        if (close_flag == true) {
            return;
        }
        try {
            super.close();
        } catch (IOException io_exception) {
            throw io_exception;
        }
        close_flag = true;
    }
}
