/**
 * Copyright (C) All rights reserved.
 *
 * @Module     NamedPipedInputStream.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2012/06/11
 *
 */

package oserv;

import java.lang.*;
import java.io.*;
import java.net.*;

public class NamedPipedInputStream extends PipedInputStream implements NamedInputStream {

    private static boolean close_flag = false;
    private static PipedOutputStream  piped_output_stream = null;

    public NamedPipedInputStream() throws IOException {
        super();
    }

    public String getFileName() {
        return null;
    }

    public PipedOutputStream getPipedOutputStream() {
        return piped_output_stream;
    }

    public void close() throws IOException {
        if (close_flag == true) {
            return;
        }
        try {
            super.close();
        } catch (IOException exception_object) {
            throw exception_object;
        }
        close_flag = true;
        return;
    }
}
