/**
 * Copyright (C) All rights reserved.
 *
 * @Module     NamedPipedOutputStream.java
 * @Author     Takahiko Tanaka.
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2012/06/11
 *
 */

package oserv;

import java.lang.*;
import java.io.*;
import java.net.*;

public class NamedPipedOutputStream extends PipedOutputStream implements NamedOutputStream {

    private static boolean close_flag = false;
    private static PipedInputStream  piped_input_stream = null;

    public NamedPipedOutputStream(PipedInputStream param_piped_input_stream) throws IOException {
        super(param_piped_input_stream);
        piped_input_stream = param_piped_input_stream;
    }

    public String getFileName() {
        return null;
    }

    public PipedInputStream getPipedInputStream() {
        return piped_input_stream;
    }

    public void closeStream() throws Exception {
        if (close_flag == true) {
            return;
        }
        try {
            super.close();
        } catch (IOException exception_object) {
            throw exception_object;
        }
        close_flag = true;
    }
}
