/**
 * Copyright (C) All rights reserved.
 *
 * @Module     ObjectClassException.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2012/02/23
 *
 */

package oserv;

import java.lang.*;
import java.io.*;
import java.net.*;

public class ObjectClassException extends Exception {
    public static String UNKNOWN_CAUSE = "Unknown exception";
    public static String CLASS_NOT_FOUND = "Class not found";

    public ObjectClassException(String message) {
        super(message);
    }

    private ObjectClassException(Exception exception_object) {
        super(exception_object);
    }

    public static ObjectClassException valueOf(Exception exception_object) {
        ObjectClassException object_class_exception;

        if (exception_object == null || exception_object.getMessage() == null) {
            object_class_exception = new ObjectClassException(UNKNOWN_CAUSE);
            return object_class_exception;
        } 
        object_class_exception = new ObjectClassException(exception_object);
        return object_class_exception;
    }

    public static ObjectClassException valueOf(String string_object) {
        ObjectClassException object_class_exception;
        if (string_object == null) {
            object_class_exception = new ObjectClassException(UNKNOWN_CAUSE);
            return object_class_exception;
        }
        object_class_exception = new ObjectClassException(string_object);
        return object_class_exception;
    }
}
