/**
 * Copyright (C) All rights reserved.
 *
 * @Module     ObjectInputManager.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2013/06/05
 *
 */

package oserv;

import java.lang.*;
import java.io.*;
import java.net.*;

import oserv.*;

public class ObjectInputManager   {
    private static String SPACE = "";

    private int debug = 0;

    private void setDebug(int level) {
        debug = level;
    }

    private int getDebug() {
        return debug;
    }

/**
    public Object  readObjectDebug(InputStream input_stream, int debug_level) throws Exception {

        Object   object_target;

        setDebug(debug_level);
        object_target = readObject(input_stream);

        return object_target;
    }
**/

    public Object  toObject(byte[] byte_array) throws Exception {

        Object                  object_instance;
        ObjectInputStream       object_input_stream;
        ByteArrayInputStream    byte_array_input_stream;

        if (byte_array == null) {
            NullPointerException  null_pointer_exception;
            null_pointer_exception = new NullPointerException();
            throw null_pointer_exception;
        }
        byte_array_input_stream = new ByteArrayInputStream(byte_array);
        try {
            object_input_stream = new ObjectInputStream(
                byte_array_input_stream);
        } catch (Exception exception_object) {
            throw exception_object;
        }
        try {
            object_instance = object_input_stream.readObject();
        } catch (Exception exception_object) {
            throw exception_object;
        }
        return object_instance;
    }
}

