/**
 * Copyright (C) All rights reserved.
 *
 * @Module     ObjectOutputManager.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2013/06/05
 *
 */

package oserv;

import java.lang.*;
import java.io.*;
import java.net.*;

import oserv.*;

public class ObjectOutputManager   {
    private int debug = 0;

    private void setDebug(int level) {
        debug = level;
    }

    private int getDebug() {
        return debug;
    }

    public byte[] toByteArray(Object object_target) throws Exception {
        byte[]                  byte_array;
        ByteArrayOutputStream   byte_array_output_stream;
        ObjectOutputStream      object_output_stream;

        if (object_target == null) {
            NullPointerException  null_pointer_exception;
            null_pointer_exception = new NullPointerException();
            throw null_pointer_exception;
        }
        try {
            byte_array_output_stream = new ByteArrayOutputStream();
            object_output_stream = new ObjectOutputStream(
                byte_array_output_stream);
        } catch (Exception exception_object) {
            throw exception_object;
        }
        try {
            object_output_stream.writeObject(object_target);
        } catch (Exception exception_object) {
            throw exception_object;
        }
        byte_array = byte_array_output_stream.toByteArray();
        return byte_array;
    }
}
