/**
 * Copyright (C) All rights reserved.
 *
 * @Module     ObjectServerDebug.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2011/11/24
 *
 */

package oserv;

import java.lang.*;

public class ObjectServerDebug {

    /**
     * for ObjectServer
     */
    public final static String DEBUG_UNMATCH_COUNT_SERVER
        = "Unmatch count!";
    public final static String DEBUG_EMPTY_OBJECT_ARRAY_SERVER
        = "Empty Object Array.";
    public final static String DEBUG_WRITEOBJECTTABLE_SERVER
        = "writeObjectTable() in ObjectServer().";
    public final static String DEBUG_OBJECT_NOT_SERIALIZABLE
        = "Object is not serializable";

    /**
     * not convert message from English to Japanese
     */
    public final static String DEBUG_WRITEVARIABLE_SERVER
        = "writeVariable() ";
    public final static String DEBUG_READVARIABLE_SERVER   
        = "readVariable()";
    public final static String DEBUG_WRITECLASSFILE_SERVER
        = "writeClassFile() ";
    public final static String DEBUG_DO_SPIN_LOCK_SERVER 
        = "doSpinLock()";
    public final static String DEBUG_DO_SPIN_UNLOCK_SERVER 
        = "doSpinUnlock()";
    public final static String DEBUG_CHECK_ACCESS_SERVER
        = "checkAccess()";

    /**
     * Definition
     */
    public final static String DEBUG_FORWARD_RESET_REQUEST 
        = "Forward reset request";
    public final static String DEBUG_INITIALIZATION = "initialization";
    public final static String DEBUG_INTERRUPT      = "Interrupt";
    public final static String DEBUG_EXCEPTION_KEY  = "Exception";
    public final static String DEBUG_OBJECT_SERVER_EXCEPTION_KEY  
        = "ObjectServerException";
    public final static String DEBUG_MAXIMUM        = "maximum ";
    public final static String DEBUG_FILE_DESCRIPTOR
                                                    = "File Object";
    public final static String DEBUG_FILE_EXCEPTION 
        = "Exception in File constructor";
    public final static String DEBUG_OBJECTINPUTSTREAM_EXCEPTION
        = "Exception in ObjectInputStream(InputStream) constructor";

    public final static String DEBUG_CONNECT_CHILD = "Thread connect child";
    public final static String DEBUG_REGISTER_CHILD = "Thread register child";
    public final static String DEBUG_FORWARD_CHILD = "Thread forward child";
    public final static String DEBUG_SYSTEM_CHILD = "Thread system child";

    public final static String DEBUG_MAX_THREAD     = "max thread ";
    public final static String DEBUG_DEBUG_VALUE    = "Debug Value";
    public final static String DEBUG_ITEM_COUNT     = "Item count";
    public final static String DEBUG_FIELD_COUNT    = "Field count";
    public final static String DEBUG_FIELD_KEY      = "Field ";
    public final static String DEBUG_ENTRY_COUNT    = "Entry count";
    public final static String DEBUG_READ_OBJECT_TABLE
                                                    = "Read Object Table";
    public final static String DEBUG_READ_FORWARD_TABLE
                                                    = "Read Forward Table";
    public final static String DEBUG_CHECK_OBJECT_TABLE_FILE
                                                    = "Check ObjectTable Path";
    public final static String DEBUG_PERSISTENT_PATH 
        = "Persistent Path";



    public final static String DEBUG_PERSISTENT_DIRECTORY_NOT_FOUND
        = "Persistent directory not found";

    public final static String DEBUG_ACCEPT_CONNECTION = "Accept Connection";
    public final static String DEBUG_REFUSE_CONNECTION = "Refuse Connection";

    public final static String DEBUG_BAD_TUNNEL_VALUE = "Bad limitation value for tunnel";
    public final static String DEBUG_PWD_ENV_KEY    = "PWD";
    public final static String DEBUG_URL_KEY        = "URL";
    public final static String DEBUG_CLASS_LOADER_KEY = "ClassLoader";
    public final static String DEBUG_PROPERTY_NAME  = "Property";
    public final static String DEBUG_PROPERTY_VALUE = "Value";
    public final static String DEBUG_PROPERTIES_FILE  = "Properties file";
    public final static String DEBUG_CLASS_NAME     = "Class Name";
    public final static String DEBUG_FILE_LENGTH    = "file length";
    public final static String DEBUG_FILE_NAME      = "File Name";
    public final static String DEBUG_SOCKET_NAME      = "Socket Name";
    public final static String DEBUG_SERVER_SOCKET  = "Server Socket";
    public final static String DEBUG_LOG_START       = "log start";
    public final static String DEBUG_LOG             = "log";
    public final static String DEBUG_RETRY_KEY      = "retry key";
    public final static String DEBUG_COUNT_KEY      = "Count";
    public final static String DEBUG_POINT_KEY      = "Point";
    public final static String DEBUG_OBJECT_VALUE   = "Object value";
    public final static String DEBUG_ARGUMENT_KEY   = "Argument";
    public final static String DEBUG_JAR_NAME       = "Jar Name";
    public final static String DEBUG_ENTRY_NAME     = "Entry Name";
    public final static String DEBUG_THREAD_NAME     = "Thread Name";
    public final static String DEBUG_OBJECT_NAME     = "Object Name";
    public final static String DEBUG_SERVICE_NAME     = "Service Name";
    public final static String DEBUG_PACKAGE_NAME    = "Package Name";
    public final static String DEBUG_USER_HOME      = "User Home";
    public final static String DEBUG_FORWARD_SERVICES = "Forward services";
    public final static String DEBUG_HOST_NAME      = "Host Name";
    public final static String DEBUG_HOST_ADDRESS     = "Host Address";
    public final static String DEBUG_PORT_NUMBER    = "Port Number";
    public final static String DEBUG_TABLE_NAME     = "Table Name";
    public final static String DEBUG_TABLE_SIZE     = "Table Size";
    public final static String DEBUG_LIST_SIZE     = "List Size";
    public final static String DEBUG_VARIABLE_NAME   = "Variable Name";
    public final static String DEBUG_VARIABLE_VALUE  = "Variable Value";
    public final static String DEBUG_VARIABLE_TYPE   = "Variable Type";
    public final static String DEBUG_BUFFER_SIZE    = "Buffer Size";
    public final static String DEBUG_QUERY_STRING   = "Query String";
    public final static String DEBUG_REQUEST_KEY    = "Request command";
    public final static String DEBUG_PARAM_KEY      = "Param";
    public final static String DEBUG_PARAMETER_NUMBER      = "Parameter number";
    public final static String DEBUG_COMMAND_KEY    = "Command";
    public final static String DEBUG_DIRECTORY_PATH = "Directory Path";
    public final static String DEBUG_CURRENT_DIRECTORY = "Current Directory";
    public final static String DEBUG_FILE_PATH       = "File path";
    public final static String DEBUG_LIBRARY_PATH_KEY = "library path";
    public final static String DEBUG_LIBRARY_ENTRY_KEY = "library entry";
    public final static String DEBUG_OBJECT_PATH = "Object path";
    public final static String MKDIR_ERROR = "mkdirs method failed.";
    public final static String DEBUG_DELETE_PARENT_KEY   = "Delete Parent";
    public final static String DEBUG_DELETE_KEY     = "Delete";
    public final static String DEBUG_DELETE_ENTRY_KEY     = "Delete entry";
    public final static String DEBUG_EXECUTE_KEY    = "Execute";
    public final static String DEBUG_INTERNAL_ERROR = "Internal error : ";
    public final static String DEBUG_END_KEY        = "End";
    public final static String DEBUG_TRACE_KEY      = "Trace";
    public final static String DEBUG_ASSERTION_KEY  = "Assertion";
    public final static String DEBUG_ERROR_KEY      = "Error";
    public final static String DEBUG_TYPE_KEY       = "Type";
    public final static String DEBUG_SIZE_KEY       = "Size";
    public final static String DEBUG_ITEM_KEY       = "Item";
    public final static String DEBUG_NULL_KEY       = "null";
    public final static String DEBUG_INTERFACE_NUMBER = "Interface number";
    public final static String DEBUG_INTERFACE_CLASS = "Interface Class";
    public final static String DEBUG_METHOD_CLASS   = "Method Class";
    public final static String DEBUG_RETURN_VALUE   = "Return Value";
    public final static String DEBUG_RETURN_TYPE    = "Return Type";
    public final static String DEBUG_RETURN_KEY     = "Return";
    public final static String DEBUG_METHOD_KEY     = "Method";
    public final static String DEBUG_MAKE_KEY       = "Make";
    public final static String DEBUG_CALL_KEY       = "Call";
    public final static String DEBUG_BACK_KEY       = "Back";
    public final static String DEBUG_VALUE_KEY     = "Value";
    public final static String DEBUG_INDEX_KEY         = "Index";
    public final static String DEBUG_CREATE_KEY     = "Create";
    public final static String DEBUG_CONFIGURE_KEY  = "Configure";
    public final static String DEBUG_BLANK_STRING_KEY     = " ";
    public final static String DEBUG_CODE_001       = "\001";
    public final static String DEBUG_CODE_002       = "\002";
    public final static String DEBUG_CODE_003       = "\003";
    public final static String DEBUG_CODE_004       = "\004";
    public final static String DEBUG_READ_OBJECT    = "Read Object";

    public final static String DEBUG_ADD_OPERATE_OBJECT_TABLE = "Add to ObjectTable";
    public final static String DEBUG_DELETE_OPERATE_OBJECT_TABLE = "Delete from ObjectTable";
    public final static String DEBUG_READ_OPERATE_OBJECT_TABLE = "Read from ObjectTable";
    public final static String DEBUG_SEARCH_OPERATE_OBJECT_TABLE = "Research at ObjectTable";

    public final static String DEBUG_CONNECTION_START_KEY = "Open connection";
    public final static String DEBUG_CONNECTION_END_KEY = "Close connection";

    public final static String DEBUG_REQUEST_CONNECTION_START_KEY = "Open request connection";
    public final static String DEBUG_REQUEST_CONNECTION_END_KEY = "Close request connection";
    public final static String DEBUG_FORWARD_CONNECTION_START_KEY = "Open forward connection";
    public final static String DEBUG_FORWARD_CONNECTION_END_KEY = "Close forward connection";

    public final static String DEBUG_PARAMETER_TRANSFER = "Transfer Parameter";
    public final static String DEBUG_PARAMETER_ERROR = "Parameter Error";

    public final static String DEBUG_LOG_SWITCH_TO_TTY
	= "log switch to tty";

    /**
     * Registration
     */
    public final static String DEBUG_REGISTER_OBJECT_SERVER
	= "Register Object Server";
    public final static String DEBUG_REGISTER_BAD_ARCHIVE_NAME 
        = "Bad Archive Name is specified in a registration request.";
    public final static String DEBUG_WRITEOBJECTTABLE_AT_END_OF_REGISTER
        = "writeObjectTable at end of register().";
    public final static String DEBUG_OBJECT_DELETE_FILE
        = "Object delete file";
    public final static String DEBUG_OBJECT_DELETE_VARIABLE_FILE
        = "Object delete variable file";
    public final static String DEBUG_FILE_NAME_ERROR = "File Name Error";
    public final static String DEBUG_NULL_COMMAND_RECEIVE    
        = "Null command was received";
    public final static String DEBUG_VARIABLE_FILE_NAME 
        = "Variable file name";
    public final static String DEBUG_DATA_CORRUPTION
        = "Data corruption";
    public final static String DEBUG_URL_PATH
        = "URL path";

    /**
     * Service
     */
    public final static String DEBUG_INVOKE_SERVICE          
        = "Service in invoke()";
    public final static String DEBUG_COUNT_OF_PARAMETER
        = "Service count of parameter";
    public final static String DEBUG_SPECIFIED_PARAMETER 
        = "Specified Parameter";
    public final static String DEBUG_LOCAL_OBJECT_NOT_FOUND
        = "Service local object not found";
    public final static String DEBUG_RESULT_OBJECT 
        = "Result Object";
    public final static String DEBUG_WRITE_RESULT_OBJECT 
        = "Write Result Object";

    /**
     * Forward
     */
    public final static String DEBUG_FORWARD_READ_JAR_ARCHIVE_FILE_KEY
        = "Forward read a jar archive file";
    public final static String DEBUG_FORWARD_GET_FILE_CONTENTS_KEY
        = "Forward read contents of file in a jar archive file";
    public final static String DEBUG_FORWARD_SERVICE_IN_KEY
        = "Forward forward doCommand service in";
    public final static String DEBUG_FORWARD_IS_RESET_REQUEST
        = "Forward reset request";
    public final static String DEBUG_FORWARD_IS_RESET_REQUEST_TRUE
        = "Forward reset true";
    public final static String DEBUG_FORWARD_IS_NOT_RESET
        = "Forward reset false";
    public final static String DEBUG_FORWARD_SERVICE_IS_OWN_SERVICE
        = "Forward service is own service";
    public final static String DEBUG_FORWARD_CONNECTION_FAIL 
        = "Forward connection fail";
    public final static String DEBUG_FORWARD_WRITE_FORWARD_FILE 
        = "Forward write forward file";
    public final static String DEBUG_FORWARD_OPEN_FORWARD_FILE 
        = "Forward open forward file";
    public final static String DEBUG_FORWARD_MAKE_CLIENTS 
        = "Make forward clients table";
    public final static String DEBUG_FORWARD_MAKE_SERVERS 
        = "Make forward servers table";
    public final static String DEBUG_FORWARD_ENTRY  = "Forward entry";
    public final static String DEBUG_FORWARD_EMPTY_CLIENT_TABLE
        = "Forward empty ForwardClientTable";
    public final static String DEBUG_FORWARD_EMPTY_SERVER_TABLE
        = "Forward empty ForwardServerTable";

    public final static String DEBUG_FORWARD_SET_SERVICE_ENTRY
        = "Forward set service entry";
    public final static String DEBUG_FORWARD_SET_FORWARD_SERVICE_ENTRY
        = "Forward setForwardServiceEntry()";
    public final static String DEBUG_FORWARD_WRITE_FORWARD_STRING_TABLE 
        = "Forward write string entry";
    public final static String DEBUG_FAIL_TO_OPERATE_FORWARDFILE 
        = "Fail to operate Forward File";
    public final static String DEBUG_FORWARD_REQUEST_HOST_ADDRESS
        = "Forward host address of request";
    public final static String DEBUG_FORWARD_REFUSE_TABLE_COUNT
        = "Forward refuse table count";
    public final static String DEBUG_FORWARD_READ_FORWARD_TABLE
        = "Forward read Forward Table";
    public final static String DEBUG_FORWARD_WRITE_FORWARD_TABLE
        = "Forward write Forward Table";
    public final static String DEBUG_FORWARD_TRANSFER_REQUEST_SERVICE
        = "Forward transfer request service";
    public final static String DEBUG_FORWARD_READ_ENTRY_FROM_FILE
        = "Forward read entry from file";
    public final static String DEBUG_FORWARD_READ_ENTRY_FROM_SOCKET 
        = "Forward read entry from socket";
    public final static String DEBUG_FORWARD_SERVER_COUNT 
        = "Forward server count";
    public final static String DEBUG_FORWARD_CONFIGURED_FORWARDS 
        = "Forward Configured forwards entry";
    public final static String DEBUG_FORWARD_COMMAND_REQUEST 
        = "Forward command request";
    public final static String DEBUG_FORWARD_COMMAND_NOT_FOUND
        = "Forward command is not found.";
    public final static String DEBUG_FORWARD_SERVICE_EXECUTION
        = "Forward service is executed.";
    public final static String DEBUG_FORWARD_SERVICE_ENTRY_NUMBER 
        = "Forward service entry number";
    public final static String DEBUG_FORWARD_SEND_COMMAND
        = "Forward send command";
    public final static String DEBUG_FORWARD_LIST_COMMAND
        = "Forward list command";
    /**
     * Tool
     */
    public final static String DEBUG_IS_DELETE
        = "isDelete()";
    public final static String DEBUG_IS_LIST
        = "isList()";
    public final static String DEBUG_IS_REGISTER
        = "isRegister()";
    /** 
     * CONNECTION message
     */
    public final static String DEBUG_FORWARD_REFUSE_FORWARD_CONNECTION
        = "Forward refuse forward connection";
    public final static String DEBUG_REQUEST_REFUSE_REQUEST_CONNECTION
        = "Request refuse request connection";
    public final static String DEBUG_OBJECT_REFUSE_OBJECT_CONNECTION
        = "Object refuse object connection";
    public final static String DEBUG_OBJECT_REFUSE_SYSTEM_CONNECTION
        = "Object refuse system connection";
    public final static String DEBUG_FORWARD_ACCEPT_FORWARD_CONNECTION
        = "Forward accept forward connection";
    public final static String DEBUG_REQUEST_ACCEPT_REQUEST_CONNECTION
        = "Request accept request connection";
    public final static String DEBUG_OBJECT_ACCEPT_OBJECT_CONNECTION
        = "Object accept object connection";
    public final static String DEBUG_OBJECT_ACCEPT_SYSTEM_CONNECTION
        = "Object accept system connection";

    public final static String DEBUG_COPY_JAR_FILE   = "copyJarFile()";
    public final static String DEBUG_DO_SPIN_LOCK    = "doSpinLock()";
    public final static String DEBUG_DO_SPIN_UNLOCK  = "doSpinUnlock()";
    public final static String DEBUG_OPEN            = "open()";
    public final static String DEBUG_CLOSE           = "close()";
    public final static String DEBUG_INVOKE          = "invoke()";

    public final static String DEBUG_MKDIRS = "mkdirs()";

    public final static String DEBUG_CASTSERVICETOFORWARDS
        = "castServiceToForwards";
    public final static String DEBUG_GETURIENTRY
        = "getURIEntry";
    public final static String DEBUG_MAKEQUERYPARAMETER
        = "makeQueryParameter";
    public final static String DEBUG_WRITEFORWARDSTRINGTABLE
        = "writeForwardStringTable";
    public final static String DEBUG_WRITEOBJECTTABLEENTRY
        = "writeObjectTableEntry";
    public final static String DEBUG_RETRYOBJECTINPUTSTREAM = "RetryObjectInputStream";

    public final static String DEBUG_JAVA_SETPROPERTIES = "setProperties()";
    public final static String DEBUG_JAVA_SETPROPERTY = "setProperty()";
    public final static String DEBUG_JAVA_SOCKET_GETINPUTSTREAM = "Socket.getInputStream()";

    public final static String DEBUG_JAVA_OUTPUTSTREAM_VALUE = "OutputStream value";
    public final static String DEBUG_JAVA_INPUTSTREAM_VALUE = "InputStream value";
    public final static String DEBUG_JAVA_OBJECTINPUTSTREAM = "ObjectInputStream";
    public final static String DEBUG_JAVA_OBJECTOUTPUTSTREAM = "ObjectOutputStream";
    public final static String DEBUG_JAVA_INPUTSTREAM = "InputStream";
    public final static String DEBUG_JAVA_OUTPUTSTREAM = "OutputStream";
    public final static String DEBUG_JAVA_BYTEARRAYINPUTSTREAM = "ByteArrayInputStream";
    public final static String DEBUG_JAVA_BYTEARRAYOUTPUTSTREAM = "ByteArrayOutputStream";
    public final static String DEBUG_JAVA_BUFFEREDINPUTSTREAM = "BufferedInputStream";
    public final static String DEBUG_JAVA_BUFFEREDOUTPUTSTREAM = "BufferedOutputStream";
    public final static String DEBUG_JAVA_PIPEDINPUTSTREAM = "PipedInputStream";
    public final static String DEBUG_JAVA_PIPEDOUTPUTSTREAM = "PipedOutputStream";
    public final static String DEBUG_JAVA_FILTERINPUTSTREAM = "FilterInputStream";
    public final static String DEBUG_JAVA_FILTEROUTPUTSTREAM = "FilterOutputStream";
    public final static String DEBUG_JAVA_FILEINPUTSTREAM = "FileInputStream";
    public final static String DEBUG_JAVA_FILEOUTPUTSTREAM = "FileOutputStream";
    public final static String DEBUG_JAVA_DATAINPUTSTREAM = "DataInputStream";
    public final static String DEBUG_JAVA_DATAOUTPUTSTREAM = "DataOutputStream";

    public final static String DEBUG_JAVA_PRINTSTREAM = "PrintStream";
    public final static String DEBUG_JAVA_PUSHBACKINPUTSTREAM = "PushbackInputStream";
    public final static String DEBUG_JAVA_SEQUENCEINPUTSTREAM = "SequenceInputStream";
    public final static String DEBUG_JAVA_LINENUMBERINPUTSTREAM = "LineNumberInputStream";


    public final static String DEBUG_REFUSE_REQUEST_TABLE
        = "Refuse request table";
    public final static String DEBUG_REFUSE_OBJECT_TABLE
        = "Refuse object table";
    public final static String DEBUG_REFUSE_FORWARD_TABLE
        = "Refuse forward table";
    public final static String DEBUG_REFUSE_SYSTEM_TABLE
        = "Refuse system table";

    public final static String DEBUG_FILE_NOT_EXIST  = "File not exist";

    /**
     * initialization
     */
    public final static String DEBUG_READ_TABLE_SIZE
        = "read table size";
    public final static String DEBUG_READ_TABLE_NUMBER
        = "read table number";
    public final static String DEBUG_REQUEST_PORT     = "Request port";
    public final static String DEBUG_REQUEST_PORT_NOT_FOUND 
        = "request port not found.";
    public final static String DEBUG_FORWARD_PARAMETER_ERROR
        = "Forward parameter error";

    public final static String DEBUG_NOT_FOUND_PROPERTY_FILE 
        = "Not found properties file";
    public final static String DEBUG_OPEN_CURRENT_PROPERTY
        = "Open current properties file";
    public final static String DEBUG_THREAD_DEATH = "Thread Death";
    public final static String DEBUG_MAIN_THREAD = "Main Thread";
    public final static String DEBUG_SERVICE_THREAD = "Service Thread";
    public final static String DEBUG_MONITOR_THREAD = "Monitor Thread";
    public final static String DEBUG_SYSTEM_THREAD = "System Thread";
    public final static String DEBUG_TRANSIENT_THREAD = "Transient Thread";
    public final static String DEBUG_REGISTER_THREAD = "Register Thread";
    public final static String DEBUG_FORWARD_THREAD = "Forward Thread";
    public final static String DEBUG_FILEINPUTSTREAM_EXCEPTION  
        = "FileInputStream Exception";
    public final static String DEBUG_MAKE_USER_FILE_DIRECTORY
        = "Make user file directory";

    public final static String DEBUG_SOCKET_INFORMATION
        = "Socket Information";

    /**
     * COMMON
     */
    public final static String DEBUG_READJARFILE
        = "readJarFile";
    public final static String DEBUG_WRITEJARFILE
        = "writeJarFile";
    public final static String DEBUG_WRITEOBJECT
        = "writeObject";
    public final static String DEBUG_READ_FROM_OBJECTINPUTSTREAM
        = "read from ObjectInputStream";
    public final static String DEBUG_MATCH_ENTRY     = "MATCH ENTRY";
    public final static String DEBUG_OBJECT_READ_FILE_CONTENT
        = "Object read content of the file";
    public final static String DEBUG_NOT_FOUND_KEY
        = "not found.";
    public final static String DEBUG_EXCEPTION_COUNT_ERROR
        = "Exception count error";
    public final static String DEBUG_PARAMETER_COUNT_ERROR
        = "Parameter count error";
    public final static String DEBUG_SET_RETRY_COUNT
        = "Set RetryCount ";
    public final static String DEBUG_SWITCH_OUTPUT 
        = "Switch System out for a service";
    public final static String DEBUG_SWITCH_BACK 
        = "Switch back to System out";
    public final static String DEBUG_MODIFIER_TYPE
        = "Modifier type";
    public final static String DEBUG_SEND_BACK_OBJECT  = "Send back Object";
    public final static String DEBUG_SERVICE_THREAD_START
        = "Service Thread Start";
    public final static String DEBUG_FORWARD_THREAD_START
        = "Forward Thread Start";
    public final static String DEBUG_REGISTER_THREAD_START
        = "Register Thread Start";
    public final static String DEBUG_MONITOR_THREAD_START
        = "Monitor Thread Start";
    public final static String DEBUG_SYSTEM_THREAD_START
        = "System Thread Start";
    public final static String DEBUG_SERVICE_THREAD_END
        = "Service Thread End";
    public final static String DEBUG_TRANSIENT_THREAD_END
        = "Transient Thread End";
    public final static String DEBUG_FORWARD_THREAD_END
        = "Forward Thread End";
    public final static String DEBUG_REGISTER_THREAD_END
        = "Register Thread End";
    public final static String DEBUG_MONITOR_THREAD_END
        = "Monitor Thread End";
    public final static String DEBUG_SYSTEM_THREAD_END
        = "System Thread End";
    public final static String DEBUG_WAIT_FOR_A_REQUEST
	= "Wait for a request";
    public final static String DEBUG_READ_PARAMETER_FROM_INSTANCE
        = "Read Parameter From Instance";

    public final static String DEBUG_KEEP_ALIVE_TRUE  = "KeepAlive true";
    public final static String DEBUG_KEEP_ALIVE_FALSE = "KeepAlive false";
    public final static String DEBUG_TCP_NO_DELAY_TRUE  = "TcpNoDelay true";
    public final static String DEBUG_TCP_NO_DELAY_FALSE = "TcpNoDelay false";
    public final static String DEBUG_SO_LINGER_FALSE = "SoLinger false";
    public final static String DEBUG_SO_LINGER_TRUE = "SoLinger true";

    public final static String DEBUG_FORWARD_ILLEGAL_URI
        = "Forward illegal URI";
    public final static String DEBUG_FORWARD_HOP_COUNT
        = "Forward hop count";
    public final static String DEBUG_FORWARD_TUNNEL_COUNT
        = "Forward tunnel count";
    public final static String DEBUG_FORWARD_PATH_COUNT
        = "Forward path count";

    public final static String DEBUG_NULL_THREADTABLE
        = "Thread Table is null";

    public final static String DEBUG_BASE_FILE_NAME
        = "Class file name";

}
