/**
 * Copyright (C) All rights reserved.
 *
 * @Module:    ObjectServerError.java
 * @Author:    Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version:   2.1 2011/11/24
 *
 */

package oserv;

import java.lang.*;

public class ObjectServerError extends Object {

    /**
     * These error message is used in ObjectServer.java
     */
    public final static String SPIN_LOCK_ERROR_SERVER
        = "Spin lock is left in ObjectServer().";
    public final static String ILLEGAL_LANGUAGE_SERVER
        = "Illegal language in ObjectServer().";
    public final static String DEBUG_FUNCTION_ERROR_SERVER
        = "Debug function error in ObjectServer().";

    public final static String NOT_SERIALIZABLE_RETURN_SERVER
        = "Return object is not serializable in ObjectServer().";
    public final static String IO_ERROR_EXCEPTION_SERVER
        = "IO error exception happened in ObjectServer().";

    public final static String UNMATCH_COUNT_INTERNAL_ERROR_SERVER
        = "Detecting unmatch parameter count in ObjectServer().";
    public final static String OBJECT_PORT_NOT_FOUND_ERROR_SERVER
        = "Object port not found in ObjectServer().";
    public final static String REQUEST_PORT_NOT_FOUND_ERROR_SERVER
        = "Request port not found in ObjectServer().";
    public final static String COMMAND_NOT_FOUND_SERVER
        = "Command not found in ObjectServer().";
    public final static String URI_PARAMETER_NULL_SERVER
        = "URI parameter is null in ObjectServer().";
    public final static String FILENAME_PARAMETER_NULL_SERVER
        = "Filename parameter is null in ObjectServer().";
    public final static String COMMAND_PARAMETER_NULL_SERVER
        = "Command parameter is null in ObjectServer().";
    public final static String CLASS_PARAMETER_NULL_SERVER
        = "Class parameter is null in ObjectServer().";
    public final static String CLASSNAME_PARAMETER_NULL_SERVER
        = "Classname parameter is null in ObjectServer().";
    public final static String OUTPUT_STREAM_PARAMETER_NULL_SERVER
        = "Output stream parameter is null in ObjectServer().";
    public final static String INPUT_STREAM_PARAMETER_NULL_SERVER
        = "Input stream parameter is null in ObjectServer().";
    public final static String OBJECT_TABLE_PARAMETER_NULL_SERVER
        = "Object table parameter is null in ObjectServer().";
    public final static String OBJECT_PARAMETER_NULL_SERVER
        = "Object parameter is null in ObjectServer().";
    public final static String OBJECT_SUFFIX_CORRUPTED_ERROR
        = "Object suffix corrupted in ObjectServer().";
    public final static String WRITE_JAR_FILE_BUFFER_SERVER
        = "Buffer is null in WriteJarFile().";
    public final static String SOCKET_NULL_UNLOCK_AND_SHUTDOWN
        = "Socket is null in unlockAndShutdown().";
    public final static String INPUTSTREAM_NULL_DO_REGISTER_CONNECTION_SERVER
        = "Command not found in doRegisterConnecion() in ObjectServer().";
    public final static String COMMAND_NOT_FOUND_REGISTER_CONNECTION_SERVER
        = "Command not found in doRegisterConnecion() in ObjectServer().";
    public final static String SOCKET_NULL_DO_REGISTER_CONNECTION_SERVER
        = "Socket is null in doRegisterConnecion() in ObjectServer().";
    public final static String SOCKET_NULL_DO_SERVICE_CONNECTION_SERVER
        = "Socket is null in doServiceConnection() in ObjectServer().";
    public final static String SOCKET_NULL_DO_FORWARD_CONNECTION_SERVER
        = "Socket is null in doForwardConnection() in ObjectServer().";
    public final static String SOCKET_NULL_DO_SYSTEM_CONNECTION_SERVER
        = "Socket is null in doSystemConnection() in ObjectServer().";
    public final static String SOCKET_NULL_DO_SYSTEM_COMMAND_SERVER
        = "Socket is null in doSystemCommand() in ObjectServer().";
    public final static String COMMAND_NOT_FOUND_DO_SYSTEM_CONNECTION_SERVER
        = "Command not found in doSystemConnection() in ObjectServer().";
    public final static String COMMAND_NOT_FOUND_DO_SYSTEM_COMMAND_SERVER
        = "Command not found in doSystemCommand() in ObjectServer().";
    public final static String ID_NOT_FOUND_DO_SYSTEM_COMMAND_SERVER
        = "Id not found in doSystemCommand() in ObjectServer().";
    public final static String PARAMETER_ERROR_DO_SYSTEM_COMMAND_SERVER
        = "Parameter error in doSystemCommand() in ObjectServer().";
    public final static String SOCKET_FAILURE_DO_SERVICE_CONNECTION_SERVER
        = "Socket connection fails in doServiceConnection() in ObjectServer().";
    public final static String SOCKET_FAILURE_DO_SYSTEM_CONNECTION_SERVER
        = "Socket connection fails in doSystemConnection() in ObjectServer().";
    public final static String FORBIDDEN_FORWARD_SERVICE_SERVER
        = "Forbidden forward service in ObjectServer().";
    public final static String ILLEGAL_FORWARD_SERVICE_SERVER
        = "Illegal forward service in ObjectServer().";
    public final static String ILLEGAL_FORMAT_PARAMETER_SERVER
        = "User's command was illegal format in ObjectServer().";
    public final static String DEBUG_LEVEL_VALUE_ERROR_SERVER
        = "oserv.debug.level property's value is illegal in ObjectServer().";
    public final static String RETRY_COUNT_VALUE_ERROR_SERVER
        = "oserv.retry.count property's value is illegal in ObjectServer().";
    public final static String CONNECTION_TIMEOUT_VALUE_ERROR_SERVER
        = "oserv.connection.timeout property's value is illegal in ObjectServer().";
    public final static String BUFFER_MAXIMUM_VALUE_ERROR_SERVER
        = "oserv.buffer.maximum property's value is illegal in ObjectServer().";
    public final static String TABLE_SIZE_VALUE_ERROR_SERVER
        = "oserv.table.size property's value is illegal in ObjectServer().";
    public final static String READ_FORWARD_TABLE_PARAMETER_ERROR_SERVER
        = "Parameter error in readForwardTable() in ObjectServer().";

    public final static String OBJECT_NOT_FOUND_EXCEPTION_SERVER
        = "Object not found in ObjectServer().";
    public final static String OBJECT_DUPLICATE_EXCEPTION_SERVER
        = "Object already exists in ObjectServer().";
    public final static String TEMPORARY_DIRECTORY_NOT_FOUND_ERROR_SERVER
        = "Temporary directory not found in ObjectServer().";
    public final static String TRANSIENT_DIRECTORY_NOT_CREATED_ERROR_SERVER
        = "Failure of creation of Transient directory in ObjectServer().";
    public final static String DEBUG_LEVEL_CONFIGURATION_ERROR_SERVER
        = "Debug level configuration error in ObjectServer().";


    public final static String FILENAME_PARAMETER_NULL_LOADER
        = "Filename parameter is null in UserClassLoader().";
    public final static String CLASSNAME_PARAMETER_NULL_LOADER
        = "Classname parameter is null in UserClassLoader().";

    public final static String IS_INPUT_STREAM_PARAMETER_ERROR_WRAPPER
        = "isInputStreamParameter() is not found in CallMethodWrapper().";
    public final static String IS_INPUT_STREAM_PARAMETER_INVOKE_ERROR_WRAPPER
        = "isInputStreamParameter() is not executed in CallMethodWrapper().";
    public final static String PARAMETER_ERROR_SET_METHOD_WRAPPER
        = "Parameter error in setMethod in CallMethodWrapper().";
    public final static String PARAMETER_ERROR_CONSTRUCTOR_WRAPPER
        = "Parameter error in constructor in CallMethodWrapper().";
    public final static String PARAMETER_ERROR_INVOKE_WRAPPER
        = "Parameter error in invoke in CallMethodWrapper().";
    public final static String PARAMETER_ERROR_SETINTPARAMETER_WRAPPER
        = "Parameter error in setintParameter in CallMethodWrapper().";
    public final static String PARAMETER_ERROR_SETLONGPARAMETER_WRAPPER
        = "Parameter error in setlongParameter in CallMethodWrapper().";
    public final static String PARAMETER_ERROR_SETFLOATPARAMETER_WRAPPER
        = "Parameter error in setfloatParameter in CallMethodWrapper().";
    public final static String PARAMETER_ERROR_SETDOUBLEPARAMETER_WRAPPER
        = "Parameter error in setdoubleParameter in CallMethodWrapper().";
    public final static String PARAMETER_ERROR_SETSHORTPARAMETER_WRAPPER
        = "Parameter error in setshortParameter in CallMethodWrapper().";
    public final static String PARAMETER_ERROR_SETBYTEPARAMETER_WRAPPER
        = "Parameter error in setbyteParameter in CallMethodWrapper().";
    public final static String PARAMETER_ERROR_SETCHARPARAMETER_WRAPPER
        = "Parameter error in setcharParameter in CallMethodWrapper().";
    public final static String PARAMETER_ERROR_SETBOOLEANPARAMETER_WRAPPER
        = "Parameter error in setbooleanParameter in CallMethodWrapper().";
    public final static String PARAMETER_ERROR_SETOBJECTPARAMETER_WRAPPER
        = "Parameter error in setObjectParameter in CallMethodWrapper().";
    public final static String PARAMETER_ERROR_GETINTVALUE_WRAPPER
        = "Parameter error in getintValue in CallMethodWrapper().";
    public final static String PARAMETER_ERROR_GETLONGVALUE_WRAPPER
        = "Parameter error in getlongValue in CallMethodWrapper().";
    public final static String PARAMETER_ERROR_GETFLOATVALUE_WRAPPER
        = "Parameter error in getfloatValue in CallMethodWrapper().";
    public final static String PARAMETER_ERROR_GETDOUBLEVALUE_WRAPPER
        = "Parameter error in getdoubleValue in CallMethodWrapper().";
    public final static String PARAMETER_ERROR_GETBOOLEANVALUE_WRAPPER
        = "Parameter error in getbooleanValue in CallMethodWrapper().";
    public final static String PARAMETER_ERROR_GETBYTEVALUE_WRAPPER
        = "Parameter error in getbyteValue in CallMethodWrapper().";
    public final static String PARAMETER_ERROR_GETSHORTVALUE_WRAPPER
        = "Parameter error in getshortValue in CallMethodWrapper().";
    public final static String PARAMETER_ERROR_GETCHARVALUE_WRAPPER
        = "Parameter error in getcharValue in CallMethodWrapper().";
    public final static String PARAMETER_ERROR_GETOBJECTVALUE_WRAPPER
        = "Parameter error in getObjectValue in CallMethodWrapper().";

    public final static String GET_CALL_METHOD_METHOD_ERROR_WRAPPER
        = "getCallMethod method is not found in CallMethod() in CallMethodWrapper().";
    public final static String SET_OBJECT_METHOD_INVOKE_ERROR_WRAPPER
        = "setObject method is not executed in CallMethodWrapper().";


/**
    public final static String INVOKE_METHOD_ERROR_CALL_METHOD
        = "invoke method is not found in CallMethod().";
    public final static String SET_METHOD_METHOD_ERROR_CALL_METHOD
        = "setMethod method is not found in CallMethod().";
    public final static String GET_PARAMETER_COUNT_METHOD_ERROR_CALL_METHOD
        = "getParameterCount method is not found in CallMethod().";
    public final static String SET_INT_PARAMETER_METHOD_ERROR_CALL_METHOD
        = "setintParameter method is not found in CallMethod().";
    public final static String SET_LONG_PARAMETER_METHOD_ERROR_CALL_METHOD
        = "setlongParameter method is not found in CallMethod().";
    public final static String SET_FLOAT_PARAMETER_METHOD_ERROR_CALL_METHOD
        = "setfloatParameter method is not found in CallMethod().";
    public final static String SET_DOUBLE_PARAMETER_METHOD_ERROR_CALL_METHOD
        = "setdoubleParameter method is not found in CallMethod().";
    public final static String SET_BYTE_PARAMETER_METHOD_ERROR_CALL_METHOD
        = "setbyteParameter method is not found in CallMethod().";
    public final static String SET_SHORT_PARAMETER_METHOD_ERROR_CALL_METHOD
        = "setshortParameter method is not found in CallMethod().";
    public final static String SET_CHAR_PARAMETER_METHOD_ERROR_CALL_METHOD
        = "setcharParameter method is not found in CallMethod().";
    public final static String SET_BOOLEAN_PARAMETER_METHOD_ERROR_CALL_METHOD
        = "setbooleanParameter method is not found in CallMethod().";
    public final static String SET_OBJECT_PARAMETER_METHOD_ERROR_CALL_METHOD
        = "setObjectParameter method is not found in CallMethod().";
    public final static String GET_INT_VALUE_METHOD_ERROR_CALL_METHOD
        = "getintValue method is not found in CallMethod().";
    public final static String GET_LONG_VALUE_METHOD_ERROR_CALL_METHOD
        = "getlongValue method is not found in CallMethod().";
    public final static String GET_FLOAT_VALUE_METHOD_ERROR_CALL_METHOD
        = "getfloatValue method is not found in CallMethod().";
    public final static String GET_DOUBLE_VALUE_METHOD_ERROR_CALL_METHOD
        = "getdoubleValue method is not found in CallMethod().";
    public final static String GET_BYTE_VALUE_METHOD_ERROR_CALL_METHOD
        = "getbyteValue method is not found in CallMethod().";
    public final static String GET_CHAR_VALUE_METHOD_ERROR_CALL_METHOD
        = "getcharValue method is not found in CallMethod().";
    public final static String GET_BOOLEAN_VALUE_METHOD_ERROR_CALL_METHOD
        = "getbooleanValue method is not found in CallMethod().";
    public final static String GET_SHORT_VALUE_METHOD_ERROR_CALL_METHOD
        = "getshortValue method is not found in CallMethod().";
    public final static String GET_OBJECT_VALUE_METHOD_ERROR_CALL_METHOD
        = "getObjectValue method is not found in CallMethod().";
**/
    public final static String INVOKE_SET_PARAMETER_ERROR_WRAPPER
        = "fail to set parameter for invoke method in CallMethodWrapper().";
    public final static String INVOKE_INVOKE_ERROR_WRAPPER
        = "invoke is not executed in CallMethodWrapper().";
    public final static String INVOKE_METHOD_ERROR_WRAPPER
        = "invoke method is not found in CallMethodWrapper().";

    public final static String SET_METHOD_SET_PARAMETER_ERROR_WRAPPER
        = "fail to set parameter for setMethod method in CallMethodWrapper().";
    public final static String SET_METHOD_INVOKE_ERROR_WRAPPER
        = "setMethod is not executed in CallMethodWrapper().";
    public final static String SET_METHOD_METHOD_ERROR_WRAPPER
        = "setMethod method is not found in CallMethodWrapper().";

    public final static String GET_COUNT_INVOKE_ERROR_WRAPPER
        = "getCount is not executed in CallMethodWrapper().";
    public final static String GET_COUNT_METHOD_ERROR_WRAPPER
        = "getCount method is not found in CallMethodWrapper().";
    public final static String GET_COUNT_RETURN_ERROR_WRAPPER
        = "getCount not get return value in CallMethodWrapper().";



    public final static String GET_PARAMETER_TYPE_SET_PARAMETER_ERROR_WRAPPER
        = "fail to set parameter for getParameterType method in CallMethodWrapper().";
    public final static String GET_PARAMETER_TYPE_INVOKE_ERROR_WRAPPER
        = "getParameterType is not executed in CallMethodWrapper().";
    public final static String GET_PARAMETER_TYPE_RETURN_ERROR_WRAPPER
        = "getParameterType not get return value in CallMethodWrapper().";
    public final static String GET_PARAMETER_TYPE_METHOD_ERROR_WRAPPER
        = "getParameterType method is not found in CallMethodWrapper().";


    public final static String GET_PARAMETER_SET_PARAMETER_ERROR_WRAPPER
        = "fail to set parameter for getParameter method in CallMethodWrapper().";
    public final static String GET_PARAMETER_INVOKE_ERROR_WRAPPER
        = "getParameter is not executed in CallMethodWrapper().";
    public final static String GET_PARAMETER_RETURN_ERROR_WRAPPER
        = "getParameter not get return value in CallMethodWrapper().";
    public final static String GET_PARAMETER_METHOD_ERROR_WRAPPER
        = "getParameter method is not found in CallMethod() in CallMethodWrapper().";


    public final static String SET_INT_PARAMETER_INVOKE_ERROR_WRAPPER
        = "setintParameter is not executed in CallMethodWrapper().";
    public final static String SET_INT_PARAMETER_SET_PARAMETER_ERROR_WRAPPER
        = "fail to set parameter for setintParameter method in CallMethodWrapper().";
    public final static String SET_INT_PARAMETER_METHOD_ERROR_WRAPPER
        = "setintParameter method is not found in CallMethodWrapper().";



    public final static String SET_LONG_PARAMETER_INVOKE_ERROR_WRAPPER
        = "setlongParameter is not executed in CallMethodWrapper().";
    public final static String SET_LONG_PARAMETER_SET_PARAMETER_ERROR_WRAPPER
        = "fail to set parameter for setlongParameter method in CallMethodWrapper().";
    public final static String SET_LONG_PARAMETER_METHOD_ERROR_WRAPPER
        = "setlongParameter method is not found in CallMethodWrapper().";



    public final static String SET_FLOAT_PARAMETER_INVOKE_ERROR_WRAPPER
        = "setfloatParameter is not executed in CallMethodWrapper().";
    public final static String SET_FLOAT_PARAMETER_SET_PARAMETER_ERROR_WRAPPER
        = "fail to set parameter for setfloatParameter method in CallMethodWrapper().";
    public final static String SET_FLOAT_PARAMETER_METHOD_ERROR_WRAPPER
        = "setfloatParameter method is not found in CallMethodWrapper().";



    public final static String SET_DOUBLE_PARAMETER_INVOKE_ERROR_WRAPPER
        = "setdoubleParameter is not executed in CallMethodWrapper().";
    public final static String SET_DOUBLE_PARAMETER_SET_PARAMETER_ERROR_WRAPPER
        = "fail to set parameter for setdoubleParameter method in CallMethodWrapper().";
    public final static String SET_DOUBLE_PARAMETER_METHOD_ERROR_WRAPPER
        = "setdoubleParameter method is not found in CallMethodWrapper().";


    public final static String SET_BYTE_PARAMETER_INVOKE_ERROR_WRAPPER
        = "setbyteParameter is not executed in CallMethodWrapper().";
    public final static String SET_BYTE_PARAMETER_SET_PARAMETER_ERROR_WRAPPER
        = "fail to set parameter for setbyteParameter method in CallMethodWrapper().";
    public final static String SET_BYTE_PARAMETER_METHOD_ERROR_WRAPPER
        = "setbyteParameter method is not found in CallMethodWrapper().";



    public final static String SET_SHORT_PARAMETER_INVOKE_ERROR_WRAPPER
        = "setshortParameter is not executed in CallMethodWrapper().";
    public final static String SET_SHORT_PARAMETER_SET_PARAMETER_ERROR_WRAPPER
        = "fail to set parameter for setshortParameter method in CallMethodWrapper().";
    public final static String SET_SHORT_PARAMETER_METHOD_ERROR_WRAPPER
        = "setshortParameter method is not found in CallMethodWrapper().";



    public final static String SET_BOOLEAN_PARAMETER_INVOKE_ERROR_WRAPPER
        = "setbooleanParameter is not executed in CallMethodWrapper().";
    public final static String SET_BOOLEAN_PARAMETER_SET_PARAMETER_ERROR_WRAPPER
        = "fail to set parameter for setbooleanParameter method in CallMethodWrapper().";
    public final static String SET_BOOLEAN_PARAMETER_METHOD_ERROR_WRAPPER
        = "setbooleanParameter method is not found in CallMethodWrapper().";



    public final static String SET_CHAR_PARAMETER_INVOKE_ERROR_WRAPPER
        = "setcharParameter is not executed in CallMethodWrapper().";
    public final static String SET_CHAR_PARAMETER_SET_PARAMETER_ERROR_WRAPPER
        = "fail to set parameter for setcharParameter method in CallMethodWrapper().";
    public final static String SET_CHAR_PARAMETER_METHOD_ERROR_WRAPPER
        = "setcharParameter method is not found in CallMethodWrapper().";



    public final static String SET_OBJECT_PARAMETER_INVOKE_ERROR_WRAPPER
        = "setObjectParameter is not executed in CallMethodWrapper().";
    public final static String SET_OBJECT_PARAMETER_SET_PARAMETER_ERROR_WRAPPER
        = "fail to set parameter for setObjectParameter method in CallMethodWrapper().";
    public final static String SET_OBJECT_PARAMETER_METHOD_ERROR_WRAPPER
        = "setObjectParameter method is not found in CallMethodWrapper().";



    public final static String GET_INT_VALUE_RETURN_ERROR_WRAPPER
        = "getintValue not get return value in CallMethodWrapper().";
    public final static String GET_INT_VALUE_INVOKE_ERROR_WRAPPER
        = "getintValue is not executed in CallMethodWrapper().";
    public final static String GET_INT_VALUE_SET_PARAMETER_ERROR_WRAPPER
        = "fail to set parameter for getintValue method in CallMethodWrapper().";
    public final static String GET_INT_VALUE_METHOD_ERROR_WRAPPER
        = "getintValue method is not found in CallMethodWrapper().";


    public final static String GET_LONG_VALUE_RETURN_ERROR_WRAPPER
        = "getlongValue not get return value in CallMethodWrapper().";
    public final static String GET_LONG_VALUE_INVOKE_ERROR_WRAPPER
        = "getlongValue is not executed in CallMethodWrapper().";
    public final static String GET_LONG_VALUE_SET_PARAMETER_ERROR_WRAPPER
        = "fail to set parameter for getlongValue method in CallMethodWrapper().";
    public final static String GET_LONG_VALUE_METHOD_ERROR_WRAPPER
        = "getlongValue method is not found in CallMethodWrapper().";



    public final static String GET_FLOAT_VALUE_RETURN_ERROR_WRAPPER
        = "getfloatValue not get return value in CallMethodWrapper().";
    public final static String GET_FLOAT_VALUE_INVOKE_ERROR_WRAPPER
        = "getfloatValue is not executed in CallMethodWrapper().";
    public final static String GET_FLOAT_VALUE_SET_PARAMETER_ERROR_WRAPPER
        = "fail to set parameter for getfloatValue method in CallMethodWrapper().";
    public final static String GET_FLOAT_VALUE_METHOD_ERROR_WRAPPER
        = "getfloatValue method is not found in CallMethodWrapper().";



    public final static String GET_DOUBLE_VALUE_RETURN_ERROR_WRAPPER
        = "getdoubleValue not get return value in CallMethodWrapper().";
    public final static String GET_DOUBLE_VALUE_INVOKE_ERROR_WRAPPER
        = "getdoubleValue is not executed in CallMethodWrapper().";
    public final static String GET_DOUBLE_VALUE_SET_PARAMETER_ERROR_WRAPPER
        = "fail to set parameter for getdoubleValue method in CallMethodWrapper().";
    public final static String GET_DOUBLE_VALUE_METHOD_ERROR_WRAPPER
        = "getdoubleValue method is not found in CallMethodWrapper().";



    public final static String GET_BYTE_VALUE_RETURN_ERROR_WRAPPER
        = "getbyteValue not get return value in CallMethodWrapper().";
    public final static String GET_BYTE_VALUE_INVOKE_ERROR_WRAPPER
        = "getbyteValue is not executed in CallMethodWrapper().";
    public final static String GET_BYTE_VALUE_SET_PARAMETER_ERROR_WRAPPER
        = "fail to set parameter for getbyteValue method in CallMethodWrapper().";
    public final static String GET_BYTE_VALUE_METHOD_ERROR_WRAPPER
        = "getbyteValue method is not found in CallMethodWrapper().";



    public final static String GET_CHAR_VALUE_RETURN_ERROR_WRAPPER
        = "getcharValue not get return value in CallMethodWrapper().";
    public final static String GET_CHAR_VALUE_INVOKE_ERROR_WRAPPER
        = "getcharValue is not executed in CallMethodWrapper().";
    public final static String GET_CHAR_VALUE_SET_PARAMETER_ERROR_WRAPPER
        = "fail to set parameter for getcharValue method in CallMethodWrapper().";
    public final static String GET_CHAR_VALUE_METHOD_ERROR_WRAPPER
        = "getcharValue method is not found in CallMethodWrapper().";



    public final static String GET_BOOLEAN_VALUE_RETURN_ERROR_WRAPPER
        = "getbooleanValue not get return value in CallMethodWrapper().";
    public final static String GET_BOOLEAN_VALUE_INVOKE_ERROR_WRAPPER
        = "getbooleanValue is not executed in CallMethodWrapper().";
    public final static String GET_BOOLEAN_VALUE_SET_PARAMETER_ERROR_WRAPPER
        = "fail to set parameter for getbooleanValue method in CallMethodWrapper().";
    public final static String GET_BOOLEAN_VALUE_METHOD_ERROR_WRAPPER
        = "getbooleanValue method is not found in CallMethodWrapper().";



    public final static String GET_SHORT_VALUE_RETURN_ERROR_WRAPPER
        = "getshortValue not get return value in CallMethodWrapper().";
    public final static String GET_SHORT_VALUE_INVOKE_ERROR_WRAPPER
        = "getshortValue is not executed in CallMethodWrapper().";
    public final static String GET_SHORT_VALUE_SET_PARAMETER_ERROR_WRAPPER
        = "fail to set parameter for getshortValue method in CallMethodWrapper().";
    public final static String GET_SHORT_VALUE_METHOD_ERROR_WRAPPER
        = "getshortValue method is not found in CallMethodWrapper().";



    public final static String GET_OBJECT_VALUE_RETURN_ERROR_WRAPPER
        = "getObjectValue not get return value in CallMethodWrapper().";
    public final static String GET_OBJECT_VALUE_INVOKE_ERROR_WRAPPER
        = "getObjectValue is not executed in CallMethodWrapper().";
    public final static String GET_OBJECT_VALUE_SET_PARAMETER_ERROR_WRAPPER
        = "fail to set parameter for getObjectValue method in CallMethodWrapper().";
    public final static String GET_OBJECT_VALUE_METHOD_ERROR_WRAPPER
        = "getObjectValue method is not found in CallMethodWrapper().";


    public final static String GET_PARAMETER_COUNT_METHOD_ERROR_WRAPPER
        = "getParameterCount method is not found in CallMethodWrapper().";

    /**
     * These error message is used in ObjectClient.java
     */
    public final static String HOST_CONFIGURATION_ERROR_CLIENT
        = "A target Host isn't configured in ObjectClient().";
    public final static String PORT_CONFIGURATION_ERROR_CLIENT
        = "A target port isn't configured in ObjectClient().";
    public final static String COMMAND_PARAMETER_NULL_CLIENT
        = "Command parameter is null in connect() in ObjectClient().";
    public final static String FIELD_PARAMETER_NULL_CLIENT
        = "Field parameter is null in connect() in ObjectClient().";
    public final static String OBJECT_PARAMETER_NULL_CLIENT
        = "Object parameter is null in connect() in ObjectClient().";

    public final static String DEBUG_LEVEL_VALUE_ERROR_CLIENT
        = "oserv.debug.level property's value is illegal in ObjectClient().";
    public final static String SERVICE_HOSTNAME_VALUE_ERROR_CLIENT
        = "oserv.service.hostname property's value is illegal in ObjectClient().";
    public final static String REQUEST_PORT_VALUE_ERROR_CLIENT
        = "oserv.request.port property's value is illegal in ObjectClient().";
    public final static String RETRY_COUNT_VALUE_ERROR_CLIENT
        = "oserv.retry.count property's value is illegal in ObjectClient().";
    public final static String CONNECTION_TIMEOUT_VALUE_ERROR_CLIENT
        = "oserv.connection.timeout property's value is illegal in ObjectClient().";
    public final static String BUFFER_MAXIMUM_VALUE_ERROR_CLIENT
        = "oserv.buffer.maximum property's value is illegal in ObjectClient().";
    public final static String TABLE_SIZE_VALUE_ERROR_CLIENT
        = "oserv.table.size property's value is illegal in ObjectClient().";
    public final static String JAR_FILE_NULL_READ_PROPERTY_FROM_JAR
        = "Jar file is null readPropertyFromJar() in ObjectClient.";
    public final static String CONNECTION_ERROR_CLIENT
        = "fail to connect in ObjectClient().";

    /**
     * These error message is used in ObjectService.java
     */
    public final static String IO_CONSTRUCTION_ERROR_SERVICE
        = "I/O Construction fails in ObjectService().";
    public final static String HOST_CONFIGURATION_ERROR_SERVICE
        = "A target Host isn't configured in ObjectService().";
    public final static String CONNECTION_ERROR_SERVICE
        = "fail to connect in ObjectService().";
    public final static String OUTPUT_STREAM_ERROR_SERVICE
        = "fail to create in ObjectService().";
    public final static String GET_ENTRY_ERROR_SERVICE
        = "fail to get entry in ObjectService().";
    public final static String FILE_ALREADY_EXIST_ERROR_SERVICE
        = "file already exist in ObjectService().";
    public final static String PARAMETER_NULL_SERVICE
        = "Parameter is null in ObjectService().";

    /**
     * These error message is used in ObjectTool.java
     */
    public final static String IO_CONSTRUCTION_ERROR_TOOL
        = "I/O Construction fails in ObjectTool().";
    public final static String GETOUTPUTSTREAM_PARAMETER_NULL_TOOL
        = "Parameter is null in getOutputStream in ObjectTool().";
    public final static String GETINPUTSTREAM_PARAMETER_NULL_TOOL
        = "Parameter is null in getInputStream in ObjectTool().";
    public final static String CLOSE_PARAMETER_NULL_TOOL
        = "Parameter is null in close in ObjectTool().";
    public final static String PARAMETER_NULL_REQUIRE_REMOVEMENT_TOOL
        = "Parameter is null in requireRemovement in ObjectTool().";
    public final static String PARAMETER_NULL_REQUIRE_REGISTRATION_TOOL
        = "Parameter is null in requireRegistration in ObjectTool().";

    public final static String HOST_CONFIGURATION_ERROR_TOOL
        = "A target Host isn't configured in ObjectTool().";
    public final static String PORT_CONFIGURATION_ERROR_TOOL
        = "A target port isn't configured in ObjectTool().";
    public final static String PORT_VALUE_ERROR_TOOL
        = "A target port isn't the right value in ObjectTool().";
    public final static String HOSTNAME_PARAMETER_NULL_TOOL
        = "A parameter hostname is null in ObjectTool().";

    public final static String DEBUG_LEVEL_VALUE_ERROR_TOOL
        = "oserv.debug.level property's value is illegal in ObjectTool().";
    public final static String SERVICE_HOSTNAME_VALUE_ERROR_TOOL
        = "oserv.service.hostname property's value is illegal in ObjectTool().";
    public final static String OBJECT_PORT_VALUE_ERROR_TOOL
        = "oserv.object.port property's value is illegal in ObjectTool().";
    public final static String RETRY_COUNT_VALUE_ERROR_TOOL
        = "oserv.retry.count property's value is illegal in ObjectTool().";
    public final static String CONNECTION_TIMEOUT_VALUE_ERROR_TOOL
        = "oserv.connection.timeout property's value is illegal in ObjectTool().";
    public final static String BUFFER_MAXIMUM_VALUE_ERROR_TOOL
        = "oserv.buffer.maximum property's value is illegal in ObjectTool().";
    public final static String TABLE_SIZE_VALUE_ERROR_TOOL
        = "oserv.table.size property's value is illegal in ObjectTool().";
    public final static String INPUT_FILE_NULL_READ_TOOL
        = "input file is null in read() in ObjectTool().";
    public final static String BUFFER_NULL_READ_TOOL
        = "buffer is null in read() in ObjectTool().";
    public final static String OUTPUT_STREAM_NULL_WRITE_TOOL
        = "OutputStream is null in write() in ObjectTool().";
    public final static String JAR_NAME_NULL_WRITE_TOOL
        = "jarname is null in write() in ObjectTool().";
    public final static String BUFFER_NULL_WRITE_TOOL
        = "buffer is null in write() in ObjectTool().";
    public final static String PARAMETER_NULL_REQUEST_LIST_TOOL
        = "Parameter null in requestList() in ObjectTool().";


    public final static String DEBUG_FUNCTION_ERROR_GENERATOR
        = "Error enabling debug feature for a function.";
    public final static String REAL_CLASS_WAS_SPECIFIED_GENERATOR
        = "Real class was specified in ObjectGenerator().";
    public final static String PACKAGE_NAME_WAS_UNMATCHED_GENERATOR
        = "Package name was unmatched.";
    public final static String DIRECTORY_WAS_NOT_FOUND_GENERATOR
        = "Directory wasn't found.";
    public final static String PACKAGE_WAS_NOT_SPECIFIED_GENERATOR
        = "Package wasn't specified.";
    public final static String HOST_CONFIGURATION_ERROR_GENERATOR
        = "A target Host isn't configured in ObjectGenerator().";
    public final static String PORT_CONFIGURATION_ERROR_GENERATOR
        = "A target port isn't configured in ObjectGenerator().";
    public final static String FILENAME_PARAMETER_NULL_GENERATOR
        = "Filename parameter is null in ObjectGenerator().";
    public final static String INTERFACE_PARAMETER_NULL_GENERATOR
        = "Interface parameter is null in ObjectGenerator().";
    public final static String CLASS_PARAMETER_NULL_GENERATOR
        = "Class parameter is null in ObjectGenerator().";
    public final static String CLASS_FILENAME_PARAMETER_NULL_GENERATOR
        = "Class parameter is null in ObjectGenerator().";
    public final static String DIRECTORY_PARAMETER_NULL_GENERATOR
        = "Directory parameter is null in ObjectGenerator().";
    public final static String TARGETNAME_PARAMETER_NULL_GENERATOR
        = "Target name parameter is null in ObjectGenerator().";
    public final static String PACKAGENAME_PARAMETER_NULL_GENERATOR
        = "Package name is null in ObjectGenerator().";

    public final static String DEBUG_LEVEL_VALUE_ERROR_GENERATOR
        = "oserv.debug.level property's value is illegal in ObjectGenerator().";
    public final static String SERVICE_HOSTNAME_VALUE_ERROR_GENERATOR
        = "oserv.service.hostname property's value is illegal in ObjectGenerator().";
    public final static String REQUEST_PORT_VALUE_ERROR_GENERATOR
        = "oserv.request.port property's value is illegal in ObjectGenerator().";
    public final static String RETRY_COUNT_VALUE_ERROR_GENERATOR
        = "oserv.retry.count property's value is illegal in ObjectGenerator().";
    public final static String CONNECTION_TIMEOUT_VALUE_ERROR_GENERATOR
        = "oserv.connection.timeout property's value is illegal in ObjectGenerator().";
    public final static String BUFFER_MAXIMUM_VALUE_ERROR_GENERATOR
        = "oserv.buffer.maximum property's value is illegal in ObjectGenerator().";
    public final static String TABLE_SIZE_VALUE_ERROR_GENERATOR
        = "oserv.table.size property's value is illegal in ObjectGenerator().";


    public final static String COPY_JAR_FILE_LENGTH_ZERO_SERVER
        = "Length zero in copyJarFile() in ObjectServer().";
    public final static String COPY_JAR_FILE_PARAMETER_NULL_SERVER
        = "Null parameter in copyJarFile() in ObjectServer().";
    public final static String COPY_OBJECT_STREAM_CONSTRUCTION_EXCEPTION
        = "Construction exception in CopyObjectStream().";
    public final static String OBJECT_OUTPUT_STREAM_PARAMETER_NULL_SERVER
        = "ObjectOutputStream is null in ObjectServer().";
    public final static String BUFFER_PARAMETER_NULL_SERVER
        = "Buffer is null in ObjectServer().";

    public final static String BUSY_EXCEPTION_OPERATETHREADTABLE_SERVER
        = "Busy exception in operateThreadTable() in ObjectServer().";
    public final static String PARAMETER_ERROR_OPERATETHREADTABLE_SERVER
        = "Parameter error in operateThreadTable() in ObjectServer().";
    public final static String PARAMETER_ERROR_THREAD_TABLE
        = "Parameter error in ThreadTable.";
    public final static String NO_INITIALIZATION_EXCEPTION_THREAD_TABLE
        = "No initialiation exception in ThreadTable.";

    public final static String PARAMETER_ERROR_TOOL
        = "Parameter error in ObjectTool().";
    public final static String JAR_FILE_FORMAT_ERROR_TOOL
        = "Jar file format error in ObjectTool().";
    public final static String ILLEGAL_OPTION_ERROR_TOOL
        = "illegal option was specified in ObjectTool().";
    public final static String CHECK_JAR_ERROR_TOOL
        = "Jar file name error in ObjectTool().";
    public final static String UNKNOWN_HOST_ERROR_TOOL
        = "Unknown Host error in ObjectTool().";
    public final static String IO_ERROR_TOOL
        = "I/O Error in ObjectTool().";
    public final static String SOCKET_IO_ERROR_TOOL
        = "Socket I/O error in ObjectTool().";
    public final static String INTERNAL_ERROR_TOOL
        = "Internal error in ObjectTool().";

    public final static String IO_CONSTRUCTION_ERROR_KILL
        = "I/O Construction fails in ObjectKill().";
    public final static String SERVICE_NOT_FOUND_ERROR_KILL
        = "Service is not found error in ObjectKill().";
    public final static String PORT_NOT_FOUND_ERROR_KILL
        = "Port not found in ObjectKill().";
    public final static String HOSTNAME_NOT_FOUND_ERROR_KILL
        = "Hostname not found in ObjectKill().";
    public final static String IO_ERROR_KILL
        = "I/O error in ObjectKill().";
    public final static String PARAMETER_ERROR_KILL
        = "Parameter error in ObjectKill().";
    public final static String IO_ERROR_SYSTEM
        = "I/O error in ObjectSystem().";
    public final static String PARAMETER_ERROR_SYSTEM
        = "Parameter error in ObjectSystem().";
    public final static String PORT_NOT_FOUND_ERROR_SYSTEM
        = "Port not found in ObjectSystem().";
    public final static String HOSTNAME_NOT_FOUND_ERROR_SYSTEM
        = "Hostname not found in ObjectSystem().";
    public final static String PARAMETER_ERROR_COMMAND
        = "Parameter error in ObjectCommand().";

    public final static String RETRY_COUNT_VALUE_ERROR_SERVICE
        = "oserv.retry.count property's value is illegal in ObjectService().";
    public final static String PARAMETER_ERROR_SERVICE
        = "Parameter error in ObjectService().";

    public final static String IO_CONSTRUCTION_ERROR_GENERATOR
        = "I/O Construction fails in ObjectGenerator().";
    public final static String PARAMETER_ERROR_GENERATOR
        = "Parameter error in ObjectGenerator().";
    public final static String INTERFACE_CLASS_NOT_FOUND_GENERATOR
        = "Interface class is not found in ObjectGenerator().";
    public final static String INTERNAL_ERROR_GENERATOR
        = "Internal error in ObjectGenerator().";
    public final static String ERROR_GENSTUB_CLASS_GENERATOR 
        = "Internal error in genStubClass() in ObjectGenerator().";

    public final static String ERROR_CONNECT_STARTUP_SERVER 
        = "Fail to startup connect service";
    public final static String ERROR_REGISTER_STARTUP_SERVER 
        = "Fail to startup register service";
    public final static String ERROR_FORWARD_STARTUP_SERVER 
        = "Fail to startup forward service";
    public final static String ERROR_THREAD_STARTUP_SERVER
        = "Fail to startup thread service";
    public final static String PARAMETER_ERROR_SERVER
        = "Parameter error in ObjectServer().";
    public final static String ERROR_SERVER_RUNNING_SERVER
        = "OServ has already run in ObjectServer().";
    public final static String ERROR_FAIL_LOCK_SERVER
        = "Fail to lock in ObjectServer().";
    public final static String ERROR_FAIL_CHECK_PROCESS_STATE_SERVER
        = "Fail to check in ProcessState in ObjectServer().";

    public final static String CONNECTION_TIMEOUT_VALUE_NOT_FOUND_SERVER
        = "oserv.connection.timeout property's value is not found in ObjectServer().";
    public final static String RETRY_COUNT_VALUE_NOT_FOUND_SERVER
        = "oserv.retry.count property's value is not found in ObjectServer().";
    public final static String BUFFER_MAXIMUM_VALUE_NOT_FOUND_SERVER
        = "oserv.buffer.maximum property's value is not found in ObjectServer().";
    public final static String TABLE_SIZE_VALUE_NOT_FOUND_SERVER
        = "oserv.table.size property's value is not found in ObjectServer().";
    public final static String MAX_THREAD_ERROR_SERVER
        = "Max Thread Value is illegal in ObjectServer().";
    public final static String MAX_THREAD_NOT_FOUND_SERVER
        = "Max Thread Value is not found in ObjectServer().";
    public final static String ERROR_FAIL_READ_FORWARDTABLE_SERVER
        = "Fail to read ForwardTable in ObjectServer().";
    public final static String ERROR_FAIL_READ_OBJECTTABLE_SERVER
        = "Fail to read ObjectTable in ObjectServer().";
    public final static String PERSISTENT_DIRECTORY_ERROR_SERVER 
        = "oserv.persistent.path is illegal in ObjectServer().";
    public final static String USER_DIRECTORY_ERROR_SERVER
        = "oserv.user.work is illegal in ObjectServer().";

    public final static String ERROR_FAIL_OPERATE_OBJECTFILE_SERVER
        = "Fail to operate ObjectFile in ObjectServer().";
    public final static String ERROR_FAIL_CLOSE_SERVER
        = "Fail to close in ObjectServer().";
    public final static String ID_NOT_FOUND_EXCEPTION_SERVER
        = "ID not found in ObjectServer().";

    public final static String RETRY_COUNT_VALUE_NOT_FOUND_TOOL
        = "oserv.retry.count property's value is not found in ObjectTool().";
    public final static String PORT_CONFIGURATION_NOT_FOUND_TOOL
        = "A target port isn't configured in ObjectTool().";

    public final static String IO_CONSTRUCTION_ERROR_CLIENT
        = "I/O Construction fails in ObjectClient().";
    public final static String STREAM_RETURN_ERROR_CLIENT
        = "Stream is not available in return.";

    public final static String OBJECT_OUTPUT_STREAM_RETURN_ERROR_CLIENT
        = "ObjectOutputStream is not available in return.";
    public final static String OBJECT_OUTPUT_STREAM_PARAMETER_ERROR_CLIENT
        = "ObjectOutputStream is not available as parameter.";
    public final static String PIPED_INPUT_STREAM_PARAMETER_ERROR_CLIENT
        = "PipedInputStream is not available as parameter.";
    public final static String OBJECT_INPUT_STREAM_PARAMETER_ERROR_CLIENT
        = "ObjectInputStream is not available as parameter.";
    public final static String PARAMETER_ERROR_CLIENT
        = "Parameter error in ObjectClient().";
    public final static String PORT_CONFIGURATION_NOT_FOUND_CLIENT
        = "A target port is not found in ObjectClient().";
    public final static String DEBUG_LEVEL_VALUE_NOT_FOUND_CLIENT
        = "oserv.debug.level property's value is not found in ObjectClient().";

    public final static String RETRY_COUNT_VALUE_NOT_FOUND_CLIENT
        = "oserv.retry.count property's value is not found in ObjectClient().";

    public final static String OVERFLOW_EXCEPTION_URITABLE
        = "Overflow exception in URITable().";
    public final static String ILLEGAL_OPTION_PARSEOPTIONS
        = "Option error in ParseOptions().";
    public final static String ILLEGAL_FORMAT_PARSEOPTIONS
        = "Format error in ParseOptions().";
    public final static String PARAMETER_ERROR_PARSEOPTIONS
        = "Parameter error in ParseOptions().";
    public final static String INDEX_OUTOFRANGE_PARSEOPTIONS 
        = "Index is out of range in ParseOptions().";
    public final static String PARAMETER_ERROR_PACKAGE
        = "Parameter error in Package().";
    public final static String PARAMETER_ERROR_STRINGOBJECT
        = "Parameter error in StringObject().";
    public final static String ENTRY_NOT_FOUND_STRINGOBJECT
        = "Entry not foundr in StringObject().";
    public final static String PARAMETER_ERROR_STRINGTABLE
        = "Parameter error in StringsTable().";
    public final static String ENTRY_NOT_FOUND_STRINGTABLE
        = "Entry not foundr in StringsTable().";
    public final static String ILLEGAL_COMMAND_TYPE_REGISTERCOMMAND
        = "Illegal command type in RegisterCommand().";

    public final static String PARAMETER_ERROR_VARIABLE_BYTE
        = "Parameter error in VariableByte().";
    public final static String PARAMETER_ERROR_MAKEDIRECTORIES
        = "Parameter error in MakeDirectories().";

    public final static String IO_ERROR_UTFINPUTSTREAM
        = "I/O Error in UTFInputStream().";

    public final static String IO_CONSTRUCTION_ERROR_LIBRARY
        = "I/O Construction fails in Library.";

    public final static String NOT_FOUND_JAR_ARCHIVE_OBJECT
        = "Jar archive was not found.";

    public final static String PARAMETER_IS_NOT_MOVABLE_EXCEPTION
        = "Parameter is not Movable.";
    public final static String PARAMETER_MESSAGE_HEAD
        = "Parameter of the Method";

    public final static String JAVA_STRING_BUFFER_INPUT_STREAM_EXCEPTION
        = "Exception happends in <init> in StringBufferInputStream.";
    public final static String JAVA_BYTE_ARRAY_INPUT_STREAM_EXCEPTION
        = "Exception happends in <init> in ByteArrayInputStream.";
    public final static String JAVA_BYTE_ARRAY_OUTPUT_STREAM_EXCEPTION
        = "Exception happends in <init> in ByteArrayOutputStream.";

    public final static String JAVA_FIELD_GET_ILLEGAL_ARGUMENT_EXCEPTION
        = "IllagelArgumentException happends in get in Field.";
    public final static String JAVA_FIELD_SET_ILLEGAL_ARGUMENT_EXCEPTION
        = "IllagelArgumentException happends in set in Field.";
    public final static String JAVA_FIELD_GET_BOOLEAN_ILLEGAL_ARGUMENT_EXCEPTION
        = "IllagelArgumentException happends in getBoolean in Field.";
    public final static String JAVA_FIELD_SET_BOOLEAN_ILLEGAL_ARGUMENT_EXCEPTION
        = "IllagelArgumentException happends in setBoolean in Field.";
    public final static String JAVA_FIELD_GET_SHORT_ILLEGAL_ARGUMENT_EXCEPTION
        = "IllagelArgumentException happends in getShort in Field.";
    public final static String JAVA_FIELD_SET_SHORT_ILLEGAL_ARGUMENT_EXCEPTION
        = "IllagelArgumentException happends in setShort in Field.";
    public final static String JAVA_FIELD_GET_CHAR_ILLEGAL_ARGUMENT_EXCEPTION
        = "IllagelArgumentException happends in getChar in Field.";
    public final static String JAVA_FIELD_SET_CHAR_ILLEGAL_ARGUMENT_EXCEPTION
        = "IllagelArgumentException happends in setChar in Field.";
    public final static String JAVA_FIELD_GET_BYTE_ILLEGAL_ARGUMENT_EXCEPTION
        = "IllagelArgumentException happends in getByte in Field.";
    public final static String JAVA_FIELD_SET_BYTE_ILLEGAL_ARGUMENT_EXCEPTION
        = "IllagelArgumentException happends in setByte in Field.";
    public final static String JAVA_FIELD_GET_DOUBLE_ILLEGAL_ARGUMENT_EXCEPTION
        = "IllagelArgumentException happends in getDouble in Field.";
    public final static String JAVA_FIELD_SET_DOUBLE_ILLEGAL_ARGUMENT_EXCEPTION
        = "IllagelArgumentException happends in setDouble in Field.";
    public final static String JAVA_FIELD_GET_FLOAT_ILLEGAL_ARGUMENT_EXCEPTION
        = "IllagelArgumentException happends in getFloat in Field.";
    public final static String JAVA_FIELD_SET_FLOAT_ILLEGAL_ARGUMENT_EXCEPTION
        = "IllagelArgumentException happends in setFloat in Field.";
    public final static String JAVA_FIELD_GET_LONG_ILLEGAL_ARGUMENT_EXCEPTION
        = "IllagelArgumentException happends in getLong in Field.";
    public final static String JAVA_FIELD_SET_LONG_ILLEGAL_ARGUMENT_EXCEPTION
        = "IllagelArgumentException happends in setLong in Field.";
    public final static String JAVA_FIELD_GET_INT_ILLEGAL_ARGUMENT_EXCEPTION
        = "IllagelArgumentException happends in getInt in Field.";
    public final static String JAVA_FIELD_SET_INT_ILLEGAL_ARGUMENT_EXCEPTION
        = "IllagelArgumentException happends in setInt in Field.";

    public final static String JAVA_FIELD_GET_ILLEGAL_ACCESS_EXCEPTION
        = "IllagelAccessException happends in get in Field.";
    public final static String JAVA_FIELD_SET_ILLEGAL_ACCESS_EXCEPTION
        = "IllagelAccessException happends in set in Field.";
    public final static String JAVA_FIELD_GET_BOOLEAN_ILLEGAL_ACCESS_EXCEPTION
        = "IllagelAccessException happends in getBoolean in Field.";
    public final static String JAVA_FIELD_SET_BOOLEAN_ILLEGAL_ACCESS_EXCEPTION
        = "IllagelAccessException happends in setBoolean in Field.";
    public final static String JAVA_FIELD_GET_BYTE_ILLEGAL_ACCESS_EXCEPTION
        = "IllagelAccessException happends in getByte in Field.";
    public final static String JAVA_FIELD_SET_BYTE_ILLEGAL_ACCESS_EXCEPTION
        = "IllagelAccessException happends in setByte in Field.";
    public final static String JAVA_FIELD_GET_SHORT_ILLEGAL_ACCESS_EXCEPTION
        = "IllagelAccessException happends in getShort in Field.";
    public final static String JAVA_FIELD_SET_SHORT_ILLEGAL_ACCESS_EXCEPTION
        = "IllagelAccessException happends in setShort in Field.";
    public final static String JAVA_FIELD_GET_CHAR_ILLEGAL_ACCESS_EXCEPTION
        = "IllagelAccessException happends in getChar in Field.";
    public final static String JAVA_FIELD_SET_CHAR_ILLEGAL_ACCESS_EXCEPTION
        = "IllagelAccessException happends in setChar in Field.";
    public final static String JAVA_FIELD_GET_DOUBLE_ILLEGAL_ACCESS_EXCEPTION
        = "IllagelAccessException happends in getDouble in Field.";
    public final static String JAVA_FIELD_SET_DOUBLE_ILLEGAL_ACCESS_EXCEPTION
        = "IllagelAccessException happends in setDouble in Field.";
    public final static String JAVA_FIELD_GET_FLOAT_ILLEGAL_ACCESS_EXCEPTION
        = "IllagelAccessException happends in getFloat in Field.";
    public final static String JAVA_FIELD_SET_FLOAT_ILLEGAL_ACCESS_EXCEPTION
        = "IllagelAccessException happends in setFloat in Field.";
    public final static String JAVA_FIELD_GET_LONG_ILLEGAL_ACCESS_EXCEPTION
        = "IllagelAccessException happends in getLong in Field.";
    public final static String JAVA_FIELD_SET_LONG_ILLEGAL_ACCESS_EXCEPTION
        = "IllagelAccessException happends in setLong in Field.";
    public final static String JAVA_FIELD_GET_INT_ILLEGAL_ACCESS_EXCEPTION
        = "IllagelAccessException happends in getInt in Field.";
    public final static String JAVA_FIELD_SET_INT_ILLEGAL_ACCESS_EXCEPTION
        = "IllagelAccessException happends in setInt in Field.";

    public final static String JAVA_FIELD_GET_EXCEPTION
        = "Exception happends in get in Field.";
    public final static String JAVA_FIELD_GET_BYTE_EXCEPTION
        = "Exception happends in getByte in Field.";
    public final static String JAVA_FIELD_GET_BOOLEAN_EXCEPTION
        = "Exception happends in getBoolean in Field.";
    public final static String JAVA_FIELD_GET_SHORT_EXCEPTION
        = "Exception happends in getShort in Field.";
    public final static String JAVA_FIELD_GET_CHAR_EXCEPTION
        = "Exception happends in getChar in Field.";
    public final static String JAVA_FIELD_GET_DOUBLE_EXCEPTION
        = "Exception happends in getDouble in Field.";
    public final static String JAVA_FIELD_GET_FLOAT_EXCEPTION
        = "Exception happends in getFloat in Field.";
    public final static String JAVA_FIELD_GET_LONG_EXCEPTION
        = "Exception happends in getLong in Field.";
    public final static String JAVA_FIELD_GET_INT_EXCEPTION
        = "Exception happends in getInt in Field.";


    public final static String JAVA_FIELD_SET_EXCEPTION
        = "Exception happends in set in Field.";
    public final static String JAVA_FIELD_SET_BYTE_EXCEPTION
        = "Exception happends in setByte in Field.";
    public final static String JAVA_FIELD_SET_BOOLEAN_EXCEPTION
        = "Exception happends in setBoolean in Field.";
    public final static String JAVA_FIELD_SET_SHORT_EXCEPTION
        = "Exception happends in setShort in Field.";
    public final static String JAVA_FIELD_SET_CHAR_EXCEPTION
        = "Exception happends in setChar in Field.";
    public final static String JAVA_FIELD_SET_DOUBLE_EXCEPTION
        = "Exception happends in setDouble in Field.";
    public final static String JAVA_FIELD_SET_FLOAT_EXCEPTION
        = "Exception happends in setFloat in Field.";
    public final static String JAVA_FIELD_SET_LONG_EXCEPTION
        = "Exception happends in setLong in Field.";
    public final static String JAVA_FIELD_SET_INT_EXCEPTION
        = "Exception happends in setInt in Field.";

    public final static String JAVA_CLASS_LOADER_DEFINE_CLASS_EXCEPTION
        = "Exception happends in defineClass in ClassLoader.";
    public final static String JAVA_METHOD_INVOKE_EXCEPTION
        = "Exception happends in invoke in Method.";
    public final static String JAVA_CLASS_GET_METHOD_EXCEPTION
        = "Exception happends in getMethod() in Class.";
    public final static String JAVA_CLASS_GET_METHODS_EXCEPTION
        = "Exception happends in getMethods() in Class.";
    public final static String JAVA_CLASS_NEW_INSTANCE_EXCEPTION
        = "Exception happends in newInstance in Class.";
    public final static String JAVA_CLASS_NEW_INSTANCE_INSTANTIATION_EXCEPTION
        = "InstantiationException happends in newInstance in Class.";
    public final static String JAVA_CLASS_NEW_INSTANCE_ILLEGAL_ACCESS_EXCEPTION
        = "IllegalAccessException happends in newInstance in Class.";
    public final static String JAVA_CLASS_FOR_NAME_CLASS_NOT_FOUND_EXCEPTION
        = "ClassNotFound Exception happends in forName in Class.";

    public final static String JAVA_DATA_INPUT_STREAM_READ_LINE_IO_EXCEPTION
        = "IO Exception happends in readLine() in DataInputStream.";
    public final static String JAVA_DATA_INPUT_STREAM_READ_FLOAT_IO_EXCEPTION
        = "IO Exception happends in readFloat() in DataInputStream.";
    public final static String JAVA_DATA_INPUT_STREAM_READ_BYTE_IO_EXCEPTION
        = "IO Exception happends in readByte() in DataInputStream.";
    public final static String JAVA_DATA_INPUT_STREAM_READ_INT_IO_EXCEPTION
        = "IO Exception happends in readInt() in DataInputStream.";
    public final static String JAVA_DATA_INPUT_STREAM_READ_SHORT_IO_EXCEPTION
        = "IO Exception happends in readShort() in DataInputStream.";
    public final static String JAVA_DATA_INPUT_STREAM_SKIP_BYTES_IO_EXCEPTION
        = "IO Exception happends in skipBytes() in DataInputStream.";
    public final static String JAVA_DATA_INPUT_STREAM_READ_IO_EXCEPTION
        = "IO Exception happends in read() in DataInputStream.";

    public final static String JAVA_DATA_OUTPUT_STREAM_IO_EXCEPTION
        = "IO Exception happends in <init> in DataOutputStream.";
    public final static String JAVA_DATA_OUTPUT_STREAM_WRITE_IO_EXCEPTION
        = "IO Exception happends in write() in DataOutputStream.";

    public final static String JAVA_FILE_OUTPUT_STREAM_FILE_NOT_FOUND_EXCEPTION
        = "FileNotFound Exception happends in FileOutputStream.";
    public final static String JAVA_FILE_OUTPUT_STREAM_WRITE_IO_EXCEPTION
        = "IO Exception happends in write in FileInputStream.";
    public final static String JAVA_FILE_OUTPUT_STREAM_IO_EXCEPTION
        = "IO Exception happends in <init> in FileInputStream.";
    public final static String JAVA_FILE_OUTPUT_STREAM_EXCEPTION
        = "Exception happends in <init> in FileInputStream.";
    public final static String JAVA_FILE_INPUT_STREAM_FILE_NOT_FOUND_EXCEPTION
        = "FileNotFound Exception happends in FileInputStream.";

    public final static String JAVA_FILE_INPUT_STREAM_READ_IO_EXCEPTION
        = "IO Exception happends in read in FileInputStream.";
    public final static String JAVA_FILE_INPUT_STREAM_IO_EXCEPTION
        = "IO Exception happends in <init> in FileInputStream.";

    public final static String JAVA_JAR_INPUT_STREAM_IO_EXCEPTION
        = "IO Exception happends in <init> in JarInputStream.";
    public final static String JAVA_JAR_INPUT_STREAM_READ_IO_EXCEPTION
        = "IO Exception happends in read in JarInputStream.";
    public final static String JAVA_JAR_INPUT_STREAM_GET_NEXT_ENTRY_IO_EXCEPTION
        = "IO Exception happends in getNextEntry in JarInputStream.";

    public final static String JAVA_OBJECT_INPUT_STREAM_READ_BOOLEAN_IO_EXCEPTION
        = "IO Exception happends in readBoolean() in ObjectInputStream.";
    public final static String JAVA_OBJECT_INPUT_STREAM_READ_SHORT_IO_EXCEPTION
        = "IO Exception happends in readShort() in ObjectInputStream.";
    public final static String JAVA_OBJECT_INPUT_STREAM_READ_BYTE_IO_EXCEPTION
        = "IO Exception happends in readByte() in ObjectInputStream.";
    public final static String JAVA_OBJECT_INPUT_STREAM_READ_CHAR_IO_EXCEPTION
        = "IO Exception happends in readChar() in ObjectInputStream.";
    public final static String JAVA_OBJECT_INPUT_STREAM_READ_DOUBLE_IO_EXCEPTION
        = "IO Exception happends in readDouble() in ObjectInputStream.";
    public final static String JAVA_OBJECT_INPUT_STREAM_READ_FLOAT_IO_EXCEPTION
        = "IO Exception happends in readFloat() in ObjectInputStream.";
    public final static String JAVA_OBJECT_INPUT_STREAM_READ_LONG_IO_EXCEPTION
        = "IO Exception happends in readLong() in ObjectInputStream.";
    public final static String JAVA_OBJECT_INPUT_STREAM_READ_INT_IO_EXCEPTION
        = "IO Exception happends in readInt() in ObjectInputStream.";
    public final static String JAVA_OBJECT_INPUT_STREAM_READ_OBJECT_IO_EXCEPTION
        = "IO Exception happends in readObject() in ObjectInputStream.";

    public final static String JAVA_OBJECT_OUTPUT_STREAM_CLOSE_IO_EXCEPTION
        = "IO Exception happends in close in ObjectOutputStream.";
    public final static String JAVA_OBJECT_OUTPUT_STREAM_WRITE_IO_EXCEPTION
        = "IO Exception happends in write in ObjectOutputStream.";

    public final static String JAVA_OBJECT_OUTPUT_STREAM_WRITE_OBJECT_IO_EXCEPTION
        = "IO Exception happends in writeObject in ObjectOutputStream.";
    public final static String JAVA_OBJECT_OUTPUT_STREAM_WRITE_INT_IO_EXCEPTION
        = "IO Exception happends in writeInt in ObjectOutputStream.";
    public final static String JAVA_OBJECT_OUTPUT_STREAM_WRITE_LONG_IO_EXCEPTION
        = "IO Exception happends in writeLong in ObjectOutputStream.";
    public final static String JAVA_OBJECT_OUTPUT_STREAM_WRITE_FLOAT_IO_EXCEPTION
        = "IO Exception happends in writeFloat in ObjectOutputStream.";
    public final static String JAVA_OBJECT_OUTPUT_STREAM_WRITE_DOUBLE_IO_EXCEPTION
        = "IO Exception happends in writeDouble in ObjectOutputStream.";
    public final static String JAVA_OBJECT_OUTPUT_STREAM_WRITE_BOOLEAN_IO_EXCEPTION
        = "IO Exception happends in writeBoolean in ObjectOutputStream.";
    public final static String JAVA_OBJECT_OUTPUT_STREAM_WRITE_SHORT_IO_EXCEPTION
        = "IO Exception happends in writeShort in ObjectOutputStream.";
    public final static String JAVA_OBJECT_OUTPUT_STREAM_WRITE_BYTE_IO_EXCEPTION
        = "IO Exception happends in writeByte in ObjectOutputStream.";
    public final static String JAVA_OBJECT_OUTPUT_STREAM_WRITE_CHAR_IO_EXCEPTION
        = "IO Exception happends in writeChar in ObjectOutputStream.";

    public final static String JAVA_OBJECT_OUTPUT_STREAM_IO_EXCEPTION
        = "IO Exception happends in <init> in ObjectOutputStream.";
    public final static String JAVA_OBJECT_INPUT_STREAM_IO_EXCEPTION
        = "IO Exception happends in <init> in ObjectInputStream.";

    public final static String JAVA_INPUT_STREAM_READ_IO_EXCEPTION
        = "IO Exception happends in read in InputStream.";

    public final static String JAVA_INTEGER_VALUE_OF_NUMBER_FORMAT_EXCEPTION
        = "Number Format Exception happends in valueOf in Integer.";

    public final static String JAVA_SOCKET_CLOSE_IO_EXCEPTION
        = "IO Exception happends in close in Socket.";
    public final static String JAVA_SOCKET_SHUTDOWN_INPUT_IO_EXCEPTION
        = "IO Exception happends in shutdownInput in Socket.";
    public final static String JAVA_SOCKET_SHUTDOWN_OUTPUT_IO_EXCEPTION
        = "IO Exception happends in shutdownOutput in Socket.";
    public final static String JAVA_SOCKET_GET_INPUT_STREAM_IO_EXCEPTION
        = "IO Exception happends in getInputStream in Socket.";
    public final static String JAVA_SOCKET_GET_OUTPUT_STREAM_IO_EXCEPTION
        = "IO Exception happends in getOutputStream in Socket.";
    public final static String JAVA_SOCKET_CONNECT_IO_EXCEPTION
        = "IO Exception happends in connect in Socket.";
    public final static String JAVA_SOCKET_ACCEPT_IO_EXCEPTION
        = "IO Exception happends in accept in Socket.";

    public final static String JAVA_SERVER_SOCKET_IO_EXCEPTION
        = "IO Exception happends in <init> in ServerSocket.";

    public final static String JAVA_URL_EXCEPTION
        = "Exception happends in <init> in URL.";
    public final static String JAVA_URI_EXCEPTION
        = "Exception happends in <init> in URI.";

    public final static String JAVA_RUNTIME_EXEC_IO_EXCEPTION
        = "IO Exception happends in exec in Runtime.";

    public final static String PROPERTY_LOADER_IO_EXCEPTION
        = "IO Exception happends in <init> In PropertyLoader.";


    public final static String NAMED_LINE_NUMBER_INPUT_STREAM_EXCEPTION
        = "Exception happends in <init> in NamedPushbackInputStream.";
    public final static String NAMED_PUSHBACK_INPUT_STREAM_EXCEPTION
        = "Exception happends in <init> in NamedPushbackInputStream.";
    public final static String NAMED_SEQUENCE_INPUT_STREAM_EXCEPTION
        = "Exception happends in <init> in NamedSequenceInputStream.";
    public final static String NAMED_PRINT_STREAM_EXCEPTION
        = "Exception happends in <init> in NamedPrintStream.";
    public final static String NAMED_OBJECT_INPUT_STREAM_EXCEPTION
        = "Exception happends in <init> in NamedObjectInputStream.";
    public final static String NAMED_OBJECT_OUTPUT_STREAM_EXCEPTION
        = "Exception happends in <init> in NamedObjectOutputStream.";
    public final static String NAMED_DATA_INPUT_STREAM_EXCEPTION
        = "Exception happends in <init> in NamedDataInputStream.";
    public final static String NAMED_DATA_OUTPUT_STREAM_EXCEPTION
        = "Exception happends in <init> in NamedDataOutputStream.";
    public final static String NAMED_FILTER_INPUT_STREAM_EXCEPTION
        = "Exception happends in <init> in NamedFilterInputStream.";
    public final static String NAMED_FILTER_OUTPUT_STREAM_EXCEPTION
        = "Exception happends in <init> in NamedFilterOutputStream.";
    public final static String NAMED_BUFFERED_INPUT_STREAM_EXCEPTION
        = "Exception happends in <init> in NamedBufferedInputStream.";
    public final static String NAMED_BUFFERED_OUTPUT_STREAM_EXCEPTION
        = "Exception happends in <init> in NamedBufferedOutputStream.";
    public final static String NAMED_FILE_INPUT_STREAM_EXCEPTION
        = "Exception happends in <init> in NamedFileInputStream.";
    public final static String NAMED_FILE_OUTPUT_STREAM_EXCEPTION
        = "Exception happends in <init> in NamedFileOutputStream.";
    public final static String NAMED_PIPED_OUTPUT_STREAM_EXCEPTION
        = "Exception happends in <init> in NamedPipedOutputStream.";
    public final static String NAMED_PIPED_INPUT_STREAM_EXCEPTION
        = "Exception happends in <init> in NamedPipedInputStream.";

    public final static String PARAMETER_ERROR_DATACLASS
        = "Parameter error in DataClass().";
    public final static String IO_ERROR_DATACLASS
        = "I/O error in DataClass().";
}
