/**
 * Copyright (C) All rights reserved.
 *
 * @Module     ObjectTable.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2012/03/09
 *
 */

package oserv;

import java.lang.*;
import java.io.*;
import java.net.*;
import java.util.*;

public class ObjectTable extends StringsTable {

    public static String SEARCH_OBJECT_TABLE = "SearchTable";
    public static String ADD_OBJECT_TABLE = "AddTable";
    public static String DELETE_OBJECT_TABLE = "DeleteTable";
    public static String READ_OBJECT_TABLE = "ReadTable";
    public static String SET_SERVICE_TYPE = "ServiceType";

    public ObjectTable clone() {
        ObjectTable clone_table;
        String      entry;
        String      type;

        clone_table = new ObjectTable();
        for (int i = 0; i < getCount(); i++) {
            try {
                entry = get(i);
                type  = getType(i);
                clone_table.add(entry, type);
            } catch (Exception exception_object) {
            }
        }
        return clone_table;
    }

    public ObjectTable add(String entry, String type)  throws Exception {
        super.add(entry, type);
        return this;
    }

    public ObjectTable delete(String entry)  throws Exception {
        super.delete(entry);
        return this;
    }

}
