/**
 * Copyright (C) All rights reserved.
 *
 * @Module     ParseOptions.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2011/10/03
 */

package oserv;

import java.lang.*;
import java.io.*;
import java.util.*;

public class ParseOptionsTest extends Object {
    private static String ARGUMENT_ERROR = "Parameter error.";
    private static String CHECK_KEY = "-check";
    private static String HELP_KEY  = "-help";

    private static String TEST1 = "Test1";
    public final static String ARGS1 = "lL|d:";
    public final static String ARGS2 = "lL|d:";
    public final static String ARGS3 = "lLd:";
    public final static String ARGS4 = "lL|d:";
    private static String TEST1_MESSAGE1 = "Test1 message 1";
    private static String TEST1_MESSAGE2 = "Test1 message 2";
    private static String TEST1_MESSAGE3 = "Test1 message 3";
    private static String TEST1_MESSAGE4 = "Test1 message 4";
    private static String TEST1_MESSAGE5 = "Test1 message 5";

    public static String ILLEGAL_OPTION_EXCEPTION = "Illegal option exception";

    public void test1() {
        ParseOptions  parse_options;
        String[]       long_flag = { HELP_KEY };
        String[]       long_key = { CHECK_KEY };
        String[]       args1 = { "-l", "-L" };
        String[]       args2 = { "-d", "file" };
        String[]       args3 = { "-l", "-d", "file" };
        String[]       args4 = { "-l", "-d", "file" };
        String[]       args5 = { "test", "file" };

        System.out.println(TEST1_MESSAGE1);
        try {
            parse_options = new ParseOptions(args1, ARGS1, long_flag, long_key);
        } catch (Exception exception_object) {
            System.err.println(ILLEGAL_OPTION_EXCEPTION);
            return;
        }
        System.out.println(TEST1_MESSAGE2);
        try {
            parse_options = new ParseOptions(args2, ARGS2, long_flag, long_key);
        } catch (Exception exception_object) {
            System.err.println(ILLEGAL_OPTION_EXCEPTION);
            return;
        }
        System.out.println(TEST1_MESSAGE3);
        try {
            parse_options = new ParseOptions(args3, ARGS3, long_flag, long_key);
        } catch (Exception exception_object) {
            System.err.println(ILLEGAL_OPTION_EXCEPTION);
            return;
        }
        System.out.println(TEST1_MESSAGE4);
        try {
            parse_options = new ParseOptions(args4, ARGS4, long_flag, long_key);
        } catch (Exception exception_object) {
            System.err.println(ILLEGAL_OPTION_EXCEPTION);
            return;
        }
        System.out.println(TEST1_MESSAGE5);
        try {
            parse_options = new ParseOptions(args5, null, null, null);
        } catch (Exception exception_object) {
exception_object.printStackTrace();
            System.err.println(ILLEGAL_OPTION_EXCEPTION);
            return;
        }
    }

    public static void main(String[] args) {
        ParseOptionsTest   parse_options_test;

        if (args.length != 1) {
            System.err.println(ARGUMENT_ERROR);
            return;
        }

        parse_options_test = new ParseOptionsTest();
        if (args[0].compareTo(TEST1) == 0) {
            parse_options_test.test1();
            return;
        }
    }
}
