/**
 * Copyright (C) All rights reserved.
 *
 * @Module     PrintMessage.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2012/07/13
 *
 */

package oserv;

import java.lang.*;
import java.io.*;

public class PrintMessage extends Object implements Serializable {
    private int                    debug;
    private LogPrintStream         logStream = null;

    private static MessageResource message_resource = new MessageResource();

    public void setMessageResource(MessageResource msgrs) {
        if (msgrs != null) {
            message_resource = msgrs;
        }
    }

    public MessageResource getMessageResource() {
        if (message_resource == null) {
            message_resource = new MessageResource();
        }
        return message_resource;
    }

    public void setDebugLogStream(int debug_level, LogPrintStream log_print_stream) {
        if (debug_level != 0) {
            debug = debug_level;
        }
        if (log_print_stream != null) {
            logStream = log_print_stream;
        }
        if (debug > ObjectServerHeader.OSERV_DEBUG_FULL_VALUE
            && logStream != null) {
            logStream.printLogln(
                getMessageResource().getFormattedMessage(
                    ObjectServerDebug.DEBUG_DEBUG_VALUE,
                    getMessageResource().getMessage(
                        ObjectServerDebug.DEBUG_DEBUG_VALUE),
                    ObjectServerDebug.DEBUG_BLANK_STRING_KEY,
                    String.valueOf(debug)));
        }
    }

    protected void setDebug(int level) {
        debug = level;
    }

    protected int getDebug() {
        return debug;
    }

    public void printMessage( 
        String format_key, String message_key, String... msg ) {
        printMessage(logStream, getMessageResource(), 
            format_key,  message_key, msg);
    }

    public static void printMessage(
        LogPrintStream log_print_stream,
        MessageResource parameter_message,
        String format_key, String message_key,
        String... msg) {

        if (log_print_stream != null && parameter_message != null) {
            log_print_stream.printLogln(
                parameter_message.getFormattedMessage(
                    format_key,
                    parameter_message.getMessage(
                        message_key)),
                    msg);
        }
    }
}
