/**
 * Copyright (C) All rights reserved.
 *
 * @Module     PropertyLoader.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2012/03/29
 *
 */

package oserv;

import java.lang.*;
import java.io.*;
import java.net.*;

public class PropertyLoader extends UTFInputStream {
    private static String KEY   = "Key";
    private static String VALUE = "Value";
    private static String SPACE = " ";
    private static String MESSAGE_LIST_SEPARATOR = "=";
    private static char COMMENT_LINE = '#';
    private static String COMMENT_LINE_STRING = "#";

    private static String  pName = null;
    private static String  vName = null;

    public PropertyLoader(InputStream is) throws Exception {
        super(is);
    }

    public String getKey() {
        int    index;
        String utf_line;

        pName = null; 
        while (true) {
            try {
                utf_line = getLine();
            } catch (Exception exception_object) {
                break;
            }
            if (utf_line.charAt(0) == COMMENT_LINE) {
                continue;
            }
            index = utf_line.indexOf(MESSAGE_LIST_SEPARATOR);
            if (index < 0) {
                continue;
            }
            pName = utf_line.substring(0, index).trim();
            vName = utf_line.substring(index+1).trim();
            index = pName.indexOf(SPACE);
            if (index >= 0) {
                pName = pName.substring(0, index);
            }
            index = vName.indexOf(SPACE);
            if (index >= 0) {
                vName = vName.substring(0, index);
            }
            index = vName.indexOf(COMMENT_LINE_STRING);
            if (index >= 0) {
                vName = vName.substring(0, index);
            }
            break;
        }
        return pName; 
    }

    public String getValue() {
        return vName;
    }

    public static void main(String[] args) {
        String             key;
        String             value;
        FileInputStream    file_input_stream;
        PropertyLoader     property_loader;

        if (args.length == 1) {
            try {
                file_input_stream = new FileInputStream(args[0]);
                property_loader = new PropertyLoader(file_input_stream);
            } catch (Exception exception_object) {
                exception_object.printStackTrace();
                return;
            }
            while (true) {
                try {
                    key = property_loader.getKey();
                    if (key == null) { break; }
                    value = property_loader.getValue();
                } catch (Exception exception_object) {
                    break;
                }
                System.out.println(KEY + SPACE + key + SPACE + 
                    VALUE + SPACE + value);
            }
        }
    }
}
