/**
 * Copyright (C) All rights reserved.
 *
 * @Module     RequestServer.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2012/03/08
 *
 */

package oserv;

import java.lang.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.util.zip.*;
import java.util.jar.*;

public class RequestServer extends ForwardServer {

    private String myType = SERVICE_THREAD_TYPE;
    private static String REQUEST_SERVER_CLASS_NAME = "oserv.RequestServer";

    public void setMyType(String type) {
        if (type != null) {
            myType = type;
        }
    }

    public static String getClassName() {
        return REQUEST_SERVER_CLASS_NAME;
    }

    protected String getMyType() {
        Thread  thread_object;

        thread_object = Thread.currentThread();
        if (thread_object instanceof RequestServer) {
            return ObjectServerHeader.SERVICE_THREAD_TYPE;
        }
        return super.getMyType();
    }

    public RequestServer() {
        super();
    }

    public RequestServer(Thread runnable, String type) {
        super(runnable, type);
    }
}
