/**
 * Copyright (C) All rights reserved.
 *
 * @Module     SecurityManagerTest.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2011/08/01
 *
 */

package oserv;

import java.lang.*;
import java.io.*;
import java.net.*;
import java.security.*;

public class SecurityManagerTest extends Object {
    public static String CURRENT_DIRECTORY = ".";
    public static char CURRENT_DIRECTORY_CHAR = '.';
    public static String EMPTY_PATH = "";
    public static String SPACE_STRING = " ";

    public static String CHECK_READ_WITH_FILE_DESCRITOR 
        = "checkReadWithFileDescriptor";
    public static String CHECK_READ = "checkRead";

    public static String SAMPLE_PATH_TITLE = "Sample Path ";
    public static String SAMPLE_PATH_1 = "workdir";
    public static String SAMPLE_PATH_2 = "./././workdir";
    public static String SAMPLE_PATH_3 = "../workdir";
    public static String SAMPLE_PATH_4 = "TEST/../workdir";
    public static String SAMPLE_PATH_5 = "TEST/../TEST/workdir";
    public static String SAMPLE_PATH_6 = "TEST/../../TEST/workdir";
    public static String SAMPLE_PATH_7 = "/TEST/../TEST/workdir";
    public static String SAMPLE_PATH_8 = "/TEST/../../TEST/workdir";

    public static String SAMPLE_PATH_1_TITLE 
        = SAMPLE_PATH_TITLE + SAMPLE_PATH_1;
    public static String SAMPLE_PATH_2_TITLE 
        = SAMPLE_PATH_TITLE + SAMPLE_PATH_2;
    public static String SAMPLE_PATH_3_TITLE 
        = SAMPLE_PATH_TITLE + SAMPLE_PATH_3;
    public static String SAMPLE_PATH_4_TITLE 
        = SAMPLE_PATH_TITLE + SAMPLE_PATH_4;
    public static String SAMPLE_PATH_5_TITLE 
        = SAMPLE_PATH_TITLE + SAMPLE_PATH_5;
    public static String SAMPLE_PATH_6_TITLE 
        = SAMPLE_PATH_TITLE + SAMPLE_PATH_6;
    public static String SAMPLE_PATH_7_TITLE 
        = SAMPLE_PATH_TITLE + SAMPLE_PATH_7;
    public static String SAMPLE_PATH_8_TITLE 
        = SAMPLE_PATH_TITLE + SAMPLE_PATH_8;

    public static String MAKECANONICAL = "makeCanonical";

    public static String EXCEPTION_END = "Exception end";
    public static String BAD_ARGUMENT = "Bad argument ";

    public static void main(String[] ag) {
        File fes;
        String path;

        fes = new File(EMPTY_PATH);
        path = fes.getAbsolutePath();

        ObjectServerSecurityManager ossm;
        ossm = new ObjectServerSecurityManager(path);

        if (ag.length < 1) {
            System.out.println(BAD_ARGUMENT + String.valueOf(ag.length));
            System.exit(-1);
        }

        if (ag[0].compareTo(MAKECANONICAL) == 0) {
            if (ag.length < 2) {
                try {
                    String canonical;
                    canonical = ossm.makeCanonical(SAMPLE_PATH_1);
                    System.out.println(SAMPLE_PATH_1_TITLE 
                        + SPACE_STRING + canonical);
                } catch (SecurityException security_exception) {
                    security_exception.printStackTrace();
                    System.out.println(EXCEPTION_END);
                }
                try {
                    String canonical;
                    canonical = ossm.makeCanonical(SAMPLE_PATH_2);
                    System.out.println(SAMPLE_PATH_2_TITLE 
                        + SPACE_STRING + canonical);
                } catch (SecurityException security_exception) {
                    security_exception.printStackTrace();
                    System.out.println(EXCEPTION_END);
                }
                try {
                    String canonical;
                    canonical = ossm.makeCanonical(SAMPLE_PATH_3);
                    System.out.println(SAMPLE_PATH_3_TITLE 
                        + SPACE_STRING + canonical);
                } catch (SecurityException security_exception) {
                    security_exception.printStackTrace();
                    System.out.println(EXCEPTION_END);
                }
                try {
                    String canonical;
                    canonical = ossm.makeCanonical(SAMPLE_PATH_4);
                    System.out.println(SAMPLE_PATH_4_TITLE 
                        + SPACE_STRING + canonical);
                } catch (SecurityException security_exception) {
                    security_exception.printStackTrace();
                    System.out.println(EXCEPTION_END);
                }
                try {
                    String canonical;
                    canonical = ossm.makeCanonical(SAMPLE_PATH_5);
                    System.out.println(SAMPLE_PATH_5_TITLE 
                        + SPACE_STRING + canonical);
                } catch (SecurityException security_exception) {
                    security_exception.printStackTrace();
                    System.out.println(EXCEPTION_END);
                }
                try {
                    String canonical;
                    canonical = ossm.makeCanonical(SAMPLE_PATH_6);
                    System.out.println(SAMPLE_PATH_6_TITLE 
                        + SPACE_STRING + canonical);
                } catch (SecurityException security_exception) {
                    security_exception.printStackTrace();
                    System.out.println(EXCEPTION_END);
                }
                try {
                    String canonical;
                    canonical = ossm.makeCanonical(SAMPLE_PATH_7);
                    System.out.println(SAMPLE_PATH_7_TITLE 
                        + SPACE_STRING + canonical);
                } catch (SecurityException security_exception) {
                    security_exception.printStackTrace();
                    System.out.println(EXCEPTION_END);
                }
                try {
                    String canonical;
                    canonical = ossm.makeCanonical(SAMPLE_PATH_8);
                    System.out.println(SAMPLE_PATH_8_TITLE 
                        + SPACE_STRING + canonical);
                } catch (SecurityException security_exception) {
                    security_exception.printStackTrace();
                    System.out.println(EXCEPTION_END);
                }
                return;
            }
            return;
        }
        if (ag[0].compareTo(CHECK_READ) == 0) {
            if (ag.length < 2) {
                try {
                    System.out.println(SAMPLE_PATH_1_TITLE);
                    ossm.checkRead(SAMPLE_PATH_1);
                    System.out.println(SAMPLE_PATH_2_TITLE);
                    ossm.checkRead(SAMPLE_PATH_2);
                    System.out.println(SAMPLE_PATH_3_TITLE);
                    ossm.checkRead(SAMPLE_PATH_3);
                } catch (SecurityException security_exception) {
                    security_exception.printStackTrace();
                    return;
                }
                return;
            }
            try {
                ossm.checkRead(ag[1]);
            } catch (SecurityException security_exception) {
                security_exception.printStackTrace();
                return;
            }
            return;
        }
    }
}


