/**
 * Copyright (C) All rights reserved.
 *
 * @Module     StringObject.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2011/11/25
 *
 */

package oserv;

import java.lang.*;
import java.io.*;
import java.util.*;

public class StringObject extends Object {
    private ArrayList keys = new ArrayList();
    private ArrayList messages = new ArrayList();

    private final static String PARAMETER_ERROR = "Parameter";
    private final static String NOT_FOUND_ERROR = "Not found";

    public void add (String key, String message)  {
        if (key == null || message == null) {
            return;
        }
        keys.add((Object)key);
        messages.add((Object)message);
    }

    public String getMessage(String key) throws Exception {
        String key_string;
        String message_string;
        ObjectServerException object_server_exception;

        if (key == null) {
            object_server_exception = new ObjectServerException(
                    ObjectServerError.PARAMETER_ERROR_STRINGOBJECT
            );
            throw object_server_exception;
        }

        for (int i = 0; i < keys.size(); i++) {
            key_string = (String)keys.get(i);
            if (key_string.compareTo(key) == 0) {
                message_string = (String)messages.get(i);
                return message_string;
            }
        }
        object_server_exception = new ObjectServerException(
                ObjectServerError.ENTRY_NOT_FOUND_STRINGOBJECT
        );
        throw object_server_exception;
    }

    public int size() {
        return keys.size();
    }
}
