/**
 * Copyright (C) All rights reserved.
 *
 * @Module     MonitorServer.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2012/03/08
 *
 */

package oserv;

import java.lang.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.util.zip.*;
import java.util.jar.*;


public class TransientMonitor extends MonitorServer {

    private String myType = MONITOR_THREAD_TYPE;
    private static String TRANSIENT_MONITOR_CLASS_NAME = "oserv.TransientMonitor";

    public void setMyType(String type) {
        if (type != null) {
            myType = type;
        }
    }

    public static String getClassName() {
        return TRANSIENT_MONITOR_CLASS_NAME;
    }

    protected String getMyType() {
        Thread  thread_object;

        thread_object = Thread.currentThread();
        if (thread_object instanceof MonitorServer) {
            return ObjectServerHeader.MONITOR_THREAD_TYPE;
        }
        return ObjectServerHeader.UNKNOWN_THREAD_TYPE;
    }

    public TransientMonitor() {
        super();
    }

    public TransientMonitor(Thread runnable, String type) {
        super(runnable, type);
    }
}
