/**
 * Copyright (C) All rights reserved.
 *
 * @Module     TransientServer.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2012/03/08
 *
 */

package oserv;

import java.lang.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.util.zip.*;
import java.util.jar.*;


public class TransientServer extends RequestServer {

    private String myType = TRANSIENT_THREAD_TYPE;
    private static String TRANSIENT_SERVER_CLASS_NAME = "oserv.TransientServer";

    public void setMyType(String type) {
        if (type != null) {
            myType = type;
        }
    }

    public static String getClassName() {
        return TRANSIENT_SERVER_CLASS_NAME;
    }

    protected String getMyType() {
        Thread  thread_object;

        thread_object = Thread.currentThread();
        if (thread_object instanceof TransientServer) {
            return ObjectServerHeader.TRANSIENT_THREAD_TYPE;
        }
        return super.getMyType();
    }

    public TransientServer() {
        super();
    }

    public TransientServer(Thread runnable, String type) {
        super(runnable, type);
    }
}
