/**
 * Copyright (C) All rights reserved.
 *
 * @Module     VariableByte.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2011/10/21
 *
 */

package oserv;

import java.lang.*;
import java.io.*;

/*
public class VariableByte extends java.lang.Object  implements Serializable {
*/
public class VariableByte extends SerializableObject  {

    private static String PARAMETER_ERROR = "Parameter size is incorrect.";
    private byte[]  variable;

    public VariableByte(long size) throws VariableByteException {
        if (size <= 0) {
            VariableByteException variable_byte_exception;

            variable_byte_exception = new VariableByteException(
                PARAMETER_ERROR);
            throw variable_byte_exception;
        }
        variable = new byte[(int)size];
    }

    public VariableByte(byte[] init) throws VariableByteException {
        construction(init, init.length);
    }

    public VariableByte(byte[] init, int size) throws VariableByteException {
        construction(init, size);
    }

    public static VariableByte valueOf(byte[] init, int size,
        MessageResource parameter_message_resource) throws VariableByteException {
        VariableByte   variable_byte;
        VariableByteException   variable_byte_exception;

        try {
            variable_byte = new VariableByte(init, size);
            if (parameter_message_resource != null) {
                variable_byte.setMessageResource(parameter_message_resource);
            }
        } catch (Exception exception_object) {
            if (parameter_message_resource == null) {
                variable_byte_exception = new VariableByteException (
                    ObjectServerError.PARAMETER_ERROR_VARIABLE_BYTE);
                throw variable_byte_exception;
            }
            variable_byte_exception = new VariableByteException (
                parameter_message_resource.getFormattedMessage(
                    ObjectServerError.PARAMETER_ERROR_VARIABLE_BYTE,
                    parameter_message_resource.getMessage( 
                        ObjectServerError.PARAMETER_ERROR_VARIABLE_BYTE)));

            throw variable_byte_exception;
        }
        return variable_byte;
    }

    public void construction(byte[] init, int size) 
                throws VariableByteException {
        if (size <= 0) {
            VariableByteException variable_byte_exception;

            variable_byte_exception = new VariableByteException(
                PARAMETER_ERROR);
            throw variable_byte_exception;
        }
        variable = new byte[size];
        for (int i = 0; i < size; i++) {
            variable[i] = init[i];
        }
    }

    public byte[] getBytes() {
        return variable;
    }

    public int getSize() {
       int  size;
       size = variable.length;
       return size;
    }
}
