/**
 * Copyright (C) All rights reserved.
 *
 * @Module     CallMethodDebug1Test.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2013/06/19
 */

package oserv.test;

import java.lang.*;
import java.lang.reflect.*;
import java.io.*;

import oserv.*;

public class CallMethodDebug1Test extends ObjectCommand {

    private static String PARAMETER_ERROR = "Parameter error";

    private final static String OSERV_CALL_METHOD_DEBUG1
        = "oserv.test.CallMethodDebug1";

    private static String CHECK_SET_METHOD ="check_setMethod";
    private static Class[]  check_set_method_args_class = { 
        Method.class };
    private static Object[] check_set_method_args_object = new Object[1];
    private static Method  check_set_method_method = null;


    private static String CALL_METHOD_SAMPLE_CLASS = "oserv.test.CallMethodSample";
    private static Class  call_method_sample_class = null;
    private static String INT_METHOD = "intMethod";
    private static Class[] int_method_args_class = { int.class };
    private static Method  call_method_sample_int_method;

    private static String INTEGER_MESSAGE = "Integer ";

    public void execTestCase(UserClassLoader user_class_loader) {
        byte[]   oserv_body;
        String   class_name;

        Class   call_method_manager_class;
        Object  object_instance;

        class_name = OSERV_CALL_METHOD_DEBUG1;
        oserv_body = CallMethodDebug1Data.getClassData();

        try {
            call_method_manager_class = 
                user_class_loader.getSpecifiedClass(
                    class_name, oserv_body);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
        System.out.println(call_method_manager_class.getName());
        try {
            object_instance = call_method_manager_class.newInstance();
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }

        class_name = CALL_METHOD_SAMPLE_CLASS;
        oserv_body = CallMethodSampleData.getClassData();
        try {
            call_method_sample_class = 
                user_class_loader.getSpecifiedClass(
                    class_name, oserv_body);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }

        try {
            call_method_sample_int_method = 
                call_method_sample_class.getDeclaredMethod(
                INT_METHOD,
                int_method_args_class );
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
        try {
            check_set_method_method =
                call_method_manager_class.getDeclaredMethod(
                CHECK_SET_METHOD,
                check_set_method_args_class );
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
        check_set_method_args_object[0] =
            (Object)call_method_sample_int_method;
        try {
            check_set_method_method.invoke(
                object_instance,
                check_set_method_args_object);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }
 
    public static void main(String[] args) {
        UserClassLoader  user_class_loader;

        user_class_loader = new UserClassLoader();
        CallMethodDebug1Test  call_method_debug1_test;
        call_method_debug1_test = new CallMethodDebug1Test();

        if (args == null || args.length < 0) {
            System.out.println(PARAMETER_ERROR);
            return;
        }
        call_method_debug1_test.execTestCase(user_class_loader);
    }
}
