/**
 * Copyright (C) All rights reserved.
 *
 * @Module     CallMethodDebug4.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2013/06/19
 *
 */

package oserv.test;

import java.lang.*;
import java.io.*;
import java.util.*;
import java.lang.reflect.*;

import oserv.*;

public class CallMethodDebug4 extends CallMethod {
    private static String SPACE = " ";

    private static String CALL_METHOD_NULL_BEFORE
        = "Before Call Method is NULL.";
    private static String CALL_METHOD_NOT_NULL_BEFORE 
        = "Before Call Method is ";
    private static String CALL_METHOD_NULL_AFTER
        = "After Call Method is NULL.";
    private static String CALL_METHOD_NOT_NULL_AFTER 
        = "After Call Method is ";

    public void check_setMethod(Method method_object) {

        try {
            super.setMethod(method_object);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }

    public void check_invoke(Object object_instance, Method target_method,
        Object[] args_object) throws Exception {
        Object return_object;
        Class[] args_type;
        Class   return_type;

        Integer   integer_index;

        args_type = target_method.getParameterTypes();
        return_type = target_method.getReturnType();

        for (int i = 0; i < args_type.length; i++) {
            integer_index = Integer.valueOf(i);
            if (args_type[i].getName().compareTo(int.class.getName()) == 0) {
                try {
                    super.setInt(
                        object_instance, (Integer)args_object[i], integer_index);
                } catch (Exception exception_object) {
                    exception_object.printStackTrace();
                    throw exception_object;
                }
                continue;
            }
            if (args_type[i].getName().compareTo(long.class.getName()) == 0) {
                try {
                    super.setLong(
                        object_instance, (Long)args_object[i], integer_index);
                } catch (Exception exception_object) {
                    exception_object.printStackTrace();
                    throw exception_object;
                }
                continue;
            }
        }

        try {
            super.invoke(object_instance);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }

    }

    public Object check_getValue(Object object_instance,
        Method   target_method) throws Exception {
        Integer  return_integer;
        Object   return_object;
        Class    return_type;

        return_type = target_method.getReturnType();

        if (return_type.getName().compareTo(int.class.getName()) == 0) {
            try {
                return_integer = super.getInt(object_instance);
            } catch (Exception exception_object) {
                exception_object.printStackTrace();
                throw exception_object;
            }
            return (Object)return_integer;
        }
        try {
            return_object = super.get(object_instance);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }
        return return_object;
    }
}
