/**
 * Copyright (C) All rights reserved.
 *
 * @Module     CallMethodTest1.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2013/06/19
 */

package oserv.test;

import java.lang.*;
import java.lang.reflect.*;
import java.io.*;

import oserv.*;

public class CallMethodTest1 extends ObjectCommand {
    /** CallMethod Instance **/
    private Object object_instance = null;

    private static String PARAMETER_ERROR = "Parameter error";

    private final static String OSERV_CALL_METHOD
        = "oserv.CallMethod";

    private String  SET_METHOD_METHOD_NAME ="setMethod";
    private Class[] set_method_args_class = { Method.class };
    private Object[] set_method_args_object = new Object[1];
    private Method  set_method_method = null;

    private String  SET_INT_PARAMETER_METHOD_NAME ="setintParameter";
    private Class[] set_int_parameter_args_class = { 
        Object.class,
        Integer.class,
        Integer.class };
    private Method  set_int_parameter_method = null;

    private String  SET_LONG_PARAMETER_METHOD ="setlongParameter";
    private Class[] set_long_parameter_args_class = { 
        Object.class,
        Long.class,
        Integer.class };
    private Method  set_long_parameter_method = null;

    private String  INVOKE_METHOD_NAME ="invoke";
    private Class[] invoke_args_class = { Object.class };
    private Object[]invoke_args_object = new Object[1];
    private Method  invoke_method = null;

    private static String CALL_INVOKE_METHOD = "Call Invoke";

    private  String  GET_INT_VALUE_METHOD_NAME ="getintValue";
    private  Class[]  get_int_value_args_class = { Object.class };
    private  Object[] get_int_value_args_object = new Object[1];
    private  Method  get_int_value_method = null;

    private static String INTEGER_MESSAGE = "Integer ";

    private static String OSERV_CALL_METHOD_SAMPLE 
        = "oserv.test.CallMethodSample";
/*
    public int intMethod(int int_parameter) {
*/
    private String   SAMPLE_INT_METHOD_METHOD_NAME = "intMethod";
    private Class[]  sample_int_method_args_class = { int.class };
    private Object[] sample_int_method_args_object = new Object[1];
    private Method   sample_int_method_method = null;

    public void execTestCase() throws Exception {
        String           class_name;
        byte[]           oserv_body;
        Object           return_object;
        Object           sample_instance;
        UserClassLoader  user_class_loader;

        Class object_output_manager_class;
        Class object_input_manager_class;
        Class call_method_invoke_class;
        Class call_method_transfer_class;
        Class call_method_class;
        Class call_method_sample_class;

        user_class_loader = new UserClassLoader();

        try {
            object_output_manager_class = 
                    user_class_loader.getSpecifiedClass(
                        OSERV_OBJECT_OUTPUT_MANAGER,
                        ObjectOutputManagerData.getClassData());

            object_input_manager_class = 
                    user_class_loader.getSpecifiedClass(
                        OSERV_OBJECT_INPUT_MANAGER,
                        ObjectInputManagerData.getClassData());

            call_method_invoke_class = 
                    user_class_loader.getSpecifiedClass(
                        OSERV_CALL_METHOD_INVOKE,
                        CallMethodInvokeData.getClassData());
            call_method_transfer_class = 
                    user_class_loader.getSpecifiedClass(
                        OSERV_CALL_METHOD_TRANSFER,
                        CallMethodTransferData.getClassData());
            call_method_class = 
                    user_class_loader.getSpecifiedClass(
                        OSERV_CALL_METHOD,
                        CallMethodData.getClassData());
            call_method_sample_class = 
                    user_class_loader.getSpecifiedClass(
                        OSERV_CALL_METHOD_SAMPLE,
                        CallMethodSampleData.getClassData());
        } catch (Exception exception_object) {
            throw exception_object;
        }

        try {
            set_method_method = call_method_class.getMethod(
                    SET_METHOD_METHOD_NAME, set_method_args_class);
        } catch (Exception exception_object) {
            throw exception_object;
        }
        try {
            invoke_method = call_method_class.getMethod(
                    INVOKE_METHOD_NAME, invoke_args_class);
        } catch (Exception exception_object) {
            throw exception_object;
        }
        try {
            get_int_value_method = call_method_class.getMethod(
                    GET_INT_VALUE_METHOD_NAME, get_int_value_args_class);
        } catch (Exception exception_object) {
            throw exception_object;
        }
        try {
            object_instance = call_method_class.newInstance();
        } catch (Exception exception_object) {
            throw exception_object;
        }

        try {
            sample_int_method_method = call_method_class.getMethod(
                SAMPLE_INT_METHOD_METHOD_NAME, sample_int_method_args_class);
        } catch (Exception exception_object) {
            throw exception_object;
        }
        try {
            set_method_method.invoke(object_instance, set_method_args_object);
        } catch (Exception exception_object) {
            throw exception_object;
        }


    }


    public static void main(String[] args) {
        CallMethodTest1   call_method_test1;

        if (args == null || args.length < 0) {
            System.out.println(PARAMETER_ERROR);
            return;
        }
        call_method_test1 = new CallMethodTest1();
        try {
            call_method_test1.execTestCase();
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }
}
