/**
 * Copyright (C) All rights reserved.
 *
 * @Module     CheckData.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2013/07/16
 *
 */

package oserv.test;

import java.lang.*;
import java.lang.reflect.*;
import java.io.*;
import java.net.*;

import oserv.*;

public class CheckData extends UserClassLoader {
    private static String SPACE = " ";
    private static String COMMA = ",";
    private static String START_BRACE = "(";
    private static String END_BRACE = ")";
    private static String TITLE = "Class";

    private static String GET_CLASS_DATA = "getClassData";
    private static Class[]  get_class_data_args_class = new Class[0];
    private static Object[]  get_class_data_args_object = new Object[0];

    private static String DATA_SUFFIX = "Data";

    public byte[] getGetData(String class_name) throws Exception {
        Class   cls;
        byte[]  byte_array;
        Method  target_method;
        Object  object_instance;

        try {
            cls = Class.forName(class_name);
            object_instance = cls.newInstance();
        } catch (Exception exception_object) {
            throw exception_object;
        }
        try {
            target_method = cls.getDeclaredMethod(GET_CLASS_DATA,
                get_class_data_args_class);
        } catch (Exception exception_object) {
            throw exception_object;
        }
        try {
            byte_array = (byte[])target_method.invoke(
                object_instance,
                get_class_data_args_object);
        } catch (Exception exception_object) {
            throw exception_object;
        }
        return byte_array;
    }

    public void showMethod(String target) throws Exception {
        Class   cls;
        String  target_data_class_name;
        byte[]  byte_array;
        Class   return_class;
        String  return_class_name;

        target_data_class_name = target + DATA_SUFFIX;

        try {
            byte_array = getGetData(target_data_class_name);
        } catch (Exception exception_object) {
            throw exception_object;
        }

        try {
            cls = defineClass(target, byte_array, 0, byte_array.length);
        } catch (Exception exception_object) {
            throw exception_object;
        }

        System.out.println(TITLE + SPACE + cls.getName());

        Class[]   parameter_types;
        Method[]  method_list;
        method_list = cls.getDeclaredMethods();

        for (int i = 0; i < method_list.length; i++) {
            parameter_types = method_list[i].getParameterTypes();


            return_class_name = VariableType.valueOf( method_list[i].getReturnType().getName());
            System.out.print(return_class_name);
            System.out.print(SPACE);
            System.out.print(method_list[i].getName());
            if (parameter_types.length <= 0) {
                System.out.println(START_BRACE + END_BRACE);
                continue;
            }
            System.out.print(SPACE);
            System.out.print(START_BRACE);
            for (int j = 0; j < parameter_types.length; j++) {
                if (j > 0) {
                    System.out.print(COMMA);
                }
                System.out.print(parameter_types[j].getName());
            } 
            System.out.println(END_BRACE);
        }
    }

    private static String PARAMETER_ERROR = "Parameter error";
    
    public static void main(String[] args) {
        CheckData    check_data;

        if (args.length != 1) {
            System.out.println(PARAMETER_ERROR);
            return;
        }
        check_data = new CheckData();

        try {
            check_data.showMethod(args[0]);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }
}
