/**
 * Copyright (C) All rights reserved.  
 *
 * @Module     DebugCommon.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2013/07/17
 *
 */

package oserv.test;

import java.lang.*;
import java.lang.reflect.*;
import java.io.*;
import java.net.*;
import java.util.*;

import oserv.*;

public class DebugCommon {
    private static String FIELD_NAME = "Field";
    private static String SPACE = " ";
    private static String NULL_MESSAGE = "null";
    private static String OBJECT_HEADER = "Object";
    private static String INTEGER_HEADER = "Integer";

    public void showByteArray(byte[] byte_array) {

        ByteArrayInputStream   byte_array_input_stream;
        ObjectInputStream      object_input_stream;
        Object                 object_instance;

        byte_array_input_stream = new ByteArrayInputStream(byte_array);
        try {
            object_input_stream = new ObjectInputStream(
                byte_array_input_stream);
            object_instance = object_input_stream.readObject();
if (object_instance != null) {
System.out.println("TEST " + object_instance.toString());
showObject(object_instance);
}
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }

    public void showObject(Object  object_instance) {
        Integer    integer_value;
        SerializableVariable    serializable_variable;

        if ((object_instance instanceof SerializableVariable) == true) {
            serializable_variable = (SerializableVariable)object_instance;
            integer_value = serializable_variable.get();
            if (integer_value != null) {
                System.out.println(INTEGER_HEADER + SPACE +
                    integer_value.toString());
            }
        }
    }

    public void showVariable(Class class_object, Object object_instance) {
        Field[]  field_list;

        field_list = class_object.getDeclaredFields();

        for (int i = 0; i < field_list.length; i++) {
            Object    object_field;

            System.out.print(
                field_list[i].getType().getName() + SPACE +
                field_list[i].getName() );

            if (field_list[i].getType().getName().compareTo(
                Integer.class.getName() ) == 0) {
                try {
                    object_field = field_list[i].get(object_instance);
                } catch (Exception exception_object) {

if (exception_object != null) {
System.out.println();
System.out.println(exception_object.getMessage());
} else {
System.out.println(Exception.class.getName());
}
                    continue;
                }
if (object_field == null) {
System.out.println( SPACE + NULL_MESSAGE );
} else {
System.out.println( SPACE + object_field.toString() );
}
            } else {
System.out.println();
            }
        }
    }

    public static void main(String[] args) {
    
    }
}

