/**
 * Copyright (C) All rights reserved.
 *
 * @Module     UserClassLoaderTest.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2013/06/19
 */

package oserv.test;

import java.lang.*;
import java.lang.reflect.*;
import java.io.*;

import oserv.*;

public class UserClassLoaderTest extends ObjectCommand {

    private static String PARAMETER_ERROR = "Parameter error";
    private static String NUMBER_1 = "1";
    private static String NUMBER_2 = "2";

    private final static String OSERV_CALL_METHOD_DEBUG1
        = "oserv.CallMethodDebug1";


    private static String CALL_METHOD_SAMPLE_CLASS = "oserv.test.sample.CallMethodSample";
    private static Class  call_method_sample_class = null;
    private static String INT_METHOD = "intMethod";
    private static Class[] int_method_args_class = { int.class };
    private static Method  call_method_sample_int_method;

    private static String TARGET_METHOD1 ="check_setMethod";
    private static Class[]  check_set_method_args_class = { Method.class };
    private static Method  call_method_check_set_method_method = null;

/*
    public final static String OSERV_CALL_METHOD_MANAGER_DEBUG2
        = "oserv.CallMethodManagerDebug2";
    private static String TARGET_SET_METHOD ="setMethod";

    private static String TARGET_METHOD2 ="chec_invoke";
    private static Class[]  check_invoke_args_class = { Object.class };
    private static Method  call_method_manager_check_invoke_method = null;
*/

    public void execTestCase1(UserClassLoader user_class_loader) {
        byte[]   oserv_body;
        String   class_name;

        Class   call_method_class;

        class_name = OSERV_CALL_METHOD_DEBUG1;
        oserv_body = CallMethodDebug1Data.getClassData();

        try {
            call_method_class = 
                user_class_loader.getSpecifiedClass(
                    class_name, oserv_body);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
        System.out.println(call_method_class.getName());
        Object object_instance;
        try {
            object_instance = call_method_class.newInstance();
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
        try {
            call_method_sample_class =
                Class.forName(CALL_METHOD_SAMPLE_CLASS, true,
                user_class_loader);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
        System.out.println(call_method_sample_class.getName());
        try {
            call_method_sample_int_method =
                call_method_sample_class.getDeclaredMethod(
                    INT_METHOD,
                    int_method_args_class  );
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
        System.out.println(
            call_method_sample_int_method.getClass().getName());
        try {
            call_method_check_set_method_method = 
                call_method_class.getDeclaredMethod(
                TARGET_METHOD1,
                check_set_method_args_class );
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
        System.out.println(
            call_method_check_set_method_method.getClass().getName());
        Object[]   obj_args;
        obj_args = new Object[1];
        obj_args[0] = (Object)call_method_sample_int_method;
        try {
            call_method_check_set_method_method.invoke(
                object_instance,
                obj_args);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }
 
/**
    public void execTestCase2(UserClassLoader user_class_loader) {
        byte[]   oserv_body;
        String   class_name;

        Class   call_method_manager_class;

        class_name = OSERV_CALL_METHOD_MANAGER_DEBUG2;
        oserv_body = CallMethodManagerDebug2Data.getClassData();

        try {
            call_method_manager_class = 
                user_class_loader.getCallMethodManagerDebugClass(
                    class_name, oserv_body);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
        System.out.println(call_method_manager_class.getName());
        Object object_instance;
        try {
            object_instance = call_method_manager_class.newInstance();
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }

        try {
            call_method_sample_class =
                Class.forName(CALL_METHOD_SAMPLE_CLASS, true,
                user_class_loader);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
        System.out.println(call_method_sample_class.getName());
        try {
            call_method_sample_int_method =
                call_method_sample_class.getDeclaredMethod(
                    INT_METHOD,
                    int_method_args_class  );
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }

        try {
            call_method_check_invoke_method = 
                call_method_class.getDeclaredMethod(
                TARGET_METHOD2,
                check_invoke_args_class );
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }

        Object[]   obj_args;
        obj_args = new Object[1];
        obj_args[0] = (Object)call_method_sample_int_method;
        try {
            call_method_check_set_method_method.invoke(
                object_instance,
                obj_args);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
        Object  sample_instance;
        try {
            sample_instance = call_method_sample_class.newInstance();
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
       
        obj_args = new Object[1];
        obj_args[0] = (Object)sample_instance;
        try {
            call_method_check_invoke_method.invoke(
                object_instance,
                obj_args);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }

*/

    public static void main(String[] args) {
        UserClassLoader  user_class_loader;

        user_class_loader = new UserClassLoader();
        UserClassLoaderTest  user_class_loader_test;
        user_class_loader_test = new UserClassLoaderTest();

        if (args == null || args.length <= 0) {
            System.out.println(PARAMETER_ERROR);
            return;
        }
        if (args[0].compareTo(NUMBER_1) == 0) {
            user_class_loader_test.execTestCase1(user_class_loader);
            return;
        }
/**
        if (args[0].compareTo(NUMBER_2) == 0) {
            user_class_loader_test.execTestCase2(user_class_loader);
            return;
        }
**/

    }
}
