/**
 * Copyright (C) All rights reserved.
 *
 * @Module     ObjectInputManagerTest.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2013/07/15
 *
 */

package oserv.test;

import java.lang.*;
import java.io.*;
import java.net.*;

import oserv.*;

public class ObjectInputManagerTest extends ObjectInputManager {

    public static String SPACE = " ";

    public static String INTEGER_VALUE = "14";

    public Object toObject(byte[]  byte_array) throws Exception{
        Object    object_instance;
        try {
            object_instance = super.toObject(byte_array);
        } catch (Exception exception_object) {
            throw exception_object;
        }
        return object_instance;
    }

    public static void main(String[] args) {
        ObjectInputManagerTest   object_input_manager_test;

        object_input_manager_test = new ObjectInputManagerTest();

        if (args.length == 1 && args[0] != null) {
            if ( args[0].compareTo(Integer.class.getName()) == 0) {
                ByteArrayOutputStream      byte_array_output_stream;
                ObjectOutputStream         object_output_stream;
                Integer                    integer_object;
                byte[]                     byte_array;
                Object                     object_instance;

                byte_array_output_stream = new ByteArrayOutputStream();

                try {
                    object_output_stream = new ObjectOutputStream(
                        byte_array_output_stream );
                } catch (Exception exception_object) {
                    exception_object.printStackTrace();
                    return;
                }

                integer_object = Integer.valueOf( INTEGER_VALUE );

                try {
                    object_output_stream.writeObject(integer_object);
                } catch (Exception exception_object) {
                    exception_object.printStackTrace();
                    return;
                }

                byte_array = byte_array_output_stream.toByteArray();

/**
                ByteArrayInputStream   byte_array_input_stream;
                ObjectInputStream      object_input_stream;
                byte_array_input_stream = new ByteArrayInputStream(byte_array);
                try {
                    object_input_stream = new ObjectInputStream(
                        byte_array_input_stream);
                    object_instance = object_input_stream.readObject();
if (object_instance != null) {
System.out.println("TEST " + object_instance.toString());
}
                } catch (Exception exception_object) {
                    exception_object.printStackTrace();
                    return;
                }
**/
                try {
                    object_instance 
                        = object_input_manager_test.toObject(byte_array);
                } catch (Exception exception_object) {
                    exception_object.printStackTrace();
                    return;
                }

                if ((object_instance instanceof Integer) == true) {
                    System.out.println(Integer.class.getName() +
                        SPACE +
                        String.valueOf(((Integer)object_instance).intValue()) );
                }
                return;
            }
            if ( args[0].compareTo(SerializableVariable.class.getName()) == 0) {
                ByteArrayOutputStream      byte_array_output_stream;
                ObjectOutputStream         object_output_stream;
                SerializableVariable       serializable_object;
                byte[]                     byte_array;
                Object                     object_instance;

                byte_array_output_stream = new ByteArrayOutputStream();

                try {
                    object_output_stream = new ObjectOutputStream(
                        byte_array_output_stream );
                } catch (Exception exception_object) {
                    exception_object.printStackTrace();
                    return;
                }

                serializable_object = new SerializableVariable();

                try {
                    object_output_stream.writeObject(serializable_object);
                } catch (Exception exception_object) {
                    exception_object.printStackTrace();
                    return;
                }

                byte_array = byte_array_output_stream.toByteArray();
                try {
                    object_instance 
                        = object_input_manager_test.toObject(byte_array);
                } catch (Exception exception_object) {
                    exception_object.printStackTrace();
                    return;
                }
                if ((object_instance instanceof SerializableVariable)==true){
                    System.out.println(object_instance.toString());
                }
            }
        }
    }
}
