/**
 * Copyright (C) All rights reserved.  
 *
 * @Module     ObjectInputManagerWrapperTest.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2013/07/17
 *
 */

package oserv.test;

import java.lang.*;
import java.lang.reflect.*;
import java.io.*;
import java.net.*;
import java.util.*;

import oserv.*;

public class ObjectInputManagerWrapperTest extends DebugCommon {
    private static String PARAMETER_ERROR = "Parameter Error";

    private static String OBJECT_HEADER = "Object";
    private static String INTEGER_HEADER = "Integer";
    private static String SPACE = " ";

    public void toObject(byte[] byte_array) throws Exception {
        ObjectInputManager           object_input_manager;
        ObjectInputManagerWrapper    object_input_manager_wrapper;
        Object                       object_instance1;
        Object                       object_instance2;
        Class                        target_class;

        object_input_manager = new ObjectInputManager();
        target_class = object_input_manager.getClass();

        try {
            object_instance1 = object_input_manager.toObject(byte_array);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }

System.out.println(OBJECT_HEADER + SPACE + object_instance1.toString());
        showObject(object_instance1) ;
/*
        if ((object_instance1 instanceof SerializableVariable) == true) {
            SerializableVariable    serializable_variable;
            serializable_variable = (SerializableVariable)object_instance1;
            Integer    integer_value;
            integer_value = serializable_variable.get();
            if (integer_value != null) {
                System.out.println(INTEGER_HEADER + SPACE +
                    integer_value.toString());
            }
        }
*/

        object_input_manager_wrapper = new ObjectInputManagerWrapper(target_class);

        try {
            object_instance2 = object_input_manager_wrapper.toObject(byte_array);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
System.out.println(OBJECT_HEADER + SPACE + object_instance2.toString());
        showObject(object_instance2) ;
/*
        if ((object_instance2 instanceof SerializableVariable) == true) {
            SerializableVariable    serializable_variable;
            serializable_variable = (SerializableVariable)object_instance2;
            Integer    integer_value;
            integer_value = serializable_variable.get();
            if (integer_value != null) {
                System.out.println(INTEGER_HEADER + SPACE +
                    integer_value.toString());
            }
        }
**/
    }
    

    public static void main(String[] args) {
        ObjectInputManagerWrapperTest   object_input_manager_wrapper_test;
        ByteArrayOutputStream           byte_array_output_stream;
        ObjectOutputStream              object_output_stream;
        SerializableVariable            serializable_variable;
        Integer                         integer_value;
        byte[]                          byte_array;

        if (args.length != 1) {
            System.err.println(PARAMETER_ERROR);
            return;
        }
        integer_value = Integer.valueOf(args[0]);

        serializable_variable = new SerializableVariable();
        serializable_variable.set(integer_value);
        try {
            byte_array_output_stream = new ByteArrayOutputStream();
            object_output_stream = new ObjectOutputStream(
                    byte_array_output_stream);
            object_output_stream.writeObject(serializable_variable);
            byte_array = byte_array_output_stream.toByteArray();
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }

        object_input_manager_wrapper_test = new ObjectInputManagerWrapperTest();

        try {
            object_input_manager_wrapper_test.toObject(byte_array);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }
}

