/**
 * Copyright (C) All rights reserved.
 *
 * @Module     ObjectOutputManagerTest.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2013/07/16
 *
 */

package oserv.test;

import java.lang.*;
import java.io.*;
import java.net.*;

import oserv.*;

public class ObjectOutputManagerTest extends ObjectOutputManager {
    public static String SPACE = " ";
    public static String INTEGER_VALUE = "14";

    public byte[] toByteArray(Object object_target) throws Exception {
        byte[]    byte_array;
        try {
            byte_array = super.toByteArray(object_target);
        } catch (Exception exception_object) {
            throw exception_object;
        }
        return byte_array;
    }

    public static void main(String[] args) {
        ObjectOutputManagerTest   object_output_manager_test;

        object_output_manager_test = new ObjectOutputManagerTest();

        if (args.length == 1 && args[0] != null) {
            if ( args[0].compareTo(Integer.class.getName()) == 0) {
                byte[]   byte_array;
                Integer  integer_object;
                Object   object_instance;

                integer_object = Integer.valueOf( INTEGER_VALUE );

                try {
                    byte_array = object_output_manager_test.toByteArray( 
                        integer_object );
                } catch (Exception exception_object) {
                    exception_object.printStackTrace();
                    return;
                }

                ByteArrayInputStream   byte_array_input_stream;
                ObjectInputStream      object_input_stream;

                try {
                    byte_array_input_stream = new ByteArrayInputStream(
                        byte_array);
                    object_input_stream = new ObjectInputStream(
                        byte_array_input_stream );
                    object_instance = object_input_stream.readObject();
                } catch (Exception exception_object) {
                    exception_object.printStackTrace();
                    return;
                }
                if ((object_instance instanceof java.lang.Integer) == true) {
                    System.out.print( Integer.class.getName() + SPACE );
                    System.out.println(
                      String.valueOf(
                      ((java.lang.Integer)object_instance).intValue() ) );
                }
                return;
            }
            if ( args[0].compareTo(SerializableVariable.class.getName()) == 0) {
                byte[]   byte_array;
                SerializableVariable  serializable_object;
                Object   object_instance;

                serializable_object = new SerializableVariable();
                try {
                    byte_array = object_output_manager_test.toByteArray( 
                        serializable_object );
                } catch (Exception exception_object) {
                    exception_object.printStackTrace();
                    return;
                }
                ByteArrayInputStream   byte_array_input_stream;
                ObjectInputStream      object_input_stream;

                try {
                    byte_array_input_stream = new ByteArrayInputStream(
                        byte_array);
                    object_input_stream = new ObjectInputStream(
                        byte_array_input_stream );
                    object_instance = object_input_stream.readObject();
                } catch (Exception exception_object) {
                    exception_object.printStackTrace();
                    return;
                }
                if ((object_instance instanceof 
                        oserv.test.SerializableVariable) == true) {

                    System.out.print(
                        oserv.test.SerializableVariable.class.getName()+SPACE);
                    System.out.println(object_instance.toString());
                }
            }
        }
    }
}

