/**
 * Copyright (C) All rights reserved.  
 *
 * @Module     ObjectOutputManagerWrapperTest.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2013/07/17
 *
 */

package oserv.test;

import java.lang.*;
import java.lang.reflect.*;
import java.io.*;
import java.net.*;
import java.util.*;

import oserv.*;

public class ObjectOutputManagerWrapperTest extends DebugCommon {
    private static String PARAMETER_ERROR = "Parameter Error";

    private static String OBJECT_HEADER = "Object";
    private static String INTEGER_HEADER = "Integer";
    private static String SPACE = " ";

    public void toByteArray(Object object_target) throws Exception {
        ObjectOutputManager         object_output_manager;
        ObjectOutputManagerWrapper  object_output_manager_wrapper;
        Class                       target_class;
        byte[]                      byte_array_1;
        byte[]                      byte_array_2;

        object_output_manager = new ObjectOutputManager();
        target_class = object_output_manager.getClass();

        try {
            byte_array_1 = object_output_manager.toByteArray(
                object_target);
        } catch (Exception exception_object) {
            throw exception_object;
        }
        showByteArray(byte_array_1);
/**
        if (byte_array_1 != null) {
            ByteArrayInputStream      byte_array_input_stream;
            ObjectInputStream         object_input_stream;
            SerializableVariable      serializable_variable;
            Integer                   integer_value;

            byte_array_input_stream = new ByteArrayInputStream(byte_array_1);
            object_input_stream = new ObjectInputStream(
                      byte_array_input_stream);
            try {            
                object_instance1 = object_input_stream.readObject();
            } catch (Exception exception_object) {
                throw exception_object;
            }
            if ((object_instance1 instanceof SerializableVariable) == true) {
                serializable_variable 
                    = (SerializableVariable)object_instance1;
                integer_value = serializable_variable.get();
                if (integer_value != null) {
                    System.out.println(INTEGER_HEADER + SPACE +
                    integer_value.toString() );
                }
            }
        }
**/

        object_output_manager_wrapper = new ObjectOutputManagerWrapper(
            target_class);

        try {
            byte_array_2 = object_output_manager_wrapper.toByteArray(
                object_target);
        } catch (Exception exception_object) {
            throw exception_object;
        }
        showByteArray(byte_array_2);
    }

    public static void main(String[] args) {
        ObjectOutputManagerWrapperTest    object_output_manager_wrapper_test;
        SerializableVariable              serializable_variable;
        Integer                           integer_value;

        serializable_variable = new SerializableVariable();

        if (args.length != 1) {
            System.err.println(PARAMETER_ERROR);
            return;
        }
        integer_value = Integer.valueOf(args[0]);
        serializable_variable.set(integer_value);

        object_output_manager_wrapper_test 
            = new ObjectOutputManagerWrapperTest();

        try {
            object_output_manager_wrapper_test.toByteArray(
                serializable_variable);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }
}

