/**
 * Copyright (C) All rights reserved.  
 *
 * @Module     ReadVariableWrapperTest.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.1 2013/07/16
 *
 */

package oserv.test;

import java.lang.*;
import java.lang.reflect.*;
import java.io.*;
import java.net.*;
import java.util.*;

import oserv.*;

public class ReadVariableWrapperTest extends DebugCommon {
    private static String SUFFIX_1 = "_1";
    private static String SUFFIX_2 = "_2";

    public void readVariable(
        String file_name, Class class_object, Object object_instance) 
        throws Exception {
        String         file_name_1;
        String         file_name_2;
        Class          target_class;

        file_name_1 = file_name + SUFFIX_1;
        file_name_2 = file_name + SUFFIX_2;

        ReadVariable          read_variable_object;
        ReadVariableWrapper   read_variable_wrapper;

        read_variable_object = new ReadVariable();

        try {
            read_variable_object.readVariable(
                file_name_1, class_object, object_instance );
        } catch (Exception exception_object) {
            throw exception_object;
        }
        showVariable(class_object, object_instance);

        target_class = read_variable_object.getClass();
        read_variable_wrapper = new ReadVariableWrapper(target_class);

        try {
            read_variable_wrapper.readVariable(
                file_name_2, class_object, object_instance );
        } catch (Exception exception_object) {
            throw exception_object;
        }
        showVariable(class_object, object_instance);
    }

    public static void main(String[] args) {
        ReadVariableWrapperTest   read_variable_wrapper_test;
        SerializableVariable       serializable_variable;

        read_variable_wrapper_test = new ReadVariableWrapperTest();
        serializable_variable = new SerializableVariable();

        try {
            read_variable_wrapper_test.readVariable(
                args[0],
                SerializableVariable.class,
                serializable_variable );
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }
}

