/**
 * Copyright (C) All rights reserved.  
 *
 * @Module     WriteVariableWrapperTest.java
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2.0 2013/07/16
 *
 */

package oserv.test;

import java.lang.*;
import java.lang.reflect.*;
import java.io.*;
import java.net.*;
import java.util.*;

import oserv.*;

public class WriteVariableWrapperTest extends DebugCommon {
    private static String SUFFIX_1 = "_1";
    private static String SUFFIX_2 = "_2";

    private static String  PARAMETER_ERROR = "Parameter error";

    public void writeVariable(
        String file_name, Class class_object, Object object_instance) 
        throws Exception {
    
        String         file_name_1;
        String         file_name_2;
        Class          target_class;

        WriteVariable  write_variable_object;
        write_variable_object = new WriteVariable();
        target_class = write_variable_object.getClass();

        file_name_1 = file_name + SUFFIX_1;
        file_name_2 = file_name + SUFFIX_2;

        showVariable(class_object, object_instance);

        try {
            write_variable_object.writeVariable(
                file_name_1, class_object, object_instance );
        } catch (Exception exception_object) {
            throw exception_object;
        }

        WriteVariableWrapper  write_variable_wrapper;
        write_variable_wrapper = new WriteVariableWrapper(
            target_class);

        try {
            write_variable_wrapper.writeVariable(
                file_name_2, class_object, object_instance );
        } catch (Exception exception_object) {
            throw exception_object;
        }
    }

    public static void main(String[] args) {
        WriteVariableWrapperTest   write_variable_wrapper_test;
        SerializableVariable       serializable_variable;
        Integer  integer_object;

        if (args.length != 2) {
            System.err.println(PARAMETER_ERROR);
            return;
        }

        write_variable_wrapper_test = new WriteVariableWrapperTest();
        serializable_variable = new SerializableVariable();

        integer_object = Integer.valueOf(args[1]);
        serializable_variable.set(integer_object);

        try {
            write_variable_wrapper_test.writeVariable(
                args[0], 
                SerializableVariable.class,
                serializable_variable );
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
    }
}

