/**
 */

package server;

import java.lang.*;
import java.lang.reflect.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.util.zip.*;
import java.util.jar.*;

import exec.*;

public class Check extends java.lang.ClassLoader {
    private String CLASS_SUFFIX = ".class";
    private String DOT_STRING = ".";

    public String replace(String path_name, String path_key, String class_key) {
        int    idx;
        String work;
        String class_string;

        if (path_name == null || path_key == null || class_key == null) {
            return null;
        }
        class_string = new String();
        work = path_name;
        while (true) {
            idx = work.indexOf(path_key);
            if (idx < 0) {
                class_string = class_string.concat(work);
                break;
            }
            class_string = class_string.concat(
                work.substring(0, idx) + class_key);
            work = work.substring(idx+1);
        }
        return class_string;
    }

    public void loadClassFromJar(FileInputStream  file_input_stream) throws Exception {
        int                     rt;
        int                     idx;
        byte[]                  buffer;
        byte[]                  class_body;
        Class                   cls;
        Class                   class_object;
        JarInputStream          jar_input_stream;
        ByteArrayOutputStream   byte_array_output_stream;
        ZipEntry                zip_entry;
        String                  class_name;

        try {
            jar_input_stream = new JarInputStream( file_input_stream );
        } catch (Exception exception_object) {
            throw exception_object;
        }
        class_object = null;
        buffer = new byte[4096];
        for (    zip_entry = jar_input_stream.getNextEntry();
                 zip_entry != null;
                 zip_entry = jar_input_stream.getNextEntry() ) {

            class_name = zip_entry.getName();
            idx = class_name.lastIndexOf(CLASS_SUFFIX);
            if (idx <= 0) {
                continue;
            }
            class_name = class_name.substring(0, idx);
            
            byte_array_output_stream = new ByteArrayOutputStream();
            while (true) {
                try {
                    rt = jar_input_stream.read(buffer, 0, buffer.length);
                } catch (Exception exception_object) {
                    throw exception_object;
                }
                if (rt == -1) {
                    break;
                }
                byte_array_output_stream.write(buffer, 0, rt);
            }
            class_body = byte_array_output_stream.toByteArray();
            class_name = replace(class_name, File.separator, DOT_STRING);
System.out.println("Entry " + class_name);
            try {
                class_object = Class.forName(class_name, true, this);
System.out.println("class_object "+class_object.toString());
                continue;
            } catch (Exception exception_object) {
            }
            try {
                cls = defineClass(class_name, class_body, 0, class_body.length);
System.out.println("defineClass");
/*
                resolveClass(cls);
*/
            } catch (Exception exception_object) {
                throw exception_object;
            }
            try {
                class_object = Class.forName(class_name, true, this);
System.out.println("forname");
            } catch (Exception exception_object) {
exception_object.printStackTrace();
                throw exception_object;
            }
/**
**/
        }
/*
        if (class_object == null) {
            Exception exception_object;
            exception_object = new Exception();
            throw exception_object;
        }
*/
        return ;
    }

    public void execute(String class_name, String method_name, String[] args) 
    throws Exception {
        Method[] method_object;
        Object   instance_object;
        Object[] object_args;
        Class    class_object;

        object_args = new Object[1];
        object_args[0] = args;

System.out.println("Class " + class_name);
        try {
            class_object = Class.forName(class_name, true, this);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }

        System.out.println("Class object " + class_object.toString());
        try {
            instance_object = class_object.newInstance();
        } catch (Exception exception_object) {
            throw exception_object;
        }
        method_object = class_object.getMethods();
        for (int i = 0; i < method_object.length; i++) {
            if (method_object[i].getName().compareTo(method_name) == 0) {
System.out.println("Method " + method_object[i].getName());
                try {
                    method_object[i].invoke(instance_object, object_args);
                } catch (Exception exception_object) {
                    throw exception_object;
                }
            }
        }

    }

    public static void main(String[]  args) {
        Check    check_object;
        FileInputStream   file_input_stream;

        if (args.length != 3) {
            System.err.println();
            return;
        }
        check_object = new Check();

        try {
            file_input_stream = new FileInputStream(args[0]);
        } catch (Exception exception_object) {
            return;
        }

        try {
            check_object.loadClassFromJar(file_input_stream);
/*
            class_object = check_object.loadClassFromJar(
                file_input_stream, args[1]);
*/
        } catch (Exception exception_object) {
            return;
        }
        try {
            check_object.execute(args[1], args[2], args);
        } catch (Exception exception_object) {
exception_object.printStackTrace();
            return;
        }
    }
}

