/**
 * Copyright (C) All rights reserved.
 *
 * @Module     DecodeInputStream.java
 * @Author     Takahiko Tanaka.
 * @Version    1.0 2013/04/10
 *
 */

package server;

import java.lang.*;
import java.io.*;
import java.util.*;

public class DecodeInputStream extends DataInputStream {
    private static String SPACE = " ";

    public DecodeInputStream(InputStream input) {
        super(input);
    }

    public byte[] decode(String code_string) {
        byte[] code_array;
        StringTokenizer    string_token_object;

        string_token_object = new StringTokenizer(code_string, SPACE);
        code_array = new byte[string_token_object.countTokens()];
        for (int i = 0; i < code_array.length; i++) {
             code_array[i] = 
                 Byte.valueOf(string_token_object.nextToken()).byteValue();
        }
        return code_array;
    }

    public String readCodeLine() throws Exception {
        String    line;
        String    code_string;
        byte[]    byte_array;

        try {
            line = readLine();
        } catch (Exception exception_object) {
            throw exception_object;
        }
        if (line == null) {
            return null;
        }
        byte_array = decode(line);
        code_string = new String(byte_array);
        return code_string;
    }

    public static void main(String[] args) {
        String              line;
        DecodeInputStream   decode_input_stream;
        FileInputStream     file_input_stream;

        try {
            file_input_stream = new FileInputStream(args[0]);
            decode_input_stream = new DecodeInputStream(file_input_stream);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
        while (true) {
            try {
                line = decode_input_stream.readCodeLine();
            } catch (Exception exception_object) {
                exception_object.printStackTrace();
                return;
            }
            if (line == null) { break; }
            System.out.println(line);
        }
    }
}
