/**
 * Copyright (C) All rights reserved.
 *
 * @Module     EncodePrintStream.java
 * @Author     Takahiko Tanaka.
 * @Version    1.0 2013/04/10
 *
 */

package server;

import java.lang.*;
import java.io.*;

public class EncodePrintStream extends PrintStream {
    private static String SPACE = " ";
    private static String HEX_HEAD = "0x";

    public EncodePrintStream(OutputStream s) {
        super(s);
    }

    public String encode(byte[] code) {
        String  code_string;

        code_string = new String();
        if (code == null) { return code_string; }
        for (int i = 0; i < code.length; i++) {
            if (i != 0) {
                code_string = code_string.concat(SPACE);
            }
            code_string = code_string.concat(
                Integer.toString(Byte.valueOf(code[i]).intValue()));
        }
        return code_string;
    }

    public void println(String p) {
        String code_string;

        code_string = encode(p.getBytes());
        super.println(code_string);
    }
    
    private static String PARAMETER_ERROR = "Parameter error.";

    public static void main(String[] args) {
        FileOutputStream     file_output_stream;
        EncodePrintStream    encode_print_stream;

        if (args.length != 2) {
            System.err.println(PARAMETER_ERROR);
            return;
        }
        try {
            file_output_stream = new FileOutputStream(args[0]);
            encode_print_stream = new EncodePrintStream(file_output_stream);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            return;
        }
        encode_print_stream.println(args[1]);
    }
}
