/**
 * Copyright (C) All rights reserved.
 *
 * @Module     TestStreamServer.java
 * @Author     Takahiko Tanaka.
 * @Version    1.0 2012/06/18
 *
 */

package tstream;

import java.lang.*;
import java.io.*;
import java.net.*;

public class TestStreamServer extends Object implements TestStreamService {
    private  static  String  EMPTY = "";
    private  static  String  STREAM_TEST_FILE = "TestStreamServer.Test";
    private  static  String  TMP_PATH = "tmp";

    private  static  String  message001 = "OutputStream Test";
    private  static  String  message002 = "FileOutputStream Test";
    private  static  String  message003 = "ObjectOutputStream Test";
    private  static  String  message004 = "BufferedOutputStream Test";
    private  static  String  message005 = "ByteArrayOutputStream Test";
    private  static  String  message006 = "FilterOutputStream Test";
    private  static  String  message007 = "PipedOutputStream Test";
    private  static  String  message008 = "DataOutputStream Test";
    private  static  String  message009 = "PrintOutputStream Test";

    private  static  String  message101 = "InputStream Test";
    private  static  String  message102 = "FileInputStream Test";
    private  static  String  message103 = "ObjectInputStream Test";
    private  static  String  message104 = "BufferedInputStream Test";
    private  static  String  message105 = "ByteArrayInputStream Test";
    private  static  String  message106 = "FilterInputStream Test";
    private  static  String  message107 = "DataInputStream Test";
    private  static  String  message108 = "LineNumberInputStream Test";
    private  static  String  message109 = "SequenceInputStream Test";
    private  static  String  message110 = "PushbackInputStream Test";
    private  static  String  message111 = "StringBufferInputStream Test";

    private  static  String  message221 = "This is a test message.";
    private  static  String  message222 = "Contents";
    private  static  String  message223 = "End Contents";
    private  static  String  message201 = "Return InputStream Test";
    private  static  String  message202 = "Return FileInputStream Test";
    private  static  String  message203 = "Return ObjectInputStream Test";
    private  static  String  message204 = "Return BufferedInputStream Test";
    private  static  String  message205 = "Return ByteArrayInputStream Test";
    private  static  String  message206 = "Return FilterInputStream Test";
    private  static  String  message207 = "Return DataInputStream Test";
    private  static  String  message208 = "Return LineNumberInputStream Test";
    private  static  String  message209 = "Return SequenceInputStream Test";
    private  static  String  message210 = "Return PushbackInputStream Test";

    private  static  String  message3041 = "OutputStream 1";
    private  static  String  message3042 = "OutputStream 2";

    public void stream001(OutputStream output_stream) throws Exception {
        PrintStream    print_stream;

        try {
            print_stream = new PrintStream(output_stream);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }

        System.out.println(message001);
        print_stream.println(message001);
        print_stream.close();
    }

    public void stream002(FileOutputStream output_stream) throws Exception {
        PrintStream    print_stream;

        try {
            print_stream = new PrintStream(output_stream);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }

        System.out.println(message002);
        print_stream.println(message002);
        print_stream.close();
    }

    public void stream003(ObjectOutputStream output_stream) throws Exception {
        System.out.println(message003);

        output_stream.writeObject((Object)message003);
        output_stream.close();
    }

    public void stream004(BufferedOutputStream output_stream) throws Exception {
        File           fd;
        PrintStream    print_stream;

        try {
            print_stream = new PrintStream(output_stream);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }

        System.out.println(message004);
        print_stream.println(message004);
        print_stream.close();
    }

    public void stream005(ByteArrayOutputStream output_stream) throws Exception {
        PrintStream    print_stream;

        try {
            print_stream = new PrintStream(output_stream);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }

        System.out.println(message005);
        print_stream.println(message005);
        print_stream.close();
    }

    public void stream006(FilterOutputStream output_stream) throws Exception {
        PrintStream    print_stream;

        try {
            print_stream = new PrintStream(output_stream);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }

        System.out.println(message006);
        print_stream.println(message006);
        print_stream.close();
    }

    public void stream007(PipedOutputStream output_stream) throws Exception {
        PrintStream    print_stream;

        try {
            print_stream = new PrintStream(output_stream);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }

        System.out.println(message007);
        print_stream.println(message007);
        print_stream.close();
    }

    public void stream008(DataOutputStream output_stream) throws Exception {
        PrintStream    print_stream;

        try {
            print_stream = new PrintStream(output_stream);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }

        System.out.println(message008);
        print_stream.println(message008);
        print_stream.close();
    }

    public void stream009(PrintStream output_stream) throws Exception {
        System.out.println(message009);
        output_stream.println(message009);
        output_stream.close();
    }

    public void stream101(InputStream input_stream) throws Exception {
        String             line;
        DataInputStream    data_input_stream;

        try {
            data_input_stream = new DataInputStream(input_stream);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }
        while (true) {
            try {
                line = data_input_stream.readLine();
            } catch (Exception  exception_object) {
                break;
            }
            if (line == null) { break; }
System.out.println("Line " + line);
        }
    }

    public void stream102(FileInputStream input_stream) throws Exception {
        String             line;
        DataInputStream    data_input_stream;

        try {
            data_input_stream = new DataInputStream(input_stream);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }
        while (true) {
            try {
                line = data_input_stream.readLine();
            } catch (Exception  exception_object) {
                break;
            }
            if (line == null) { break; }
System.out.println("Line " + line);
        }
    }

    public void stream103(ObjectInputStream input_stream) throws Exception {
        String      line;

        while (true) {
            try {
                line = (String)input_stream.readObject();
            } catch (Exception  exception_object) {
                break;
            }
            if (line == null) { break; }
System.out.println("Line " + line);
        }
    }

    public void stream104(BufferedInputStream input_stream) throws Exception {
        String             line;
        DataInputStream    data_input_stream;

        try {
            data_input_stream = new DataInputStream(input_stream);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }
        while (true) {
            try {
                line = data_input_stream.readLine();
            } catch (Exception  exception_object) {
                break;
            }
            if (line == null) { break; }
System.out.println("Line " + line);
        }
    }

    public void stream105(ByteArrayInputStream input_stream) throws Exception {
        String             line;
        DataInputStream    data_input_stream;

        try {
            data_input_stream = new DataInputStream(input_stream);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }
        while (true) {
            try {
                line = data_input_stream.readLine();
            } catch (Exception  exception_object) {
                break;
            }
            if (line == null) { break; }
System.out.println("Line " + line);
        }
    }

    public void stream106(FilterInputStream input_stream) throws Exception {
        String             line;
        DataInputStream    data_input_stream;

        try {
            data_input_stream = new DataInputStream(input_stream);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }
        while (true) {
            try {
                line = data_input_stream.readLine();
            } catch (Exception  exception_object) {
                break;
            }
            if (line == null) { break; }
System.out.println("Line " + line);
        }
    }

    public void stream107(DataInputStream input_stream) throws Exception {
        String             line;

        while (true) {
            try {
                line = input_stream.readLine();
            } catch (Exception  exception_object) {
                break;
            }
            if (line == null) { break; }
System.out.println("Line " + line);
        }
    }

    public void stream108(LineNumberInputStream input_stream) throws Exception {
        String             line;
        DataInputStream    data_input_stream;

        try {
            data_input_stream = new DataInputStream(input_stream);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }
        while (true) {
            try {
                line = data_input_stream.readLine();
            } catch (Exception  exception_object) {
                break;
            }
            if (line == null) { break; }
System.out.println("Line " + line);
        }
    }

    public void stream109(SequenceInputStream input_stream) throws Exception {
        String             line;
        DataInputStream    data_input_stream;

        try {
            data_input_stream = new DataInputStream(input_stream);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }
        while (true) {
            try {
                line = data_input_stream.readLine();
            } catch (Exception  exception_object) {
                break;
            }
            if (line == null) { break; }
System.out.println("Line " + line);
        }
    }

    public void stream110(PushbackInputStream input_stream) throws Exception {
        String             line;
        DataInputStream    data_input_stream;

        try {
            data_input_stream = new DataInputStream(input_stream);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }
        while (true) {
            try {
                line = data_input_stream.readLine();
            } catch (Exception  exception_object) {
                break;
            }
            if (line == null) { break; }
System.out.println("Line " + line);
        }
    }

    public void stream111(StringBufferInputStream input_stream) throws Exception {
        String             line;
        DataInputStream    data_input_stream;

        try {
            data_input_stream = new DataInputStream(input_stream);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }
        while (true) {
            try {
                line = data_input_stream.readLine();
            } catch (Exception  exception_object) {
                break;
            }
            if (line == null) { break; }
System.out.println("Line " + line);
        }
    }

    public InputStream stream201() throws Exception {
        FileOutputStream       file_output_stream;
        DataInputStream        data_input_stream;
        ByteArrayOutputStream  byte_array_output_stream;
        ByteArrayInputStream   byte_array_input_stream;
        PrintStream            print_stream;

        try {
            byte_array_output_stream = new ByteArrayOutputStream();
            print_stream = new PrintStream(byte_array_output_stream);
            print_stream.println(message221);
            print_stream.println(message222);
            print_stream.println(message201);
            print_stream.println(message223);
            byte_array_input_stream = new ByteArrayInputStream(
                byte_array_output_stream.toByteArray());
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }

        try {
            data_input_stream = new DataInputStream(byte_array_input_stream);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }
        return (InputStream)data_input_stream;
    }

    public FileInputStream stream202() throws Exception {
        FileOutputStream   file_output_stream;
        FileInputStream    file_input_stream;
        PrintStream        print_stream;
        String             filename = STREAM_TEST_FILE;
        String             tmp_path = TMP_PATH;
        File               fd;

        fd = new File(EMPTY);
 
        try {
            file_output_stream = new FileOutputStream(
                fd.getPath() + File.separator + 
                tmp_path + File.separator + filename);
            print_stream = new PrintStream(file_output_stream);
            print_stream.println(message221);
            print_stream.println(message222);
            print_stream.println(message202);
            print_stream.println(message223);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }

        try {
            fd = new File(EMPTY);
            fd = fd.getAbsoluteFile();
            file_input_stream = new FileInputStream(
                fd.getPath() + File.separator + 
                tmp_path + File.separator + filename);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }
        return (FileInputStream)file_input_stream;
    }

    public ObjectInputStream stream203() throws Exception {
        FileOutputStream     file_output_stream;
        ObjectInputStream    object_input_stream;
        ByteArrayOutputStream  byte_array_output_stream;
        ByteArrayInputStream   byte_array_input_stream;
        PrintStream            print_stream;

        try {
            byte_array_output_stream = new ByteArrayOutputStream();
            print_stream = new PrintStream(byte_array_output_stream);
            print_stream.println(message221);
            print_stream.println(message222);
            print_stream.println(message203);
            print_stream.println(message223);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }

        try {
            byte_array_input_stream = new ByteArrayInputStream(
                byte_array_output_stream.toByteArray());
            object_input_stream = new ObjectInputStream(byte_array_input_stream);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }
        return (ObjectInputStream)object_input_stream;
    }

    public BufferedInputStream stream204() throws Exception{
        FileOutputStream       file_output_stream;
        ObjectInputStream      object_input_stream;
        ByteArrayOutputStream  byte_array_output_stream;
        ByteArrayInputStream   byte_array_input_stream;
        BufferedInputStream    buffered_input_stream;
        PrintStream            print_stream;

        try {
            byte_array_output_stream = new ByteArrayOutputStream();
            print_stream = new PrintStream(byte_array_output_stream);
            print_stream.println(message221);
            print_stream.println(message222);
            print_stream.println(message204);
            print_stream.println(message223);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }

        try {
            byte_array_input_stream = new ByteArrayInputStream(
                byte_array_output_stream.toByteArray());
            buffered_input_stream = new BufferedInputStream(byte_array_input_stream);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }
        return (BufferedInputStream)buffered_input_stream;
    }

    public ByteArrayInputStream stream205() throws Exception {
        FileOutputStream     file_output_stream;
        ObjectInputStream    object_input_stream;
        ByteArrayOutputStream  byte_array_output_stream;
        ByteArrayInputStream   byte_array_input_stream;
        PrintStream            print_stream;

        try {
            byte_array_output_stream = new ByteArrayOutputStream();
            print_stream = new PrintStream(byte_array_output_stream);
            print_stream.println(message221);
            print_stream.println(message222);
            print_stream.println(message205);
            print_stream.println(message223);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }

        try {
            byte_array_input_stream = new ByteArrayInputStream(
                byte_array_output_stream.toByteArray());
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }
        return (ByteArrayInputStream)byte_array_input_stream;
    }

    public FilterInputStream stream206() throws Exception {
        FileOutputStream     file_output_stream;
        ObjectInputStream    object_input_stream;
        ByteArrayOutputStream  byte_array_output_stream;
        ByteArrayInputStream   byte_array_input_stream;
        PrintStream            print_stream;
        FilterInputStream      filter_input_stream;

        try {
            byte_array_output_stream = new ByteArrayOutputStream();
            print_stream = new PrintStream(byte_array_output_stream);
            print_stream.println(message221);
            print_stream.println(message222);
            print_stream.println(message206);
            print_stream.println(message223);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }

        try {
            byte_array_input_stream = new ByteArrayInputStream(
                byte_array_output_stream.toByteArray());
            filter_input_stream = (FilterInputStream)new DataInputStream(byte_array_input_stream);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }
        return (FilterInputStream)filter_input_stream;
    }

    public DataInputStream stream207() throws Exception {
        FileOutputStream       file_output_stream;
        ObjectInputStream      object_input_stream;
        ByteArrayOutputStream  byte_array_output_stream;
        ByteArrayInputStream   byte_array_input_stream;
        PrintStream            print_stream;
        DataInputStream    data_input_stream;

        try {
            byte_array_output_stream = new ByteArrayOutputStream();
            print_stream = new PrintStream(byte_array_output_stream);
            print_stream.println(message221);
            print_stream.println(message222);
            print_stream.println(message207);
            print_stream.println(message223);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }

        try {
            byte_array_input_stream = new ByteArrayInputStream(
                byte_array_output_stream.toByteArray());
            data_input_stream = new DataInputStream(byte_array_input_stream);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }
        return (DataInputStream)data_input_stream;
    }

    public LineNumberInputStream stream208() throws Exception{
        FileOutputStream       file_output_stream;
        ObjectInputStream      object_input_stream;
        ByteArrayOutputStream  byte_array_output_stream;
        ByteArrayInputStream   byte_array_input_stream;
        PrintStream            print_stream;
        LineNumberInputStream  line_number_input_stream;

        try {
            byte_array_output_stream = new ByteArrayOutputStream();
            print_stream = new PrintStream(byte_array_output_stream);
            print_stream.println(message221);
            print_stream.println(message222);
            print_stream.println(message208);
            print_stream.println(message223);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }

        try {
            byte_array_input_stream = new ByteArrayInputStream(
                byte_array_output_stream.toByteArray());
            line_number_input_stream = new LineNumberInputStream(byte_array_input_stream);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }
        return line_number_input_stream;
    }

    public SequenceInputStream stream209() throws Exception {
        FileOutputStream       file_output_stream;
        ObjectInputStream      object_input_stream;
        ByteArrayOutputStream  byte_array_output_stream;
        ByteArrayInputStream   byte_array_input_stream;
        ByteArrayInputStream   byte_array_input_stream2;
        PrintStream            print_stream;
        SequenceInputStream    sequence_input_stream;
        byte[]                 buffer;

        try {
            byte_array_output_stream = new ByteArrayOutputStream();
            print_stream = new PrintStream(byte_array_output_stream);
            print_stream.println(message221);
            print_stream.println(message222);
            print_stream.println(message209);
            print_stream.println(message223);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }
        buffer = new byte[0];

        try {
            byte_array_input_stream = new ByteArrayInputStream(
                byte_array_output_stream.toByteArray());
            byte_array_input_stream2 = new ByteArrayInputStream(buffer);
            sequence_input_stream = new SequenceInputStream(byte_array_input_stream, 
            byte_array_input_stream2);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }
        return (SequenceInputStream)sequence_input_stream;
    }

    public PushbackInputStream stream210() throws Exception {
        FileOutputStream       file_output_stream;
        ObjectInputStream      object_input_stream;
        ByteArrayOutputStream  byte_array_output_stream;
        ByteArrayInputStream   byte_array_input_stream;
        PrintStream            print_stream;
        PushbackInputStream    pushback_input_stream;

        try {
            byte_array_output_stream = new ByteArrayOutputStream();
            print_stream = new PrintStream(byte_array_output_stream);
            print_stream.println(message221);
            print_stream.println(message222);
            print_stream.println(message210);
            print_stream.println(message223);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }

        try {
            byte_array_input_stream = new ByteArrayInputStream(
                byte_array_output_stream.toByteArray());
            pushback_input_stream = new PushbackInputStream(byte_array_input_stream);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }
        return (PushbackInputStream)pushback_input_stream;
    }

    public void stream301(InputStream input_stream, OutputStream output_stream)  throws Exception {
        String             line;
        PrintStream        print_stream;
        DataInputStream    data_input_stream;

        try {
            print_stream = new PrintStream(output_stream);
            data_input_stream = new DataInputStream(input_stream);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }
        while (true) {
            try {
                line = data_input_stream.readLine();
            } catch (Exception exception_object) {
                break;
            }
            if (line == null) { break; }
            print_stream.println(line);
System.out.println(line);
        }
        print_stream.close();
    }

    public void stream302(OutputStream output_stream, InputStream input_stream)  throws Exception {
        String             line;
        PrintStream        print_stream;
        DataInputStream    data_input_stream;

        try {
            print_stream = new PrintStream(output_stream);
            data_input_stream = new DataInputStream(input_stream);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }
        while (true) {
            try {
                line = data_input_stream.readLine();
            } catch (Exception exception_object) {
                break;
            }
            if (line == null) { break; }
            print_stream.println(line);
System.out.println(line);
        }
        print_stream.close();
    }

    public void stream303(InputStream input_stream1, InputStream input_stream2)  throws Exception {
        String             line;
        boolean            flag1;
        boolean            flag2;
        DataInputStream    data_input_stream1;
        DataInputStream    data_input_stream2;

        try {
            data_input_stream1 = new DataInputStream(input_stream1);
            data_input_stream2 = new DataInputStream(input_stream2);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }
        flag1 = false;
        flag2 = false;
        while (true) {
            try {
                if (flag1 == false) {
                    line = data_input_stream1.readLine();
                    if (line == null) {
                        flag1 = true;
                    } else {
System.out.println("Line " + line);
                    }
                }
                if (flag2 == false) {
                    line = data_input_stream2.readLine();
                    if (line == null) {
                        flag2 = true;
                    } else {
System.out.println("Line " + line);
                    }
                }
            } catch (Exception  exception_object) {
                break;
            }
            if (flag1 == false && flag2 == false) {
                break;
            }
        }
    }

    public void stream304(OutputStream output_stream1, OutputStream output_stream2) throws Exception {
        PrintStream    print_stream1;
        PrintStream    print_stream2;

        try {
            print_stream1 = new PrintStream(output_stream1);
            print_stream2 = new PrintStream(output_stream2);
        } catch (Exception exception_object) {
            exception_object.printStackTrace();
            throw exception_object;
        }

        System.out.println(message3041);
        print_stream1.println(message3041);
        print_stream2.println(message3042);
     
        print_stream1.close();
        print_stream2.close();
    }
}

