/**
 * Copyright (C) All rights reserved.
 *
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2012/01/20
 * @Module     VarServer.java
 *
 */

package var;

import java.lang.*;
import java.net.*;
import java.io.*;

public class VarServer extends Object implements VarService {
    private final static String VAR_SERVER_MESSAGE 
        = "This is VarServer Message";

    private final static String INT_HEADER      = "Int    ";
    private final static String LONG_HEADER     = "Long   ";
    private final static String FLOAT_HEADER    = "Float  ";
    private final static String DOUBLE_HEADER   = "Double ";
    private final static String BOOLEAN_HEADER  = "Boolean ";
    private final static String SHORT_HEADER    = "Short ";
    private final static String CHAR_HEADER     = "Char ";
    private final static String BYTE_HEADER     = "Byte ";
    private final static String STRING_HEADER   = "String ";

    private final static String OBJECT_HEADER   = "Object ";

    private final static String OBJECT_INT_HEADER      = "Integer ";
    private final static String OBJECT_LONG_HEADER     = "Long    ";
    private final static String OBJECT_FLOAT_HEADER    = "Float   ";
    private final static String OBJECT_DOUBLE_HEADER   = "Double  ";
    private final static String OBJECT_BOOLEAN_HEADER  = "Boolean ";
    private final static String OBJECT_SHORT_HEADER    = "Short   ";
    private final static String OBJECT_CHAR_HEADER     = "Char    ";
    private final static String OBJECT_BYTE_HEADER     = "Byte    ";

    private final static String INT_RETURN      = "Int value     ";
    private final static String LONG_RETURN     = "Long value    ";
    private final static String FLOAT_RETURN    = "Float value   ";
    private final static String DOUBLE_RETURN   = "Double value  ";
    private final static String BOOLEAN_RETURN  = "Boolean value ";
    private final static String SHORT_RETURN    = "Short value   ";
    private final static String CHAR_RETURN     = "Char value    ";
    private final static String BYTE_RETURN     = "Byte value    ";
    private final static String STRING_RETURN   = "String value  ";

    private final static String OBJECT_RETURN   = "Object value  ";

    private final static String OBJECT_INT_RETURN      = "Integer value ";
    private final static String OBJECT_LONG_RETURN     = "Long value    ";
    private final static String OBJECT_FLOAT_RETURN    = "Float value   ";
    private final static String OBJECT_DOUBLE_RETURN   = "Double value  ";
    private final static String OBJECT_BOOLEAN_RETURN  = "Boolean value ";
    private final static String OBJECT_SHORT_RETURN    = "Short value   ";
    private final static String OBJECT_CHAR_RETURN     = "Char value    ";
    private final static String OBJECT_BYTE_RETURN     = "Byte value    ";

    private final static String BYTE_ARRAY_VALUE = "Value";
    
    private final static String SPACE = " ";

    private final static String STRING_VALUE = "20";

    public  SerializableVariable serializable_variable 
        = new SerializableVariable(new String());

    private final static String PREVIOUS_MESSAGE = "Previous message ";

    public int          check1() 
    {
        int int_value;
        int_value = 1;
        System.out.println(VAR_SERVER_MESSAGE);
        System.out.println(INT_HEADER + String.valueOf(int_value));
        return int_value;
    }

    public long         check2() 
    {
        long long_value;
        long_value = 2;
        System.out.println(VAR_SERVER_MESSAGE);
        System.out.println(LONG_HEADER + String.valueOf(long_value));
        return long_value;
    }

    public float        check3()
    {
        float float_value;
        float_value = (float)3.0;
        System.out.println(VAR_SERVER_MESSAGE);
        System.out.println(FLOAT_HEADER + String.valueOf(float_value));
        return float_value;
    }

    public double       check4() 
    {
        double double_value;
        double_value = 4.0;
        System.out.println(VAR_SERVER_MESSAGE);
        System.out.println(DOUBLE_HEADER + String.valueOf(double_value));
        return double_value;
    }

    public short        check5()
    {
        short short_value;
        short_value = 5;
        System.out.println(VAR_SERVER_MESSAGE);
        System.out.println(SHORT_HEADER + String.valueOf(short_value));
        return short_value;
    }

    public char         check6()
    {
        char char_value;
        char_value = 6;
        System.out.println(VAR_SERVER_MESSAGE);
        System.out.println(CHAR_HEADER + String.valueOf((int)char_value));
        return char_value;
    }

    public byte         check7()
    {
        byte byte_value;
        byte_value = 7;
        System.out.println(VAR_SERVER_MESSAGE);
        System.out.println(CHAR_HEADER + String.valueOf(byte_value));
        return byte_value;
    }

    public boolean      check8()
    {
        boolean boolean_value;
        boolean_value = true;
        System.out.println(VAR_SERVER_MESSAGE);
        System.out.println(BOOLEAN_HEADER + String.valueOf(boolean_value));
        return boolean_value;
    }

    public Object      check9() throws VarException
    {
        Object object_instance;
        object_instance = new Object();
        System.out.println(VAR_SERVER_MESSAGE);
        VarException exception_object;
        exception_object = new VarException(object_instance.toString());
        throw exception_object;
    }

    public String         check10() 
    {
        String  string_value;
        string_value = "10";
        System.out.println(VAR_SERVER_MESSAGE);
        System.out.println(STRING_HEADER + string_value);
        return string_value;
    }

    public Integer      check11()
    {
        Integer integer_value;
        integer_value = new Integer(11);
        System.out.println(VAR_SERVER_MESSAGE);
        System.out.println(OBJECT_INT_HEADER + String.valueOf(integer_value.intValue()) + SPACE + integer_value.toString());
        return integer_value;
    }

    public Long         check12()
    {
        Long long_value;
        long_value = new Long(12);
        System.out.println(VAR_SERVER_MESSAGE);
        System.out.println(OBJECT_LONG_HEADER + String.valueOf(long_value.longValue()) + SPACE + long_value.toString());
        return long_value;
    }

    public Float        check13()
    {
        Float float_value;
        float_value = new Float(13.0);
        System.out.println(VAR_SERVER_MESSAGE);
        System.out.println(OBJECT_FLOAT_HEADER + String.valueOf(float_value.floatValue()) + SPACE + float_value.toString());
        return float_value;
    }

    public Double       check14()
    {
        Double double_value;
        double_value = new Double(14.0);
        System.out.println(VAR_SERVER_MESSAGE);
        System.out.println(OBJECT_DOUBLE_HEADER + String.valueOf(double_value.doubleValue()) + SPACE + double_value.toString());
        return double_value;
    }

    public Short        check15()
    {
        Short short_value;
        short_value = new Short((short)15);
        System.out.println(VAR_SERVER_MESSAGE);
        System.out.println(OBJECT_SHORT_HEADER + String.valueOf(short_value.shortValue()) + SPACE + short_value.toString());
        return short_value;
    }

    public Character    check16()
    {
        Character character_value;
        character_value = Character.valueOf((char)16);
        System.out.println(VAR_SERVER_MESSAGE);
        System.out.println(OBJECT_CHAR_HEADER + String.valueOf((int)character_value.charValue()) );
        return character_value;
    }

    public Byte         check17()
    {
        Byte byte_value;
        byte_value = new Byte((byte)17);
        System.out.println(VAR_SERVER_MESSAGE);
        System.out.println(OBJECT_BYTE_HEADER + String.valueOf(byte_value.byteValue()) + SPACE + byte_value.toString());
        return byte_value;
    }

    public Boolean      check18()
    {
        Boolean boolean_value;
        boolean_value = new Boolean(true);
        System.out.println(VAR_SERVER_MESSAGE);
        System.out.println(OBJECT_BOOLEAN_HEADER + String.valueOf(boolean_value.booleanValue()) + SPACE + boolean_value.toString());
        return boolean_value;
    }

    public Object       check19() throws IOException, WriteAbortedException
    {
        SerializableObject object_value;
        object_value = new SerializableObject();
        System.out.println(VAR_SERVER_MESSAGE);
        System.out.println(OBJECT_HEADER + object_value.toString());
        return object_value;
    }

    public Object      check20() throws Exception
    {
        Object   object_value;
        object_value = new Object();
        System.out.println(VAR_SERVER_MESSAGE);
        System.out.println(OBJECT_HEADER + object_value.toString());
        return object_value;
    }

    public String       check21(int a)
    {
        String  string_value;
        System.out.println(VAR_SERVER_MESSAGE);
        string_value = new String(INT_RETURN + String.valueOf(a));
        System.out.println(string_value);
        return string_value;
    }

    public String       check22(long a)
    {
        String  string_value;
        System.out.println(VAR_SERVER_MESSAGE);
        string_value = new String(LONG_RETURN + String.valueOf(a));
        System.out.println(string_value);
        return string_value;
    }

    public String       check23(float a)
    {
        String  string_value;
        System.out.println(VAR_SERVER_MESSAGE);
        string_value = new String(FLOAT_RETURN + String.valueOf(a));
        System.out.println(string_value);
        return string_value;
    }

    public String       check24(double a)
    {
        String  string_value;
        System.out.println(VAR_SERVER_MESSAGE);
        string_value = new String(DOUBLE_RETURN + String.valueOf(a));
        System.out.println(string_value);
        return string_value;
    }

    public String       check25(short a)
    {
        String  string_value;
        System.out.println(VAR_SERVER_MESSAGE);
        string_value = new String(SHORT_RETURN + String.valueOf(a));
        System.out.println(string_value);
        return string_value;
    }

    public String       check26(char a)
    {
        String  string_value;
        System.out.println(VAR_SERVER_MESSAGE);
        string_value = new String(CHAR_RETURN + String.valueOf((int)a));
        System.out.println(string_value);
        return string_value;
    }

    public String         check27(byte a)
    {
        String  string_value;
        System.out.println(VAR_SERVER_MESSAGE);
        string_value = new String(BYTE_RETURN + Byte.valueOf(a).toString());
        System.out.println(string_value);
        return string_value;
    }

    public String         check28(boolean a)
    {
        String  string_value;
        System.out.println(VAR_SERVER_MESSAGE);
        string_value = new String(BOOLEAN_RETURN + String.valueOf(a));
        System.out.println(string_value);
        return string_value;
    }

    public String         check29(Object a) throws NotSerializableException
    {
        String  string_value;
        System.out.println(VAR_SERVER_MESSAGE);
        string_value = new String(OBJECT_RETURN + a.toString());
        System.out.println(string_value);
        return string_value;
    }

    public String         check30(String a)
    {
        String  string_value;
        System.out.println(VAR_SERVER_MESSAGE);
        string_value = new String(STRING_RETURN + a);
        System.out.println(string_value);
        return string_value;
    }

    public String         check31(Integer a)
    {
        String  string_value;
        System.out.println(VAR_SERVER_MESSAGE);
        string_value = new String(OBJECT_INT_RETURN + a.toString());
        System.out.println(string_value);
        return string_value;
    }

    public String         check32(Long a)
    {
        String  string_value;
        System.out.println(VAR_SERVER_MESSAGE);
        string_value = new String(OBJECT_LONG_RETURN + a.toString());
        System.out.println(string_value);
        return string_value;
    }

    public String         check33(Float a)
    {
        String  string_value;
        System.out.println(VAR_SERVER_MESSAGE);
        string_value = new String(OBJECT_FLOAT_RETURN + a.toString());
        System.out.println(string_value);
        return string_value;
    }

    public String         check34(Double a)
    {
        String  string_value;
        System.out.println(VAR_SERVER_MESSAGE);
        string_value = new String(OBJECT_DOUBLE_RETURN + a.toString());
        System.out.println(string_value);
        return string_value;
    }

    public String         check35(Short a)
    {
        String  string_value;
        System.out.println(VAR_SERVER_MESSAGE);
        string_value = new String(OBJECT_SHORT_RETURN + a.toString());
        System.out.println(string_value);
        return string_value;
    }

    public String         check36(Character a)
    {
        String  string_value;
        System.out.println(VAR_SERVER_MESSAGE);
        string_value = OBJECT_CHAR_RETURN + String.valueOf((int)a.charValue());
        System.out.println(string_value);
        return string_value;
    }

    public String         check37(Byte a)
    {
        String  string_value;
        System.out.println(VAR_SERVER_MESSAGE);
        string_value = new String(OBJECT_BYTE_RETURN + a.toString());
        System.out.println(string_value);
        return string_value;
    }

    public String         check38(Boolean a)
    {
        String  string_value;
        System.out.println(VAR_SERVER_MESSAGE);
        string_value = new String(OBJECT_BOOLEAN_RETURN + a.toString());
        System.out.println(string_value);
        return string_value;
    }

    public String         check39(SerializableObject a) throws NotSerializableException
    {
        String  string_value;
        System.out.println(VAR_SERVER_MESSAGE);
        string_value = new String(OBJECT_RETURN + a.toString());
        System.out.println(string_value);
        return string_value;
    }

    public String         check40(SerializableTest a) throws Exception
    {
        String  string_value;
        System.out.println(VAR_SERVER_MESSAGE);
        string_value = new String(OBJECT_RETURN + a.toString());
        System.out.println(string_value);
        return string_value;
    }

    public byte[]         check41()
    {
        byte[] byte_array;
        byte_array = new byte[16];
        for (int i = 0; i < 16; i++) {
            byte_array[i] = (byte)i;
            System.out.println(VAR_SERVER_MESSAGE);
            System.out.println(BYTE_ARRAY_VALUE + SPACE + String.valueOf(i));
        }
        return byte_array;
    }

    public String check42(byte[] a) 
    {
        String rt;
        rt = new String();
        for (int i = 0; i < a.length; i++) {
            rt = rt.concat(BYTE_ARRAY_VALUE + SPACE + String.valueOf(i) 
                + SPACE + String.valueOf((int)a[i]));

        }
        System.out.println(VAR_SERVER_MESSAGE);
        System.out.println(BYTE_ARRAY_VALUE + SPACE + rt);
        return rt;
    }

    public String         check43(String  msg)
    {
        String previous;

        System.out.println(VAR_SERVER_MESSAGE);
        System.out.println(msg);
        previous = PREVIOUS_MESSAGE;
        if (serializable_variable != null) {
            previous = PREVIOUS_MESSAGE + serializable_variable.getMessage();
            System.out.println(serializable_variable.toString());
            System.out.println(serializable_variable.getMessage());
        }
        System.out.println(previous);
        serializable_variable = new SerializableVariable(msg);
        System.out.println(serializable_variable.getMessage());
        return previous;
    }
}
