/**
 * Copyright (C) All rights reserved.
 *
 * @Author     Takahiko Tanaka
 *             uewxiun@pb3.so-net.ne.jp
 * @Version    2012/01/20
 * @Module     VarClient.java
 *
 */

package var;

import java.lang.*;
import java.io.*;

import oserv.*;

public class VarClient extends Object {
    private final static String VALUE_NULL   = "Value null";
    private final static String VALUE_KEY    = "Value";
    private final static String OBJECT_RETURN   = "Object value ";
    private final static String SPACE = " ";

    private final static String INT_HEADER      = "Int    ";
    private final static String LONG_HEADER     = "Long   ";
    private final static String FLOAT_HEADER    = "Float  ";
    private final static String DOUBLE_HEADER   = "Double ";
    private final static String BOOLEAN_HEADER  = "Boolean ";
    private final static String SHORT_HEADER    = "Short ";
    private final static String CHAR_HEADER     = "Char ";
    private final static String BYTE_HEADER     = "Byte ";

    private final static String INT_RETURN      = "Int value   ";
    private final static String LONG_RETURN     = "Long value  ";
    private final static String FLOAT_RETURN    = "Float value ";
    private final static String DOUBLE_RETURN   = "Double value ";
    private final static String BOOLEAN_RETURN  = "Boolean value ";
    private final static String SHORT_RETURN    = "Short value ";
    private final static String CHAR_RETURN     = "Char value ";
    private final static String BYTE_RETURN     = "Byte value ";
    private final static String STRING_RETURN   = "String value ";
    private final static String OBJECT_INT_RETURN      = "Integer value ";
    private final static String OBJECT_LONG_RETURN     = "Long value    ";
    private final static String OBJECT_FLOAT_RETURN    = "Float value   ";
    private final static String OBJECT_DOUBLE_RETURN   = "Double value  ";
    private final static String OBJECT_BOOLEAN_RETURN  = "Boolean value ";
    private final static String OBJECT_SHORT_RETURN    = "Short value   ";
    private final static String OBJECT_CHAR_RETURN     = "Char value    ";
    private final static String OBJECT_BYTE_RETURN     = "Byte value    ";

    private final static String EXCEPTION_TEST = "Exception Test ";
    private final static String EXCEPTION_KEY = "Exception ";

    private final static String STRING_30 = "30";
    private final static String TEST_ALL = "all";
    private final static String TEST_0 = "0";
    private final static String TEST_1 = "1";
    private final static String TEST_2 = "2";
    private final static String TEST_3 = "3";
    private final static String TEST_4 = "4";
    private final static String TEST_5 = "5";
    private final static String TEST_6 = "6";
    private final static String TEST_7 = "7";
    private final static String TEST_8 = "8";
    private final static String TEST_9 = "9";
    private final static String TEST_10 = "10";
    private final static String TEST_11 = "11";
    private final static String TEST_12 = "12";
    private final static String TEST_13 = "13";
    private final static String TEST_14 = "14";
    private final static String TEST_15 = "15";
    private final static String TEST_16 = "16";
    private final static String TEST_17 = "17";
    private final static String TEST_18 = "18";
    private final static String TEST_19 = "19";
    private final static String TEST_20 = "20";
    private final static String TEST_21 = "21";
    private final static String TEST_22 = "22";
    private final static String TEST_23 = "23";
    private final static String TEST_24 = "24";
    private final static String TEST_25 = "25";
    private final static String TEST_26 = "26";
    private final static String TEST_27 = "27";
    private final static String TEST_28 = "28";
    private final static String TEST_29 = "29";
    private final static String TEST_30 = "30";
    private final static String TEST_31 = "31";
    private final static String TEST_32 = "32";
    private final static String TEST_33 = "33";
    private final static String TEST_34 = "34";
    private final static String TEST_35 = "35";
    private final static String TEST_36 = "36";
    private final static String TEST_37 = "37";
    private final static String TEST_38 = "38";
    private final static String TEST_39 = "39";
    private final static String TEST_40 = "40";
    private final static String TEST_41 = "41";
    private final static String TEST_42 = "42";
    private final static String TEST_43 = "43";

    public void          check1() {
        VarService vs = (VarService)new VarServer();
        int data = vs.check1();
        System.out.println(INT_RETURN + String.valueOf(data));
        return;
    }

    public void         check2() {
        VarService vs = (VarService)new VarServer();
        long data = vs.check2();
        System.out.println(LONG_RETURN + String.valueOf(data));
        return;
    }

    public void        check3() {
        VarService vs = (VarService)new VarServer();
        float data = vs.check3();
        System.out.println(FLOAT_RETURN + String.valueOf(data));
        return;
    }

    public void        check4() {
        VarService vs = (VarService)new VarServer();
        double data = vs.check4();
        System.out.println(DOUBLE_RETURN + String.valueOf(data));
        return;
    }

    public void         check5() {
        VarService vs = (VarService)new VarServer();
        short data = vs.check5();
        System.out.println(SHORT_RETURN + String.valueOf(data));
        return;
    }

    public void         check6() {
        VarService vs = (VarService)new VarServer();
        char data = vs.check6();
        System.out.println(CHAR_RETURN + String.valueOf((int)data));
        return;
    }

    public void         check7() {
        VarService vs = (VarService)new VarServer();
        byte data = vs.check7();
        System.out.println(BYTE_RETURN + Byte.valueOf(data).toString());
    }

    public void         check8() {
        VarService vs = (VarService)new VarServer();
        boolean data = vs.check8();
        System.out.println(BOOLEAN_RETURN + String.valueOf(data));
    }

    public void         check9() {
        Object     object_instance = new Object();
        VarService vs = (VarService)new VarServer();
        try {
           object_instance = vs.check9();
        } catch (Exception exception_object) {
            System.out.println(EXCEPTION_TEST + exception_object.toString());
            return;
        }
        System.out.println(TEST_9 + SPACE + object_instance.toString());
    }

    public void         check10() {
        VarService vs = (VarService)new VarServer();
        String rt = vs.check10();
        if (rt == null) { System.out.println(VALUE_NULL); }
        else {
            System.out.println(STRING_RETURN + rt);
        }
    }

    public void         check11() {
        VarService vs = (VarService)new VarServer();
        Integer data = vs.check11();
        if (data == null) { System.out.println(VALUE_NULL); }
        else {
            System.out.println(OBJECT_INT_RETURN + data.toString());
        }
    }

    public void         check12() {
        VarService vs = (VarService)new VarServer();
        Long data = vs.check12();
        if (data == null) { System.out.println(VALUE_NULL); }
        else {
            System.out.println(OBJECT_LONG_RETURN + data.toString());
        }
    }

    public void         check13() {
        VarService vs = (VarService)new VarServer();
        Float data = vs.check13();
        if (data == null) { System.out.println(VALUE_NULL); }
        else {
            System.out.println(OBJECT_FLOAT_RETURN + data.toString());
        }
    }

    public void         check14() {
        VarService vs = (VarService)new VarServer();
        Double data = vs.check14();
        if (data == null) { System.out.println(VALUE_NULL); }
        else {
            System.out.println(OBJECT_DOUBLE_RETURN + data.toString());
        }
    }

    public void         check15() {
        VarService vs = (VarService)new VarServer();
        Short data = vs.check15();
        if (data == null) { System.out.println(VALUE_NULL); }
        else {
            System.out.println(OBJECT_SHORT_RETURN + data.toString());
        }
    }

    public void         check16() {
        VarService vs = (VarService)new VarServer();
        Character data = vs.check16();
        if (data == null) { System.out.println(VALUE_NULL); }
        else {
            System.out.println(OBJECT_CHAR_RETURN + String.valueOf((int)data.charValue()));
        }
    }

    public void         check17() {
        VarService vs = (VarService)new VarServer();
        Byte data = vs.check17();
        if (data == null) { System.out.println(VALUE_NULL); }
        else {
            System.out.println(OBJECT_BYTE_RETURN + data.toString());
        }
    }

    public void      check18() {
        VarService vs = (VarService)new VarServer();
        Boolean data = vs.check18();
        if (data == null) { System.out.println(VALUE_NULL); }
        else {
            System.out.println(OBJECT_BOOLEAN_RETURN + data.toString());
        }
    }

    public void         check19() {
        VarService vs = (VarService)new VarServer();
        try {
            Object data = vs.check19();
            if (data == null) { System.out.println(VALUE_NULL); }
            System.out.println(OBJECT_RETURN + data.toString());
        } catch (WriteAbortedException wp) {
            wp.printStackTrace();
        } catch (IOException ep) {
            ep.printStackTrace();
        }
    }

    public void         check20() {
        VarService vs = (VarService)new VarServer();
        Object data = null;
        try {
            data = vs.check20();
        } catch (Exception exception_object) {
            System.out.println(EXCEPTION_KEY + exception_object.toString());
            return;
        }
        if (data == null) { System.out.println(VALUE_NULL); }
        else {
            System.out.println(VALUE_KEY + SPACE + data.toString());
        }
    }

    public void         check21(int a) {
        VarService vs = (VarService)new VarServer();
        String rt = vs.check21(a);
        if (rt == null) { System.out.println(VALUE_NULL); }
        else { System.out.println(VALUE_KEY + SPACE + rt); }
    }

    public void         check22(long a) {
        VarService vs = (VarService)new VarServer();
        String rt = vs.check22(a);
        if (rt == null) { System.out.println(VALUE_NULL); }
        else { System.out.println(VALUE_KEY + SPACE + rt); }
    }

    public void         check23(float a) {
        VarService vs = (VarService)new VarServer();
        String rt = vs.check23(a);
        if (rt == null) { System.out.println(VALUE_NULL); }
        else { System.out.println(VALUE_KEY + SPACE + rt); }
    }

    public void         check24(double a) {
        VarService vs = (VarService)new VarServer();
        String rt = vs.check24(a);
        if (rt == null) { System.out.println(VALUE_NULL); }
        else { System.out.println(VALUE_KEY + SPACE + rt); }
    }

    public void         check25(short a) {
        VarService vs = (VarService)new VarServer();
        String rt = vs.check25(a);
        if (rt == null) { System.out.println(VALUE_NULL); }
        else { System.out.println(VALUE_KEY + SPACE + rt); }
    }

    public void         check26(char a) {
        VarService vs = (VarService)new VarServer();
        String rt = vs.check26(a);
        if (rt == null) { System.out.println(VALUE_NULL); }
        else { System.out.println(VALUE_KEY + SPACE + rt); }
    }

    public void         check27(byte a) {
        VarService vs = (VarService)new VarServer();
        String rt = vs.check27(a);
        if (rt == null) { System.out.println(VALUE_NULL); }
        else { System.out.println(VALUE_KEY + SPACE + rt); }
    }

    public void         check28(boolean a) {
        VarService vs = (VarService)new VarServer();
        String rt = vs.check28(a);
        if (rt == null) { System.out.println(VALUE_NULL); }
        else { System.out.println(VALUE_KEY + SPACE + rt); }
    }

    public void         check29(Object a) {
        String rt;
        VarService vs = (VarService)new VarServer();
        try {
            rt = vs.check29(a);
        } catch (NotSerializableException exception_object) {
            System.err.println(exception_object.toString());
            return;
        }
        if (rt == null) { System.out.println(VALUE_NULL); }
        else { System.out.println(VALUE_KEY + SPACE + rt); }
    }

    public void         check30(String a) {
        VarService vs = (VarService)new VarServer();
        String rt = vs.check30(a);
        if (rt == null) { System.out.println(VALUE_NULL); }
        else { System.out.println(VALUE_KEY + SPACE + rt); }
    }

    public void         check31(Integer a) {
        VarService vs = (VarService)new VarServer();
        String rt = vs.check31(a);
        if (rt == null) { System.out.println(VALUE_NULL); }
        else { System.out.println(VALUE_KEY + SPACE + rt); }
    }

    public void         check32(Long a) {
        VarService vs = (VarService)new VarServer();
        String rt = vs.check32(a);
        if (rt == null) { System.out.println(VALUE_NULL); }
        else { System.out.println(VALUE_KEY + SPACE + rt); }
    }

    public void         check33(Float a) {
        VarService vs = (VarService)new VarServer();
        String rt = vs.check33(a);
        if (rt == null) { System.out.println(VALUE_NULL); }
        else { System.out.println(VALUE_KEY + SPACE + rt); }
    }

    public void         check34(Double a) {
        VarService vs = (VarService)new VarServer();
        String rt = vs.check34(a);
        if (rt == null) { System.out.println(VALUE_NULL); }
        else { System.out.println(VALUE_KEY + SPACE + rt); }
    }

    public void         check35(Short a) {
        VarService vs = (VarService)new VarServer();
        String rt = vs.check35(a);
        if (rt == null) { System.out.println(VALUE_NULL); }
        else { System.out.println(VALUE_KEY + SPACE + rt); }
    }

    public void         check36(Character a) {
        VarService vs = (VarService)new VarServer();
        String rt = vs.check36(a);
        if (rt == null) { System.out.println(VALUE_NULL); }
        else { System.out.println(VALUE_KEY + SPACE + rt); }
    }

    public void         check37(Byte a) {
        VarService vs = (VarService)new VarServer();
        String rt = vs.check37(a);
        if (rt == null) { System.out.println(VALUE_NULL); }
        else { System.out.println(VALUE_KEY + SPACE + rt); }
    }

    public void         check38(Boolean a) {
        VarService vs = (VarService)new VarServer();
        String rt = vs.check38(a);
        if (rt == null) { System.out.println(VALUE_NULL); }
        else { System.out.println(VALUE_KEY + SPACE + rt); }
    }

    public void         check39(SerializableObject a) {
        String rt;
        VarService vs = (VarService)new VarServer();
        try {
            rt = vs.check39(a);
        } catch (NotSerializableException exception_object) {
            System.err.println(exception_object.toString());
            return;
        }
        if (rt == null) { System.out.println(VALUE_NULL); }
        else { System.out.println(VALUE_KEY + SPACE + rt); }
    }

    public void         check40(SerializableTest a) {
        String rt;
        VarService vs = (VarService)new VarServer();
        try {
            rt = vs.check40(a);
        } catch (Exception exception_object) {
            System.err.println(exception_object.toString());
            return;
        }
        if (rt == null) { System.out.println(VALUE_NULL); }
        else { System.out.println(VALUE_KEY + SPACE + rt); }
    }

    public void        check41() {
        VarService vs = (VarService)new VarServer();
        byte[] byte_array = vs.check41();
        if (byte_array == null) { 
            System.out.println(VALUE_NULL); 
            return;
        }
        for (int i = 0; i < byte_array.length;i++) {
            System.out.println(VALUE_KEY + SPACE + String.valueOf(i) 
                + SPACE + String.valueOf((int)byte_array[i]));
        }
        return;
    }

    public void     check42(byte[] a) {
        VarService vs = (VarService)new VarServer();
        String rt = vs.check42(a);
        System.out.println(VALUE_KEY + SPACE + rt);
        return;
    }

    private static String PREVIOUS = "Previous message is null";
    private static String MESSAGE1 = "Message 1";
    private static String MESSAGE2 = "Message 2";

    public void      check43() {
        VarService vs = (VarService)new VarServer();

        String msg = vs.check43(MESSAGE1);
        if (msg == null) {
            System.out.println(PREVIOUS);
        } else {
            System.out.println(msg);
        }
        msg = vs.check43(MESSAGE2);
        if (msg == null) {
            System.out.println(PREVIOUS);
        } else {
            System.out.println(msg);
        }
    }

    private static String NOT_SERIALIZABLE_OBJECT
        = "Not Serializable Object";

    public static void main(String[] ag) {
        VarClient vc = new VarClient();
        if (ag.length == 1) {
            if (ag[0].compareTo(TEST_ALL) == 0) {
                vc.check1();
                vc.check2();
                vc.check3();
                vc.check4();
                vc.check5();
                vc.check6();
                vc.check7();
                vc.check8();
                vc.check9();
                vc.check10();

                vc.check11();
                vc.check12();
                vc.check13();
                vc.check14();
                vc.check15();
                vc.check16();
                vc.check17();
                vc.check18();

                vc.check19();
                vc.check20();

                vc.check21(21);
                vc.check22(22);
                vc.check23((float)23.0);
                vc.check24(24.0);
                vc.check25((short)25);
                vc.check26((char)26);
                vc.check27((byte)27);
                vc.check28(true);

                Object obj = (Object)new Test();
                vc.check29((Object)obj);
                vc.check30(STRING_30);

                vc.check31(Integer.valueOf(31));
                vc.check32(Long.valueOf((long)32));
                vc.check33(Float.valueOf((float)33.0));
                vc.check34(Double.valueOf((double)34.0));
                vc.check35(Short.valueOf((short)35));
                vc.check36(new Character((char)36));
                vc.check37(new Byte((byte)37));
                vc.check38(Boolean.valueOf(true));

                SerializableObject slobj = new SerializableObject();
                vc.check39(slobj);

                vc.check41();
                byte[] a = new byte[16];
                for (int i = 0; i < a.length; i++) {
                    a[i] = (byte)i;
                }
                vc.check42(a);
                vc.check43();
                return;
            }
            if (ag[0].compareTo(TEST_1) == 0) {
                vc.check1();
                return;
            }
            if (ag[0].compareTo(TEST_2) == 0) {
                vc.check2();
                return;
            }
            if (ag[0].compareTo(TEST_3) == 0) {
                vc.check3();
                return;
            }
            if (ag[0].compareTo(TEST_4) == 0) {
                vc.check4();
                return;
            }
            if (ag[0].compareTo(TEST_5) == 0) {
                vc.check5();
                return;
            }
            if (ag[0].compareTo(TEST_6) == 0) {
                vc.check6();
                return;
            }
            if (ag[0].compareTo(TEST_7) == 0) {
                vc.check7();
                return;
            }
            if (ag[0].compareTo(TEST_8) == 0) {
                vc.check8();
                return;
            }
            if (ag[0].compareTo(TEST_9) == 0) {
                vc.check9();
                return;
            }
            if (ag[0].compareTo(TEST_10) == 0) {
                vc.check10();
                return;
            }
            if (ag[0].compareTo(TEST_11) == 0) {
                vc.check11();
                return;
            }
            if (ag[0].compareTo(TEST_12) == 0) {
                vc.check12();
                return;
            }
            if (ag[0].compareTo(TEST_13) == 0) {
                vc.check13();
                return;
            }
            if (ag[0].compareTo(TEST_14) == 0) {
                vc.check14();
                return;
            }
            if (ag[0].compareTo(TEST_15) == 0) {
                vc.check15();
                return;
            }
            if (ag[0].compareTo(TEST_16) == 0) {
                vc.check16();
                return;
            }
            if (ag[0].compareTo(TEST_17) == 0) {
                vc.check17();
                return;
            }
            if (ag[0].compareTo(TEST_18) == 0) {
                vc.check18();
                return;
            }
            if (ag[0].compareTo(TEST_19) == 0) {
                vc.check19();
                return;
            }
            if (ag[0].compareTo(TEST_20) == 0) {
                vc.check20();
                return;
            }
            if (ag[0].compareTo(TEST_21) == 0) {
                vc.check21(21);
                return;
            }
            if (ag[0].compareTo(TEST_22) == 0) {
                vc.check22(22);
                return;
            }
            if (ag[0].compareTo(TEST_23) == 0) {
                vc.check23((float)23.0);
                return;
            }
            if (ag[0].compareTo(TEST_24) == 0) {
                vc.check24(24.0);
                return;
            }
            if (ag[0].compareTo(TEST_25) == 0) {
                vc.check25((short)25);
                return;
            }
            if (ag[0].compareTo(TEST_26) == 0) {
                vc.check26((char)26);
                return;
            }
            if (ag[0].compareTo(TEST_27) == 0) {
                vc.check27((byte)27);
                return;
            }
            if (ag[0].compareTo(TEST_28) == 0) {
                vc.check28(true);
                return;
            }
            if (ag[0].compareTo(TEST_29) == 0) {
                Object obj = (Object)new Test();
                vc.check29((Object)obj);
                return;
            }
            if (ag[0].compareTo(TEST_30) == 0) {
                vc.check30(STRING_30);
                return;
            }
            if (ag[0].compareTo(TEST_31) == 0) {
                vc.check31(Integer.valueOf(31));
                return;
            }
            if (ag[0].compareTo(TEST_32) == 0) {
                vc.check32(Long.valueOf((long)32));
                return;
            }
            if (ag[0].compareTo(TEST_33) == 0) {
                vc.check33(Float.valueOf((float)33.0));
                return;
            }
            if (ag[0].compareTo(TEST_34) == 0) {
                vc.check34(Double.valueOf((double)34.0));
                return;
            }
            if (ag[0].compareTo(TEST_35) == 0) {
                vc.check35(Short.valueOf((short)35));
                return;
            }
            if (ag[0].compareTo(TEST_36) == 0) {
                vc.check36(new Character((char)36));
                return;
            }
            if (ag[0].compareTo(TEST_37) == 0) {
                vc.check37(new Byte((byte)37));
                return;
            }
            if (ag[0].compareTo(TEST_38) == 0) {
                vc.check38(Boolean.valueOf(true));
                return;
            }
            if (ag[0].compareTo(TEST_39) == 0) {
                SerializableObject slobj = new SerializableObject();
                vc.check39(slobj);
                return;
            }
            if (ag[0].compareTo(TEST_40) == 0) {
                SerializableTest tlobj = new SerializableTest();
                vc.check40(tlobj);
                return;
            }
            if (ag[0].compareTo(TEST_41) == 0) {
                vc.check41();
                return;
            }
            if (ag[0].compareTo(TEST_42) == 0) {
                byte[] a = new byte[16];
                for (int i = 0; i < a.length; i++) {
                    a[i] = (byte)i;
                }
                vc.check42(a);
                return;
            }
            if (ag[0].compareTo(TEST_43) == 0) {
                vc.check43();
                return;
            }
        }
    }
}
